PROGRAM recalibration
! declaration of variables
IMPLICIT NONE
! basic constants
double precision :: PI,light,H0,q0,veryhugenumber
! loop and counting integers as well as some init parameters
integer :: io_err,n,i,ii,iii,ee,maxloop,galactive,weight_switch,Kcor_switch,gbandK,fingersofgod,colourdata
integer :: highest,second,lowest,itercount,n_simplexstart,n_simplex_dim,nsd1,selectmodel,sigmaclip,autosplit
double precision :: zmin,zmax,deltaz,helpflip,gQ,dist_help,split1,split2,omega_m,omega_lambda
integer, dimension (1:3) :: intz
! arrays for binned data
integer, dimension(0:50) :: zbin_numbers
integer, dimension(0:70) :: logR0_bin_g,logR0_bin_r,logR0_bin_i,logR0_bin_z
integer, dimension(0:60) :: logI0_bin_g,logI0_bin_r,logI0_bin_i,logI0_bin_z
integer, dimension(0:60) :: logsigma0_bin_g,logsigma0_bin_r,logsigma0_bin_i,logsigma0_bin_z
integer, dimension(0:60) :: r_cor_bin_g,r_cor_bin_r,r_cor_bin_i,r_cor_bin_z
integer, dimension(0:50) :: sigma_cor_bin_g,sigma_cor_bin_r,sigma_cor_bin_i,sigma_cor_bin_z
integer, dimension(0:75) :: R0_bin_g,R0_bin_r,R0_bin_i,R0_bin_z
integer, dimension(0:100) :: I0_bin_g,I0_bin_r,I0_bin_i,I0_bin_z
integer, dimension(0:80) :: mag_bin_g,mag_bin_r,mag_bin_i,mag_bin_z
integer, dimension(0:50) :: magabs_bin_g,magabs_bin_r,magabs_bin_i,magabs_bin_z
integer, dimension(0:50,0:15) :: magabsz_bin_g,magabsz_bin_r,magabsz_bin_i,magabsz_bin_z
integer, dimension(0:50,1:3) :: magabsz_largebin_g,magabsz_largebin_r,magabsz_largebin_i
integer, dimension(0:50,1:3) :: magabsz_largebin_z
integer, dimension(0:50) :: mag_app_bin_g,mag_app_bin_r,mag_app_bin_i,mag_app_bin_z
double precision, dimension(0:50) :: volbin_numbers,overdense,erf1y,ev_z,logDL,yh
double precision, dimension(0:20) :: ck_inverf
double precision, dimension(0:50,0:3) :: magabsnorm_g,magabsnorm_r,magabsnorm_i,magabsnorm_z
! arrays for SDSS raw data
integer(kind=8), allocatable :: objid(:)
double precision, allocatable :: gb(:),gl(:),mapsize(:),ra(:),dec(:)
double precision, allocatable :: z(:),zErr(:),veldisp(:),veldisperr(:),z_cluster(:)
double precision, allocatable :: ba_g(:),ba_r(:),ba_i(:),ba_z(:)
double precision, allocatable :: baErr_g(:),baErr_r(:),baErr_i(:),baErr_z(:)
double precision, allocatable :: deVRad_g(:),deVRad_r(:),deVRad_i(:),deVRad_z(:)
double precision, allocatable :: deVRadErr_g(:),deVRadErr_r(:),deVRadErr_i(:),deVRadErr_z(:)
double precision, allocatable :: deVMag_g(:),deVMag_r(:),deVMag_i(:),deVMag_z(:)
double precision, allocatable :: deVMagErr_g(:),deVMagErr_r(:),deVMagErr_i(:),deVMagErr_z(:)
double precision, allocatable :: cModelMag_g(:),cModelMag_r(:),cModelMag_i(:),cModelMag_z(:)
double precision, allocatable :: cModelMagErr_g(:),cModelMagErr_r(:),cModelMagErr_i(:),cModelMagErr_z(:)
double precision, allocatable :: extinction_g(:),extinction_r(:),extinction_i(:),extinction_z(:)
double precision, allocatable :: distanceErr(:),z_corErr(:)
double precision, allocatable :: MagErr_g(:),MagErr_r(:),MagErr_i(:),MagErr_z(:)
double precision, allocatable :: KErr_g(:),KErr_r(:),KErr_i(:),KErr_z(:)
double precision, allocatable :: r_corErr_g(:),r_corErr_r(:),r_corErr_i(:),r_corErr_z(:)
double precision, allocatable :: sigma_corErr_g(:),sigma_corErr_r(:),sigma_corErr_i(:),sigma_corErr_z(:)
double precision, allocatable :: muErr_g(:),muErr_r(:),muErr_i(:),muErr_z(:)
double precision, allocatable :: alphaErr_g(:),alphaErr_r(:),alphaErr_i(:),alphaErr_z(:)
double precision, allocatable :: R0Err_g(:),R0Err_r(:),R0Err_i(:),R0Err_z(:)
double precision, allocatable :: magabsErr_g(:),magabsErr_r(:),magabsErr_i(:),magabsErr_z(:)
double precision, allocatable :: magappErr_g(:),magappErr_r(:),magappErr_i(:),magappErr_z(:)
double precision, allocatable :: RadErr_g(:),RadErr_r(:),RadErr_i(:),RadErr_z(:)
! arrays for derived parameters
double precision, allocatable :: Mag_g(:),Mag_r(:),Mag_i(:),Mag_z(:)
double precision, allocatable :: distance(:),z_cor(:),logdistlum(:)
double precision, allocatable :: K_g(:),K_r(:),K_i(:),K_z(:)
double precision, allocatable :: r_cor_g(:),r_cor_r(:),r_cor_i(:),r_cor_z(:)
double precision, allocatable :: sigma_cor_g(:),sigma_cor_r(:),sigma_cor_i(:),sigma_cor_z(:)
double precision, allocatable :: logI0_g(:),logI0_r(:),logI0_i(:),logI0_z(:)
double precision, allocatable :: I0_g(:),I0_r(:),I0_i(:),I0_z(:)
double precision, allocatable :: alpha_g(:),alpha_r(:),alpha_i(:),alpha_z(:)
double precision, allocatable :: R0_g(:),R0_r(:),R0_i(:),R0_z(:)
double precision, allocatable :: logR0_g(:),logR0_r(:),logR0_i(:),logR0_z(:)
double precision, allocatable :: logsigma_g(:),logsigma_r(:),logsigma_i(:),logsigma_z(:)
double precision, allocatable :: err_g(:),err_r(:),err_i(:),err_z(:)
double precision, allocatable :: otherside_g(:),otherside_r(:),otherside_i(:),otherside_z(:)
double precision, allocatable :: dadR(:),dbdR(:),dcdR(:)
double precision, allocatable :: deviation_g(:),deviation_r(:),deviation_i(:),deviation_z(:)
double precision, allocatable :: Mag_app_g(:),Mag_app_r(:),Mag_app_i(:),Mag_app_z(:)
! arrays for statistical weights
double precision, allocatable :: weightzcor(:),weight_g(:),weight_r(:),weight_i(:),weight_z(:)
double precision, allocatable :: magabs_g(:),magabs_r(:),magabs_i(:),magabs_z(:)
double precision, allocatable :: wrms_g(:),wrms_r(:),wrms_i(:),wrms_z(:)
double precision, allocatable :: weightKg(:),weightKr(:),weightKi(:),weightKz(:)
! booleans for selection
logical, allocatable :: active(:),subsample(:),partpresel(:),actold(:)
logical :: continueloop
! variables for least square fitting
double precision, dimension(1:3,1:3) :: Amatrix_g,Bmatrix1_g,Amatrix_r,Bmatrix1_r,Amatrix_i,Bmatrix1_i,&
Amatrix_z,Bmatrix1_z,Bmatrix2_g,Bmatrix3_g,Bmatrix2_r,Bmatrix3_r,Bmatrix2_i,Bmatrix3_i,&
Bmatrix2_z,Bmatrix3_z
double precision, dimension(1:3) :: Yvector_g,Yvector_r,Yvector_i,Yvector_z
double precision :: z_limit,V_limit,D_limit,binhelp2
double precision :: detA_g,detA_r,detA_i,detA_z,detB1_g,detB1_r,detB1_i,detB1_z
double precision :: detB2_g,detB2_r,detB2_i,detB2_z,detB3_g,detB3_r,detB3_i,detB3_z
double precision :: a_g,b_g,c_g,a_r,b_r,c_r,a_i,b_i,c_i,a_z,b_z,c_z,rms_u,rms_g,rms_r,rms_i,rms_z
double precision :: delta_a_g,delta_b_g,delta_c_g,delta_a_r,delta_b_r,delta_c_r
double precision :: delta_a_i,delta_b_i,delta_c_i,delta_a_z,delta_b_z,delta_c_z
double precision :: c_err_u,a_err_g,b_err_g,c_err_g,a_err_r,b_err_r,c_err_r
double precision :: a_err_i,b_err_i,c_err_i,a_err_z,b_err_z,c_err_z,binhelp
! other stuff and variables for the error analysis
double precision :: r_fiber,z_gal_x,z_gal_y,z_gal_z
double precision :: v_cmb,l_cmb,b_cmb,z_cmb,gal_b,gal_l
double precision :: z_cmb_x,z_cmb_y,z_cmb_z
double precision :: zbar,dbar_g,dbar_r,dbar_i,dbar_z
double precision :: devfitk_g,devfitk_r,devfitk_i,devfitk_z,devfitd_u,devfitd_g,devfitd_r,devfitd_i,devfitd_z
double precision :: devRMS_g,devRMS_r,devRMS_i,devRMS_z,divisor
!some more init parameters
double precision :: maxmag_g,minmag_g,maxmag_r,minmag_r,maxmag_i,minmag_i,maxmag_z,minmag_z
!K correction coefficients
double precision, dimension(0:5,0:3) :: K_coeff_r,K_coeff_i,K_coeff_z
double precision, dimension(0:7,0:3) ::K_coeff_g
! sample limiting variables
integer :: z_steps,n1percent,hcount,act_radii_weights
integer, allocatable :: interval_counter(:)
double precision, allocatable :: helplist_g(:),helplist_r(:),helplist_i(:),helplist_z(:)
double precision, allocatable :: Mag_max_g(:),Mag_min_g(:),R_max_g(:),R_min_g(:),sigma_max_g(:),sigma_min_g(:)
double precision, allocatable :: Mag_max_r(:),Mag_min_r(:),R_max_r(:),R_min_r(:),sigma_max_r(:),sigma_min_r(:)
double precision, allocatable :: Mag_max_i(:),Mag_min_i(:),R_max_i(:),R_min_i(:),sigma_max_i(:),sigma_min_i(:)
double precision, allocatable :: Mag_max_z(:),Mag_min_z(:),R_max_z(:),R_min_z(:),sigma_max_z(:),sigma_min_z(:)
double precision, allocatable :: I_max_g(:),I_min_g(:),I_max_r(:),I_min_r(:),I_max_i(:),&
I_min_i(:),I_max_z(:),I_min_z(:)
! variables for simplex fitting
double precision, allocatable :: paralist(:,:),x_c(:),x_simplex(:,:),x_l(:),ax_c(:)
double precision, allocatable :: x_h(:),x_alpha(:),x_beta(:),x_gamma(:),f_sum(:),x_oldlow(:)
double precision :: f_h,f_l,f_s,simplex_alpha,simplex_beta,simplex_gamma,simplex_delta,upterm
double precision :: f_alpha,f_beta,f_gamma,f_simplex_help,com_change
double precision, allocatable :: mMag(:),msigma(:),mQ(:),sveldisp(:),ssigma(:),rrad(:),rsigma(:),isb(:),isigma(:)
double precision, allocatable :: lowfunc(:)
double precision, allocatable :: rrm(:),rvm(:),rrv(:),rri(:),rvi(:)
double precision, allocatable :: volume_weight_u(:),volume_weight_g(:),volume_weight_r(:),volume_weight_i(:),&
volume_weight_z(:)
double precision :: V_sum_g,V_sum_r,V_sum_i,V_sum_z,help_sum2_g,help_sum2_r,help_sum2_i
double precision :: dist_k_u,dist_k_g,dist_k_r,dist_k_i,dist_k_z,help_sum2_z
double precision :: dist_d_u,dist_d_g,dist_d_r,dist_d_i,dist_d_z
double precision, allocatable :: stat_err_g(:),stat_err_r(:),stat_err_i(:),stat_err_z(:)
double precision, allocatable :: stat_median_help(:)
double precision :: Vol1,Vol2,solve_t1,solve_t2,av_mag_abs
double precision, allocatable :: petroRad_g(:), petroRad_r(:), petroRad_i(:), petroRad_z(:)
double precision, allocatable :: petroRadErr_g(:), petroRadErr_r(:), petroRadErr_i(:), petroRadErr_z(:)
double precision, allocatable :: petroMag_g(:), petroMag_r(:), petroMag_i(:), petroMag_z(:)
double precision, allocatable :: petroMagErr_g(:), petroMagErr_r(:), petroMagErr_i(:), petroMagErr_z(:)
double precision, allocatable :: Rad_g(:),Rad_r(:),Rad_i(:),Rad_z(:)
double precision, allocatable :: ModelMag_g(:),ModelMag_r(:),ModelMag_i(:),ModelMag_z(:)
double precision, allocatable :: galdense_run(:),gsigma_run(:),delta_m_run(:),gQ_run(:)
double precision :: galdense,gsigma,delta_m,D_help,bestmin
LOGICAL :: file_exists
double precision ::old_gsigma,old_galdense,old_delta_m,old_mQ,old_bestmin,weight_sum2_u,weight_sum2_g
double precision :: t1,t2,t3,weight_sum2_r,weight_sum2_i,weight_sum2_z
double precision :: mlimit_u,mlimit_g,mlimit_r,mlimit_i,mlimit_z
double precision, dimension(1:5) :: av_r_cor,sigma_r_cor,av_sigma_cor,sigma_sigma_cor,av_mag_app,sigma_mag_app
double precision, dimension(1:5) :: av_logR0,sigma_logR0,av_logsigma,sigma_logsigma,av_sb,sigma_sb
double precision, allocatable :: fp_dist_g(:),fp_dist_r(:),fp_dist_i(:),fp_dist_z(:),fp_dist_av(:)
double precision, allocatable :: fp_cdist_g(:),fp_cdist_r(:),fp_cdist_i(:),fp_cdist_z(:)
double precision, allocatable :: fp_ldist_g(:),fp_ldist_r(:),fp_ldist_i(:),fp_ldist_z(:)
double precision, allocatable :: vpec_g(:),vpec_r(:),vpec_i(:),vpec_z(:)
double precision :: fp_dist_err_g,fp_dist_err_r,fp_dist_err_i,fp_dist_err_z,fp_dist_err_av
integer, dimension(0:500,0:500) :: fp_map
double precision, dimension(0:500,0:500) :: weight_map
integer:: help_x,help_y,n_threesigma
double precision :: help_x2,help_y2,help_colour,help_c_max,help_c_min,help_c_av
double precision :: mag_evolution_u,mag_evolution_g,mag_evolution_r,mag_evolution_i,mag_evolution_z
double precision :: R0_max_g,R0_max_r,R0_max_i,R0_max_z
double precision :: R0_min_g,R0_min_r,R0_min_i,R0_min_z
integer, dimension(0:500,0:400) :: bias_map
double precision, dimension(1:3,1:3) :: colour_matrix,help_matrix_1,help_matrix_2,help_matrix_3
double precision, dimension(1:3) :: colour_vector
double precision :: det_cMatrix,det_helpMatrix1,det_helpMatrix2,det_helpMatrix3
double precision :: colour_coeff1,colour_coeff2,colour_coeff3,colour_rms,colour_dev,Vmin
double precision :: av_dev_g,av_dev_r,av_dev_i,av_dev_z,sxx,syy,sxy
double precision :: r_iz,r_rz,r_gz,r_uz,r_ri,r_gi,r_ui,r_gr,r_ur,r_ug
double precision :: dist_dsat_g,dist_dsat_r,dist_dsat_i,dist_dsat_z,solve_t3
double precision :: Dmin,Vminsat
double precision :: rang_min_g,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,rang_dco,otherlimit

double precision :: z_lower,z_middle,z_upper,D_lower,D_middle,D_upper
double precision, allocatable :: z_fp_g(:),z_fp_r(:),z_fp_i(:),z_fp_z(:)


OPEN(30,file='output/protocol.txt')

! define constants
PI=ACOS(-1.D0) !pi
light=299792.458D0 !speed of light

veryhugenumber=huge(0.D0)


WRITE(*,*) '-----program started-----'
WRITE(30,*) '-----program started-----'
CALL SYSTEM_CLOCK(hcount)
hcount=hcount-INT(hcount/100000)*100000
call srand(hcount) 


act_radii_weights=1


! read input file
OPEN(53,file='input/input.txt')
READ(53,*)
READ(53,*) weight_switch
READ(53,*)
READ(53,*) zmin,zmax
READ(53,*)
READ(53,*) gbandK
READ(53,*)
READ(53,*) fingersofgod
READ(53,*)
READ(53,*)
READ(53,*) maxmag_g,minmag_g
READ(53,*)
READ(53,*) maxmag_r,minmag_r
READ(53,*)
READ(53,*) maxmag_i,minmag_i
READ(53,*)
READ(53,*) maxmag_z,minmag_z
READ(53,*)
READ(53,*) n_simplexstart
READ(53,*)
READ(53,*) selectmodel
READ(53,*) 
READ(53,*) sigmaclip
READ(53,*) 
READ(53,*) mag_evolution_g,mag_evolution_r,mag_evolution_i,mag_evolution_z
READ(53,*) 
READ(53,*) R0_min_g,R0_min_r,R0_min_i,R0_min_z
READ(53,*) 
READ(53,*) R0_max_g,R0_max_r,R0_max_i,R0_max_z
READ(53,*) 
READ(53,*) autosplit
READ(53,*) split1,split2
READ(53,*) 
READ(53,*) colourdata
READ(53,*) 
READ(53,*) H0,omega_m,omega_lambda
 CLOSE(53)

q0=omega_m/2.D0-omega_lambda !decaleration parameter 


z_limit=zmin
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance
Vmin=D_limit**3
! Vmin=0.D0

IF (fingersofgod==0) THEN

! get length of file
OPEN(50,file='input/all_ellipticals.txt')
io_err=0
n=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n=n+1
END DO
 CLOSE(50)
n=n-2

ELSE

! get length of file
OPEN(50,file='input/subset.txt')
io_err=0
n=0
DO WHILE (io_err==0) 
READ(50,*,iostat=io_err) 
n=n+1
END DO
 CLOSE(50)
n=n-1



END IF


! allocate arrays
allocate(objid(1:n))
allocate(gb(1:n))
allocate(gl(1:n))
allocate(z(1:n))
allocate(zErr(1:n))
allocate(veldisp(1:n))
allocate(veldisperr(1:n))

allocate(ba_g(1:n))
allocate(ba_r(1:n))
allocate(ba_i(1:n))
allocate(ba_z(1:n))

allocate(baErr_g(1:n))
allocate(baErr_r(1:n))
allocate(baErr_i(1:n))
allocate(baErr_z(1:n))

allocate(deVRad_g(1:n))
allocate(deVRad_r(1:n))
allocate(deVRad_i(1:n))
allocate(deVRad_z(1:n))

allocate(deVRadErr_g(1:n))
allocate(deVRadErr_r(1:n))
allocate(deVRadErr_i(1:n))
allocate(deVRadErr_z(1:n))

allocate(deVMag_g(1:n))
allocate(deVMag_r(1:n))
allocate(deVMag_i(1:n))
allocate(deVMag_z(1:n))

allocate(deVMagErr_g(1:n))
allocate(deVMagErr_r(1:n))
allocate(deVMagErr_i(1:n))
allocate(deVMagErr_z(1:n))

allocate(cModelMag_g(1:n))
allocate(cModelMag_r(1:n))
allocate(cModelMag_i(1:n))
allocate(cModelMag_z(1:n))

allocate(cModelMagErr_g(1:n))
allocate(cModelMagErr_r(1:n))
allocate(cModelMagErr_i(1:n))
allocate(cModelMagErr_z(1:n))

allocate(extinction_g(1:n))
allocate(extinction_r(1:n))
allocate(extinction_i(1:n))
allocate(extinction_z(1:n))

allocate(petroRad_g(1:n))
allocate(petroRad_r(1:n))
allocate(petroRad_i(1:n))
allocate(petroRad_z(1:n))

allocate(petroRadErr_g(1:n))
allocate(petroRadErr_r(1:n))
allocate(petroRadErr_i(1:n))
allocate(petroRadErr_z(1:n))

allocate(petroMag_g(1:n))
allocate(petroMag_r(1:n))
allocate(petroMag_i(1:n))
allocate(petroMag_z(1:n))

allocate(petroMagErr_g(1:n))
allocate(petroMagErr_r(1:n))
allocate(petroMagErr_i(1:n))
allocate(petroMagErr_z(1:n))

allocate(Rad_g(1:n))
allocate(Rad_r(1:n))
allocate(Rad_i(1:n))
allocate(Rad_z(1:n))

allocate(ModelMag_g(1:n))
allocate(ModelMag_r(1:n))
allocate(ModelMag_i(1:n))
allocate(ModelMag_z(1:n))
allocate(z_cluster(1:n))

allocate(MagErr_g(1:n))
allocate(MagErr_r(1:n))
allocate(MagErr_i(1:n))
allocate(MagErr_z(1:n))

allocate(RadErr_g(1:n))
allocate(RadErr_r(1:n))
allocate(RadErr_i(1:n))
allocate(RadErr_z(1:n))

allocate(ra(1:n))
allocate(dec(1:n))


IF (fingersofgod==0) THEN

! read file
OPEN(50,file='input/all_ellipticals.txt')
READ(50,*) 
DO i=1,n 
READ(50,*) objid(i),ra(i),dec(i),gb(i),gl(i),z(i),zErr(i),veldisp(i),veldisperr(i),&
ba_g(i),ba_r(i),ba_i(i),ba_z(i),&
baErr_g(i),baErr_r(i),baErr_i(i),baErr_z(i),&
deVRad_g(i),deVRad_r(i),deVRad_i(i),deVRad_z(i),&
deVRadErr_g(i),deVRadErr_r(i),deVRadErr_i(i),deVRadErr_z(i),&
deVMag_g(i),deVMag_r(i),deVMag_i(i),deVMag_z(i),&
deVMagErr_g(i),deVMagErr_r(i),deVMagErr_i(i),deVMagErr_z(i),&
extinction_g(i),extinction_r(i),extinction_i(i),extinction_z(i),&
 cModelMag_g(i),cModelMag_r(i),cModelMag_i(i),cModelMag_z(i),&
 cModelMagErr_g(i),cModelMagErr_r(i),cModelMagErr_i(i),cModelMagErr_z(i),&
 petroRad_g(i), petroRad_r(i), petroRad_i(i), petroRad_z(i),&
petroRadErr_g(i), petroRadErr_r(i), petroRadErr_i(i), petroRadErr_z(i),&
 petroMag_g(i), petroMag_r(i), petroMag_i(i), petroMag_z(i),&
petroMagErr_g(i), petroMagErr_r(i), petroMagErr_i(i), petroMagErr_z(i)
END DO
 CLOSE(50)

ELSE


WRITE(*,*) 'ERROR: feature removed'

END IF



WRITE(*,*) 'read in data for ',n,' galaxies'
WRITE(30,*) 'read in data for ',n,' galaxies'

!set parameters
r_fiber=1.5D0


!prepare for calculation of correction for CMB motion
! values for the motion of the sun relativ to the CMB
v_cmb=369.D0
l_cmb=263.99D0
b_cmb=48.26D0

! calculate sun's motion in z space relativ to the CMB
z_cmb=v_cmb/light
gal_b=b_cmb*PI/180.D0
gal_l=l_cmb*PI/180.D0
z_cmb_x=z_cmb*COS(gal_b)*COS(gal_l)
z_cmb_y=z_cmb*COS(gal_b)*SIN(gal_l)
z_cmb_z=z_cmb*SIN(gal_b)


maxloop=0
IF (sigmaclip>0) THEN
maxloop=10
END IF


IF (selectmodel==1) THEN
DO i=1,n


MagErr_g(i)=cModelMagErr_g(i)
MagErr_r(i)=cModelMagErr_r(i)
MagErr_i(i)=cModelMagErr_i(i)
MagErr_z(i)=cModelMagErr_z(i)

RadErr_g(i)=deVRadErr_g(i)
RadErr_r(i)=deVRadErr_r(i)
RadErr_i(i)=deVRadErr_i(i)
RadErr_z(i)=deVRadErr_z(i)


Rad_g(i)=deVRad_g(i)
Rad_r(i)=deVRad_r(i)
Rad_i(i)=deVRad_i(i)
Rad_z(i)=deVRad_z(i)

ModelMag_g(i)=cModelMag_g(i)
ModelMag_r(i)=cModelMag_r(i)
ModelMag_i(i)=cModelMag_i(i)
ModelMag_z(i)=cModelMag_z(i)
END DO
END IF


IF (selectmodel==2) THEN
DO i=1,n

MagErr_g(i)=deVMagErr_g(i)
MagErr_r(i)=deVMagErr_r(i)
MagErr_i(i)=deVMagErr_i(i)
MagErr_z(i)=deVMagErr_z(i)

RadErr_g(i)=deVRadErr_g(i)
RadErr_r(i)=deVRadErr_r(i)
RadErr_i(i)=deVRadErr_i(i)
RadErr_z(i)=deVRadErr_z(i)

Rad_g(i)=deVRad_g(i)
Rad_r(i)=deVRad_r(i)
Rad_i(i)=deVRad_i(i)
Rad_z(i)=deVRad_z(i)

ModelMag_g(i)=deVMag_g(i)
ModelMag_r(i)=deVMag_r(i)
ModelMag_i(i)=deVMag_i(i)
ModelMag_z(i)=deVMag_z(i)
END DO
END IF


IF (selectmodel==3) THEN
DO i=1,n



MagErr_g(i)=petroMagErr_g(i)
MagErr_r(i)=petroMagErr_r(i)
MagErr_i(i)=petroMagErr_i(i)
MagErr_z(i)=petroMagErr_z(i)

RadErr_g(i)=petroRadErr_g(i)
RadErr_r(i)=petroRadErr_r(i)
RadErr_i(i)=petroRadErr_i(i)
RadErr_z(i)=petroRadErr_z(i)


Rad_g(i)=petroRad_g(i)
Rad_r(i)=petroRad_r(i)
Rad_i(i)=petroRad_i(i)
Rad_z(i)=petroRad_z(i)

ModelMag_g(i)=petroMag_g(i)
ModelMag_r(i)=petroMag_r(i)
ModelMag_i(i)=petroMag_i(i)
ModelMag_z(i)=petroMag_z(i)

END DO
END IF





deltaz=zmax-zmin
! z_steps=NINT(deltaz*100.D0)




divisor=(SQRT(1.D0+2.D0*q0*zmax)+1.D0+q0*zmax)
dist_help=light/H0*zmax*(1.D0+((zmax*(1.D0-q0))/divisor))*1000.D0
dist_help=LOG10(dist_help*1000.D0)

divisor=(SQRT(1.D0+2.D0*q0*zmin)+1.D0+q0*zmin)
helpflip=light/H0*zmin*(1.D0+((zmin*(1.D0-q0))/divisor))*1000.D0
helpflip=LOG10(helpflip*1000.D0)

OPEN(55,file='output/maxz.txt')
WRITE(55,*) 'maxz=',zmax
WRITE(55,*) 'maxdist=',dist_help
WRITE(55,*) 'mindist=',helpflip
 CLOSE(55)



z_steps=20
! some more allocations


allocate(interval_counter(1:z_steps))


allocate(Mag_max_g(1:z_steps))
allocate(Mag_min_g(1:z_steps))
allocate(R_max_g(1:z_steps))
allocate(R_min_g(1:z_steps))
allocate(sigma_max_g(1:z_steps))
allocate(sigma_min_g(1:z_steps))
allocate(I_max_g(1:z_steps))
allocate(I_min_g(1:z_steps))

allocate(Mag_max_r(1:z_steps))
allocate(Mag_min_r(1:z_steps))
allocate(R_max_r(1:z_steps))
allocate(R_min_r(1:z_steps))
allocate(sigma_max_r(1:z_steps))
allocate(sigma_min_r(1:z_steps))
allocate(I_max_r(1:z_steps))
allocate(I_min_r(1:z_steps))

allocate(Mag_max_i(1:z_steps))
allocate(Mag_min_i(1:z_steps))
allocate(R_max_i(1:z_steps))
allocate(R_min_i(1:z_steps))
allocate(sigma_max_i(1:z_steps))
allocate(sigma_min_i(1:z_steps))
allocate(I_max_i(1:z_steps))
allocate(I_min_i(1:z_steps))

allocate(Mag_max_z(1:z_steps))
allocate(Mag_min_z(1:z_steps))
allocate(R_max_z(1:z_steps))
allocate(R_min_z(1:z_steps))
allocate(sigma_max_z(1:z_steps))
allocate(sigma_min_z(1:z_steps))
allocate(I_max_z(1:z_steps))
allocate(I_min_z(1:z_steps))


allocate(helplist_g(1:n))
allocate(helplist_r(1:n))
allocate(helplist_i(1:n))
allocate(helplist_z(1:n))

allocate(mMag(1:5))
allocate(msigma(1:5))
allocate(mQ(1:5))
allocate(sveldisp(1:5))
allocate(ssigma(1:5))
allocate(rrad(1:5))
allocate(rsigma(1:5))
allocate(isb(1:5))
allocate(isigma(1:5))
allocate(rrm(1:5))
allocate(rvm(1:5))
allocate(rrv(1:5))
allocate(rri(1:5))
allocate(rvi(1:5))

allocate(stat_err_g(1:n))
allocate(stat_err_r(1:n))
allocate(stat_err_i(1:n))
allocate(stat_err_z(1:n))
allocate(stat_median_help(1:n))

allocate(mapsize(1:n))
allocate(partpresel(1:n))

allocate(logdistlum(1:n))


allocate(fp_dist_g(1:n))
allocate(fp_dist_r(1:n))
allocate(fp_dist_i(1:n))
allocate(fp_dist_z(1:n))
allocate(fp_dist_av(1:n))

allocate(fp_cdist_g(1:n))
allocate(fp_cdist_r(1:n))
allocate(fp_cdist_i(1:n))
allocate(fp_cdist_z(1:n))

allocate(fp_ldist_g(1:n))
allocate(fp_ldist_r(1:n))
allocate(fp_ldist_i(1:n))
allocate(fp_ldist_z(1:n))

allocate(vpec_g(1:n))
allocate(vpec_r(1:n))
allocate(vpec_i(1:n))
allocate(vpec_z(1:n))


allocate(actold(1:n))


!get parameters for K correction  

OPEN(52,file='input/K_correction_g.txt')
DO i=0,gbandK
READ(52,*) K_coeff_g(i,0:3)
END DO
 CLOSE(52)
OPEN(52,file='input/K_correction_r.txt')
DO i=0,5
READ(52,*) K_coeff_r(i,0:3)
END DO
 CLOSE(52)
OPEN(52,file='input/K_correction_i.txt')
DO i=0,5
READ(52,*) K_coeff_i(i,0:3)
END DO
 CLOSE(52)
OPEN(52,file='input/K_correction_z.txt')
DO i=0,5
READ(52,*) K_coeff_z(i,0:3)
END DO
 CLOSE(52)


! allocate arrays



allocate(distanceErr(1:n))


allocate(KErr_g(1:n))
allocate(KErr_r(1:n))
allocate(KErr_i(1:n))
allocate(KErr_z(1:n))

allocate(r_corErr_g(1:n))
allocate(r_corErr_r(1:n))
allocate(r_corErr_i(1:n))
allocate(r_corErr_z(1:n))


allocate(sigma_corErr_g(1:n))
allocate(sigma_corErr_r(1:n))
allocate(sigma_corErr_i(1:n))
allocate(sigma_corErr_z(1:n))


allocate(muErr_g(1:n))
allocate(muErr_r(1:n))
allocate(muErr_i(1:n))
allocate(muErr_z(1:n))


allocate(z_corErr(1:n))

allocate(alphaErr_g(1:n))
allocate(alphaErr_r(1:n))
allocate(alphaErr_i(1:n))
allocate(alphaErr_z(1:n))


allocate(R0Err_g(1:n))
allocate(R0Err_r(1:n))
allocate(R0Err_i(1:n))
allocate(R0Err_z(1:n))

allocate(magabsErr_g(1:n))
allocate(magabsErr_r(1:n))
allocate(magabsErr_i(1:n))
allocate(magabsErr_z(1:n))

allocate(magappErr_g(1:n))
allocate(magappErr_r(1:n))
allocate(magappErr_i(1:n))
allocate(magappErr_z(1:n))


allocate(distance(1:n))

allocate(Mag_g(1:n))
allocate(Mag_r(1:n))
allocate(Mag_i(1:n))
allocate(Mag_z(1:n))

allocate(K_g(1:n))
allocate(K_r(1:n))
allocate(K_i(1:n))
allocate(K_z(1:n))

allocate(r_cor_g(1:n))
allocate(r_cor_r(1:n))
allocate(r_cor_i(1:n))
allocate(r_cor_z(1:n))


allocate(sigma_cor_g(1:n))
allocate(sigma_cor_r(1:n))
allocate(sigma_cor_i(1:n))
allocate(sigma_cor_z(1:n))


allocate(logI0_g(1:n))
allocate(logI0_r(1:n))
allocate(logI0_i(1:n))
allocate(logI0_z(1:n))


allocate(I0_g(1:n))
allocate(I0_r(1:n))
allocate(I0_i(1:n))
allocate(I0_z(1:n))

allocate(z_cor(1:n))

allocate(alpha_g(1:n))
allocate(alpha_r(1:n))
allocate(alpha_i(1:n))
allocate(alpha_z(1:n))


allocate(R0_g(1:n))
allocate(R0_r(1:n))
allocate(R0_i(1:n))
allocate(R0_z(1:n))


allocate(logR0_g(1:n))
allocate(logR0_r(1:n))
allocate(logR0_i(1:n))
allocate(logR0_z(1:n))

allocate(logsigma_g(1:n))
allocate(logsigma_r(1:n))
allocate(logsigma_i(1:n))
allocate(logsigma_z(1:n))


allocate(err_g(1:n))
allocate(err_r(1:n))
allocate(err_i(1:n))
allocate(err_z(1:n))

allocate(otherside_g(1:n))
allocate(otherside_r(1:n))
allocate(otherside_i(1:n))
allocate(otherside_z(1:n))
allocate(dadR(1:n))
allocate(dbdR(1:n))
allocate(dcdR(1:n))
allocate(active(1:n))

allocate(deviation_g(1:n))
allocate(deviation_r(1:n))
allocate(deviation_i(1:n))
allocate(deviation_z(1:n))

allocate(weightzcor(1:n))

allocate(weight_g(1:n))
allocate(weight_r(1:n))
allocate(weight_i(1:n))
allocate(weight_z(1:n))

allocate(wrms_g(1:n))
allocate(wrms_r(1:n))
allocate(wrms_i(1:n))
allocate(wrms_z(1:n))
allocate(subsample(1:n))

allocate(magabs_g(1:n))
allocate(magabs_r(1:n))
allocate(magabs_i(1:n))
allocate(magabs_z(1:n))


allocate(weightKg(1:n))
allocate(weightKr(1:n))
allocate(weightKi(1:n))
allocate(weightKz(1:n))

allocate(Mag_app_g(1:n))
allocate(Mag_app_r(1:n))
allocate(Mag_app_i(1:n))
allocate(Mag_app_z(1:n))

allocate(z_fp_g(1:n))
allocate(z_fp_r(1:n))
allocate(z_fp_i(1:n))
allocate(z_fp_z(1:n))
 
 
! of course, all data is fine at the beginningdeVMagErr_g
DO i=1,n
active(i)=.TRUE.
END DO


WRITE(*,*) 'initizialization done'
WRITE(30,*) 'initizialization done'




!correct for galactic extinction
DO i=1,n

Mag_g(i)=ModelMag_g(i)-extinction_g(i)
Mag_r(i)=ModelMag_r(i)-extinction_r(i)
Mag_i(i)=ModelMag_i(i)-extinction_i(i)
Mag_z(i)=ModelMag_z(i)-extinction_z(i)
END DO
WRITE(*,*) 'corrected for galactic extinction'
WRITE(30,*) 'corrected for galactic extinction'


!K-correction
DO i=1,n


K_g(i)=0.D0
DO ii=0,gbandK
DO iii=0,3
K_g(i)=K_g(i)+K_coeff_g(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_r(i))**iii)
END DO
END DO

K_r(i)=0.D0
DO ii=0,5
DO iii=0,3
K_r(i)=K_r(i)+K_coeff_r(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_r(i))**iii)
END DO
END DO

K_i(i)=0.D0
DO ii=0,5
DO iii=0,3
K_i(i)=K_i(i)+K_coeff_i(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_i(i))**iii)
END DO
END DO

K_z(i)=0.D0
DO ii=0,5
DO iii=0,3
K_z(i)=K_z(i)+K_coeff_z(ii,iii)*(z(i)**ii)*((Mag_g(i)-Mag_z(i))**iii)
END DO
END DO



KErr_g(i)=K_g(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(MagErr_g(i)**2+MagErr_r(i)**2)/(Mag_g(i)-Mag_r(i)))**2))
KErr_r(i)=K_r(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(MagErr_g(i)**2+MagErr_r(i)**2)/(Mag_g(i)-Mag_r(i)))**2))
KErr_i(i)=K_i(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(MagErr_g(i)**2+MagErr_i(i)**2)/(Mag_g(i)-Mag_i(i)))**2))
KErr_z(i)=K_z(i)*SQRT(((zErr(i)/z(i))**2)+((SQRT(MagErr_g(i)**2+MagErr_z(i)**2)/(Mag_g(i)-Mag_z(i)))**2))





END DO 
WRITE(*,*) 'K-correction applied'
WRITE(30,*) 'K-correction applied'



!correct for ellipticity
DO i=1,n

r_cor_g(i)=Rad_g(i)*SQRT(ba_g(i))
r_cor_r(i)=Rad_r(i)*SQRT(ba_r(i))
r_cor_i(i)=Rad_i(i)*SQRT(ba_i(i))
r_cor_z(i)=Rad_z(i)*SQRT(ba_z(i))

r_corErr_g(i)=r_cor_g(i)*SQRT((1.D0/2.D0*(baErr_g(i)/ba_g(i))**2)+((RadErr_g(i)/Rad_g(i))**2))
r_corErr_r(i)=r_cor_r(i)*SQRT((1.D0/2.D0*(baErr_r(i)/ba_r(i))**2)+((RadErr_r(i)/Rad_r(i))**2))
r_corErr_i(i)=r_cor_i(i)*SQRT((1.D0/2.D0*(baErr_i(i)/ba_i(i))**2)+((RadErr_i(i)/Rad_i(i))**2))
r_corErr_z(i)=r_cor_z(i)*SQRT((1.D0/2.D0*(baErr_z(i)/ba_z(i))**2)+((RadErr_z(i)/Rad_z(i))**2))


END DO
WRITE(*,*) 'corrected for ellipticity and dimming'
WRITE(30,*) 'corrected for ellipticity and dimming'

OPEN(70,file='output/rcor.txt')
DO i=1,n
WRITE(70,*) r_cor_g(i),r_cor_r(i),r_cor_i(i),r_cor_z(i)
END DO
 CLOSE(70)

 
 IF (act_radii_weights.NE.0) THEN
 
DO i=1,n
helplist_g(i)=r_cor_g(i)
helplist_r(i)=r_cor_r(i)
helplist_i(i)=r_cor_i(i)
helplist_z(i)=r_cor_z(i)
END DO



 DO ii=1,n
 DO iii=ii,n

 IF (helplist_g(ii)<helplist_g(iii)) THEN
 helpflip=helplist_g(ii)
 helplist_g(ii)=helplist_g(iii)
 helplist_g(iii)=helpflip
 END IF
 IF (helplist_r(ii)<helplist_r(iii)) THEN
 helpflip=helplist_r(ii)
 helplist_r(ii)=helplist_r(iii)
 helplist_r(iii)=helpflip
 END IF
 IF (helplist_i(ii)<helplist_i(iii)) THEN
 helpflip=helplist_i(ii)
 helplist_i(ii)=helplist_i(iii)
 helplist_i(iii)=helpflip
 END IF
 IF (helplist_z(ii)<helplist_z(iii)) THEN
 helpflip=helplist_z(ii)
 helplist_z(ii)=helplist_z(iii)
 helplist_z(iii)=helpflip
 END IF

 END DO
 END DO

n1percent=CEILING(DBLE(n)/1000.D0*3D0) !99.7% limit =~3 sigma
n_threesigma=n-n1percent

rang_min_g=helplist_g(n_threesigma)

rang_min_r=helplist_r(n_threesigma)

rang_min_i=helplist_i(n_threesigma)

rang_min_z=helplist_z(n_threesigma)

! WRITE(*,*) rang_min_g,rang_min_r,rang_min_i,rang_min_z





WRITE(*,*) 'radial size limits calculated'
WRITE(30,*) 'radial size limits calculated'

END IF

!correction for fixed aperature for the velocity dispersion measurment
DO i=1,n


divisor=(r_fiber/(r_cor_g(i)/8.D0))
sigma_cor_g(i)=veldisp(i)*(divisor**0.04D0)


divisor=(r_fiber/(r_cor_r(i)/8.D0))
sigma_cor_r(i)=veldisp(i)*(divisor**0.04D0)


divisor=(r_fiber/(r_cor_i(i)/8.D0))
sigma_cor_i(i)=veldisp(i)*(divisor**0.04D0)


divisor=(r_fiber/(r_cor_z(i)/8.D0))
sigma_cor_z(i)=veldisp(i)*(divisor**0.04D0)


sigma_corErr_g(i)=(r_corErr_g(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_g(i)**(-1.04D0)))**2
sigma_corErr_g(i)=sigma_corErr_g(i)+((veldisperr(i)*(divisor**0.04D0))**2)
sigma_corErr_g(i)=SQRT(sigma_corErr_g(i))

sigma_corErr_r(i)=(r_corErr_r(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_r(i)**(-1.04D0)))**2
sigma_corErr_r(i)=sigma_corErr_r(i)+((veldisperr(i)*(divisor**0.04D0))**2)
sigma_corErr_r(i)=SQRT(sigma_corErr_r(i))

sigma_corErr_i(i)=(r_corErr_i(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_i(i)**(-1.04D0)))**2
sigma_corErr_i(i)=sigma_corErr_i(i)+((veldisperr(i)*(divisor**0.04D0))**2)
sigma_corErr_i(i)=SQRT(sigma_corErr_i(i))

sigma_corErr_z(i)=(r_corErr_z(i)*0.04D0*veldisp(i)*((8.D0*r_fiber)**0.04D0)*(r_cor_z(i)**(-1.04D0)))**2
sigma_corErr_z(i)=sigma_corErr_z(i)+((veldisperr(i)*(divisor**0.04D0))**2)
sigma_corErr_z(i)=SQRT(sigma_corErr_z(i))


END DO
WRITE(*,*) 'corrected for fixed aperature diameter'
WRITE(30,*) 'corrected for fixed aperature diameter'

OPEN(70,file='output/sigmacor.txt')
DO i=1,n
WRITE(70,*) sigma_cor_g(i),sigma_cor_r(i),sigma_cor_i(i),sigma_cor_z(i)
END DO
 CLOSE(70)

OPEN(70,file='output/sigmacor_err.txt')
DO i=1,n
WRITE(70,*) sigma_corErr_g(i),sigma_corErr_r(i),sigma_corErr_i(i),sigma_corErr_z(i)
END DO
 CLOSE(70)








!correct redshift for motion relativ to the CMB
DO i=1,n
gal_b=gb(i)*PI/180.D0
gal_l=gl(i)*PI/180.D0
z_gal_x=z(i)*COS(gal_b)*COS(gal_l)
z_gal_y=z(i)*COS(gal_b)*SIN(gal_l)
z_gal_z=z(i)*SIN(gal_b)
z_gal_x=z_gal_x+z_cmb_x
z_gal_y=z_gal_y+z_cmb_y
z_gal_z=z_gal_z+z_cmb_z
z_cor(i)=z_gal_x*COS(gal_b)*COS(gal_l)+z_gal_y*COS(gal_b)*SIN(gal_l)+z_gal_z*SIN(gal_b)

z_corErr(i)=zErr(i)
END DO
WRITE(*,*) 'corrected for motion relativ to the CMB'
WRITE(30,*) 'corrected for motion relativ to the CMB'


IF (fingersofgod==1) THEN
DO i=1,n
z_cor(i)=z_cluster(i)
END DO
END IF


DO i=1,n


magabs_g(i)=Mag_g(i)-K_g(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
magabs_g(i)=magabs_g(i)+mag_evolution_g*z_cor(i)
Mag_app_g(i)=magabs_g(i)

magappErr_g(i)=(KErr_g(i)**2)+(MagErr_g(i)**2)+((mag_evolution_g*z_corErr(i))**2)
magappErr_g(i)=SQRT(magappErr_g(i))




logI0_g(i)=magabs_g(i)+2.5D0*LOG10(2.D0*PI*(r_cor_g(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
! surface brightness  - last term corrects for cosmological dimming
logI0_g(i)=logI0_g(i)/(-2.5D0) !rescaling (it's just a matter of definition)



muErr_g(i)=(magappErr_g(i)**2)+((r_corErr_g(i)*5.D0/(LOG(10.D0)*r_cor_g(i)))**2)
muErr_g(i)=muErr_g(i)+((10.D0/LOG(10.D0)*z_corErr(i)/z_cor(i))**2)
muErr_g(i)=SQRT(muErr_g(i))



I0_g(i)=10.D0**(logI0_g(i))


magabs_r(i)=Mag_r(i)-K_r(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
magabs_r(i)=magabs_r(i)+mag_evolution_r*z_cor(i)
Mag_app_r(i)=magabs_r(i)

magappErr_r(i)=(KErr_r(i)**2)+(MagErr_r(i)**2)+((mag_evolution_r*z_corErr(i))**2)
magappErr_r(i)=SQRT(magappErr_r(i))






logI0_r(i)=magabs_r(i)+2.5D0*LOG10(2.D0*PI*(r_cor_r(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
! surface brightness  - last term corrects for cosmological dimming
logI0_r(i)=logI0_r(i)/(-2.5D0) !rescaling (it's just a matter of definition)


muErr_r(i)=(magappErr_r(i)**2)+((r_corErr_r(i)*5.D0/(LOG(10.D0)*r_cor_r(i)))**2)
muErr_r(i)=muErr_r(i)+((10.D0/LOG(10.D0)*z_corErr(i)/z_cor(i))**2)
muErr_r(i)=SQRT(muErr_r(i))


I0_r(i)=10.D0**(logI0_r(i))

magabs_i(i)=Mag_i(i)-K_i(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
magabs_i(i)=magabs_i(i)+mag_evolution_i*z_cor(i)
Mag_app_i(i)=magabs_i(i)


magappErr_i(i)=(KErr_i(i)**2)+(MagErr_i(i)**2)+((mag_evolution_i*z_corErr(i))**2)
magappErr_i(i)=SQRT(magappErr_i(i))





logI0_i(i)=magabs_i(i)+2.5D0*LOG10(2.D0*PI*(r_cor_i(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
! surface brightness  - last term corrects for cosmological dimming
logI0_i(i)=logI0_i(i)/(-2.5D0) !rescaling (it's just a matter of definition)

muErr_i(i)=(magappErr_i(i)**2)+((r_corErr_i(i)*5.D0/(LOG(10.D0)*r_cor_i(i)))**2)
muErr_i(i)=muErr_i(i)+((10.D0/LOG(10.D0)*z_corErr(i)/z_cor(i))**2)
muErr_i(i)=SQRT(muErr_i(i))

I0_i(i)=10.D0**(logI0_i(i))


magabs_z(i)=Mag_z(i)-K_z(i) ! corrected apparent magnitudes
!correct for potential redshift evolution
magabs_z(i)=magabs_z(i)+mag_evolution_z*z_cor(i)
Mag_app_z(i)=magabs_z(i)



magappErr_z(i)=(KErr_z(i)**2)+(MagErr_z(i)**2)+((mag_evolution_z*z_corErr(i))**2)
magappErr_z(i)=SQRT(magappErr_z(i))





logI0_z(i)=magabs_z(i)+2.5D0*LOG10(2.D0*PI*(r_cor_z(i)**2.D0))-10.D0*LOG10(1.D0+z_cor(i)) 
! surface brightness  - last term corrects for cosmological dimming
logI0_z(i)=logI0_z(i)/(-2.5D0) !rescaling (it's just a matter of definition)

muErr_z(i)=(magappErr_z(i)**2)+((r_corErr_z(i)*5.D0/(LOG(10.D0)*r_cor_z(i)))**2)
muErr_z(i)=muErr_z(i)+((10.D0/LOG(10.D0)*z_corErr(i)/z_cor(i))**2)
muErr_z(i)=SQRT(muErr_z(i))

I0_z(i)=10.D0**(logI0_z(i))


END DO
WRITE(*,*) 'surfacebrightness calculated and corrected for cosmological dimming'
WRITE(30,*) 'surfacebrightness calculated and corrected for cosmological dimming'

OPEN(70,file='output/logI0.txt')
DO i=1,n
WRITE(70,*) logI0_g(i),logI0_r(i),logI0_i(i),logI0_z(i)
END DO
 CLOSE(70)

OPEN(70,file='output/mu.txt')
DO i=1,n
WRITE(70,*) (logI0_g(i)*(-2.5D0)),(logI0_r(i)*(-2.5D0)),(logI0_i(i)*(-2.5D0)),(logI0_z(i)*(-2.5D0))
END DO
 CLOSE(70)

 OPEN(70,file='output/muerr.txt')
DO i=1,n
WRITE(70,*) muErr_g(i),muErr_r(i),muErr_i(i),muErr_z(i)
END DO
 CLOSE(70)

!calculate the redshift distance
DO i=1,n
!distance(i)=light/H0*z_cor(i)*((1.D0-(((1.D0+q0)/2.D0)*z_cor(i)))/(1.D0+z_cor(i))) !old version
divisor=(SQRT(1.D0+2.D0*q0*z_cor(i))+1.D0+q0*z_cor(i))
!luminosity distance
distance(i)=light/H0*z_cor(i)*(1.D0+((z_cor(i)*(1.D0-q0))/divisor))
logdistlum(i)=LOG10(distance(i)*1.D6)
!angular diameter distance
distance(i)=distance(i)*((1.D0+z_cor(i))**(-2.D0))

!distance in kpc
distance(i)=distance(i)*1000.D0

distanceErr(i)=light/H0*z_corErr(i)*1000.D0


END DO
WRITE(*,*) 'distances calculated'
WRITE(30,*) 'distances calculated'

OPEN(70,file='output/distance.txt')
DO i=1,n
WRITE(70,*) distance(i)
END DO
 CLOSE(70)

 OPEN(70,file='output/distanceErr.txt')
DO i=1,n
WRITE(70,*) distanceErr(i)
END DO
 CLOSE(70)


!transform arcseconds to radiant
DO i=1,n

alpha_g(i)=r_cor_g(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_r(i)=r_cor_r(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_i(i)=r_cor_i(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alpha_z(i)=r_cor_z(i)*2.D0*PI/(360.D0*60.D0*60.D0)


alphaErr_g(i)=r_corErr_g(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alphaErr_r(i)=r_corErr_r(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alphaErr_i(i)=r_corErr_i(i)*2.D0*PI/(360.D0*60.D0*60.D0)
alphaErr_z(i)=r_corErr_z(i)*2.D0*PI/(360.D0*60.D0*60.D0)


END DO
WRITE(*,*) 'angles transformed to radiant'
WRITE(30,*) 'angles transformed to radiant'

!too simple, no controll output necessary

!calculate effective radius in kpc
DO i=1,n

R0_g(i)=TAN(alpha_g(i))*distance(i)
R0_r(i)=TAN(alpha_r(i))*distance(i)
R0_i(i)=TAN(alpha_i(i))*distance(i)
R0_z(i)=TAN(alpha_z(i))*distance(i)

R0Err_g(i)=SQRT(((alphaErr_g(i)/alpha_g(i))**2)+((distanceErr(i)/distance(i))**2))*R0_g(i)
R0Err_r(i)=SQRT(((alphaErr_r(i)/alpha_r(i))**2)+((distanceErr(i)/distance(i))**2))*R0_r(i)
R0Err_i(i)=SQRT(((alphaErr_i(i)/alpha_i(i))**2)+((distanceErr(i)/distance(i))**2))*R0_i(i)
R0Err_z(i)=SQRT(((alphaErr_z(i)/alpha_z(i))**2)+((distanceErr(i)/distance(i))**2))*R0_z(i)



END DO
WRITE(*,*) 'effective radius calculated'
WRITE(30,*) 'effective radius calculated'



OPEN(70,file='output/R0.txt')
DO i=1,n
WRITE(70,*) R0_g(i),R0_r(i),R0_i(i),R0_z(i)
END DO
 CLOSE(70)

 OPEN(70,file='output/R0Err.txt')
DO i=1,n
WRITE(70,*) R0Err_g(i),R0Err_r(i),R0Err_i(i),R0Err_z(i)
END DO
 CLOSE(70)




!transform to log(R0)
DO i=1,n

logR0_g(i)=LOG10(R0_g(i))
logR0_r(i)=LOG10(R0_r(i))
logR0_i(i)=LOG10(R0_i(i))
logR0_z(i)=LOG10(R0_z(i))


!transform to log(sigma)

logsigma_g(i)=LOG10(sigma_cor_g(i))
logsigma_r(i)=LOG10(sigma_cor_r(i))
logsigma_i(i)=LOG10(sigma_cor_i(i))
logsigma_z(i)=LOG10(sigma_cor_z(i))

END DO
WRITE(*,*) 'parameters logaritmized'
WRITE(30,*) 'parameters logaritmized'


! preselecting sample

DO i=1,n
!note - angular diameter distance to luminosity distance 

magabs_g(i)=magabs_g(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_r(i)=magabs_r(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_i(i)=magabs_i(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
magabs_z(i)=magabs_z(i)-5.D0*LOG10(((1.D0+z_cor(i))**2.D0)*distance(i)*1000.D0)+5.D0
END DO




DO i=1,n

                                                                                

IF (magabs_g(i)<maxmag_g) THEN
active(i)=.FALSE.
END IF
IF (magabs_g(i)>minmag_g) THEN
active(i)=.FALSE.
END IF

IF (magabs_r(i)<maxmag_r) THEN
active(i)=.FALSE.
END IF
IF (magabs_r(i)>minmag_r) THEN
active(i)=.FALSE.
END IF

IF (magabs_i(i)<maxmag_i) THEN
active(i)=.FALSE.
END IF
IF (magabs_i(i)>minmag_i) THEN
active(i)=.FALSE.
END IF

IF (magabs_z(i)<maxmag_z) THEN
active(i)=.FALSE.
END IF
IF (magabs_z(i)>minmag_z) THEN
active(i)=.FALSE.
END IF

   

active(96842)=.FALSE.



IF ((logR0_g(i))<(R0_min_g)) THEN
active(i)=.FALSE.
END IF
IF ((logR0_g(i))>(R0_max_g)) THEN
active(i)=.FALSE.
WRITE(*,*) i
END IF

IF ((logR0_r(i))<(R0_min_r)) THEN
active(i)=.FALSE.
END IF
IF ((logR0_r(i))>(R0_max_r)) THEN
active(i)=.FALSE.
WRITE(*,*) i
END IF

IF ((logR0_i(i))<(R0_min_i)) THEN
active(i)=.FALSE.
END IF
IF ((logR0_i(i))>(R0_max_i)) THEN
active(i)=.FALSE.
WRITE(*,*) i
END IF

IF ((logR0_z(i))<(R0_min_z)) THEN
active(i)=.FALSE.
END IF
IF ((logR0_z(i))>(R0_max_z)) THEN
active(i)=.FALSE.
WRITE(*,*) i
END IF




IF (logdistlum(i)>=veryhugenumber) THEN
active(i)=.FALSE.
END IF
IF (logdistlum(i)<=-veryhugenumber) THEN
active(i)=.FALSE.
END IF
!
END DO





OPEN(70,file='output/mz_vs_g-r.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) magabs_z(i),(Mag_app_g(i)-Mag_app_r(i))
END IF
END DO

DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT((-magabs_z(i)-18.D0)*40.D0)
help_y=NINT(((Mag_app_g(i)-Mag_app_r(i))-0.4D0)*400.D0)
IF ((help_x>0).AND.(help_x<320)) THEN
IF ((help_y>0).AND.(help_y<320)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/mz_vs_g-r_map.txt')
DO i=0,320
DO ii=0,320
help_x2=-((DBLE(i))/40.D0)-18.D0
help_y2=((DBLE(ii))/400.D0)+0.4D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)




!redsequence
IF (colourdata==1) THEN

DO i=1,3
DO ii=1,3
 colour_matrix(i,ii)=0.D0
END DO
 colour_vector(i)=0.D0
END DO

DO i=1,n
IF (active(i)) THEN
help_colour=Mag_app_g(i)-Mag_app_r(i)

 colour_matrix(1,1)=colour_matrix(1,1)+magabs_z(i)**4
 colour_matrix(1,2)=colour_matrix(1,2)+magabs_z(i)**3
 colour_matrix(2,1)=colour_matrix(2,1)+magabs_z(i)**3
 colour_matrix(2,2)=colour_matrix(2,2)+magabs_z(i)**2
 colour_matrix(3,1)=colour_matrix(3,1)+magabs_z(i)**2
 colour_matrix(1,3)=colour_matrix(1,3)+magabs_z(i)**2
 colour_matrix(3,2)=colour_matrix(3,2)+magabs_z(i)
 colour_matrix(2,3)=colour_matrix(2,3)+magabs_z(i)
 colour_matrix(3,3)=colour_matrix(3,3)+1.D0

 colour_vector(1)=colour_vector(1)+help_colour*magabs_z(i)**2
 colour_vector(2)=colour_vector(2)+help_colour*magabs_z(i)
 colour_vector(3)=colour_vector(3)+help_colour

END IF
END DO

det_cMatrix=colour_matrix(1,1)*colour_matrix(2,2)*colour_matrix(3,3)
det_cMatrix=det_cMatrix+colour_matrix(2,1)*colour_matrix(3,2)*colour_matrix(1,3)
det_cMatrix=det_cMatrix+colour_matrix(1,2)*colour_matrix(2,3)*colour_matrix(3,1)
det_cMatrix=det_cMatrix-colour_matrix(1,3)*colour_matrix(2,2)*colour_matrix(3,1)
det_cMatrix=det_cMatrix-colour_matrix(2,1)*colour_matrix(1,2)*colour_matrix(3,3)
det_cMatrix=det_cMatrix-colour_matrix(2,3)*colour_matrix(3,2)*colour_matrix(1,1)


DO i=1,3
DO ii=1,3
 help_matrix_1(i,ii)=colour_matrix(i,ii)
 help_matrix_2(i,ii)=colour_matrix(i,ii)
 help_matrix_3(i,ii)=colour_matrix(i,ii)
END DO
END DO

DO i=1,3
 help_matrix_1(1,i)=colour_vector(i)
 help_matrix_2(2,i)=colour_vector(i)
 help_matrix_3(3,i)=colour_vector(i)
END DO

det_helpMatrix1=help_matrix_1(1,1)*help_matrix_1(2,2)*help_matrix_1(3,3)
det_helpMatrix1=det_helpMatrix1+help_matrix_1(2,1)*help_matrix_1(3,2)*help_matrix_1(1,3)
det_helpMatrix1=det_helpMatrix1+help_matrix_1(1,2)*help_matrix_1(2,3)*help_matrix_1(3,1)
det_helpMatrix1=det_helpMatrix1-help_matrix_1(1,3)*help_matrix_1(2,2)*help_matrix_1(3,1)
det_helpMatrix1=det_helpMatrix1-help_matrix_1(2,1)*help_matrix_1(1,2)*help_matrix_1(3,3)
det_helpMatrix1=det_helpMatrix1-help_matrix_1(2,3)*help_matrix_1(3,2)*help_matrix_1(1,1)

det_helpMatrix2=help_matrix_2(1,1)*help_matrix_2(2,2)*help_matrix_2(3,3)
det_helpMatrix2=det_helpMatrix2+help_matrix_2(2,1)*help_matrix_2(3,2)*help_matrix_2(1,3)
det_helpMatrix2=det_helpMatrix2+help_matrix_2(1,2)*help_matrix_2(2,3)*help_matrix_2(3,1)
det_helpMatrix2=det_helpMatrix2-help_matrix_2(1,3)*help_matrix_2(2,2)*help_matrix_2(3,1)
det_helpMatrix2=det_helpMatrix2-help_matrix_2(2,1)*help_matrix_2(1,2)*help_matrix_2(3,3)
det_helpMatrix2=det_helpMatrix2-help_matrix_2(2,3)*help_matrix_2(3,2)*help_matrix_2(1,1)

det_helpMatrix3=help_matrix_3(1,1)*help_matrix_3(2,2)*help_matrix_3(3,3)
det_helpMatrix3=det_helpMatrix3+help_matrix_3(2,1)*help_matrix_3(3,2)*help_matrix_3(1,3)
det_helpMatrix3=det_helpMatrix3+help_matrix_3(1,2)*help_matrix_3(2,3)*help_matrix_3(3,1)
det_helpMatrix3=det_helpMatrix3-help_matrix_3(1,3)*help_matrix_3(2,2)*help_matrix_3(3,1)
det_helpMatrix3=det_helpMatrix3-help_matrix_3(2,1)*help_matrix_3(1,2)*help_matrix_3(3,3)
det_helpMatrix3=det_helpMatrix3-help_matrix_3(2,3)*help_matrix_3(3,2)*help_matrix_3(1,1)



 colour_coeff1=det_helpMatrix1/det_cMatrix
 colour_coeff2=det_helpMatrix2/det_cMatrix
 colour_coeff3=det_helpMatrix3/det_cMatrix


 colour_rms=0.D0
 DO i=1,n
 IF (active(i)) THEN

 help_colour=Mag_app_g(i)-Mag_app_r(i)
 colour_dev=colour_coeff1*(magabs_z(i)**2)+colour_coeff2*magabs_z(i)+colour_coeff3-help_colour
 colour_rms=colour_rms+(colour_dev**2)

 END IF
 END DO

 colour_rms=SQRT(colour_rms/colour_matrix(3,3))



 DO i=1,n
 IF (active(i)) THEN
 help_colour=Mag_app_g(i)-Mag_app_r(i)
 colour_dev=colour_coeff1*(magabs_z(i)**2)+colour_coeff2*magabs_z(i)+colour_coeff3-help_colour 
 colour_dev=ABS(colour_dev)
 IF (colour_dev>(3.D0*colour_rms)) THEN
 active(i)=.FALSE.
 END IF

 END IF
 END DO


OPEN(70,file='output/redsequence_fit.txt')
WRITE(70,*) 'cc1=',colour_coeff1
WRITE(70,*) 'cc2=',colour_coeff2
WRITE(70,*) 'cc3=',colour_coeff3
WRITE(70,*) 'c_rms=',colour_rms
 CLOSE(70)

WRITE(*,*) 'filtered for red sequence'
WRITE(30,*) 'filtered for red sequence'
END IF







galactive=0
DO i=1,n
IF (active(i)) THEN
partpresel(i)=.TRUE.
galactive=galactive+1
ELSE
partpresel(i)=.FALSE.
END IF
END DO





DO i=1,n

IF (z_cor(i)>zmax) THEN
active(i)=.FALSE.
END IF

IF (z_cor(i)<zmin) THEN
active(i)=.FALSE.
END IF

END DO






av_mag_abs=0.D0
DO i=1,n 
IF (active(i)) THEN
av_mag_abs=av_mag_abs+magabs_r(i)
END IF
END DO

av_mag_abs=av_mag_abs/DBLE(galactive)

DO i=1,n 
IF (active(i)) THEN
mapsize(i)=magabs_r(i)/av_mag_abs/2.D0
END IF
END DO








DO i=0,300
DO ii=0,240
fp_map(i,ii)=0
END DO
END DO


!maps for contoure plots
DO i=1,n
IF (active(i)) THEN

help_x=NINT(r_cor_g(i)*20.D0)
help_y=NINT((Mag_app_g(i)-10.D0)*20.D0)

IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<240)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/r_m_app_map_g.txt')
DO i=0,300
DO ii=0,240
help_x2=DBLE(i)/20.D0
help_y2=(DBLE(ii)/20.D0)+10.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)










DO i=0,300
DO ii=0,240
fp_map(i,ii)=0
END DO
END DO


!maps for contoure plots
DO i=1,n
IF (active(i)) THEN

help_x=NINT(r_cor_r(i)*20.D0)
help_y=NINT((Mag_app_r(i)-10.D0)*20.D0)

IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<240)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/r_m_app_map_r.txt')
DO i=0,300
DO ii=0,240
help_x2=DBLE(i)/20.D0
help_y2=(DBLE(ii)/20.D0)+10.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)










DO i=0,300
DO ii=0,240
fp_map(i,ii)=0
END DO
END DO


!maps for contoure plots
DO i=1,n
IF (active(i)) THEN

help_x=NINT(r_cor_i(i)*20.D0)
help_y=NINT((Mag_app_i(i)-10.D0)*20.D0)

IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<240)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/r_m_app_map_i.txt')
DO i=0,300
DO ii=0,240
help_x2=DBLE(i)/20.D0
help_y2=(DBLE(ii)/20.D0)+10.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)








DO i=0,300
DO ii=0,240
fp_map(i,ii)=0
END DO
END DO


!maps for contoure plots
DO i=1,n
IF (active(i)) THEN

help_x=NINT(r_cor_z(i)*20.D0)
help_y=NINT((Mag_app_z(i)-10.D0)*20.D0)

IF ((help_x>0).AND.(help_x<300)) THEN
IF ((help_y>0).AND.(help_y<240)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/r_m_app_map_z.txt')
DO i=0,300
DO ii=0,240
help_x2=DBLE(i)/20.D0
help_y2=(DBLE(ii)/20.D0)+10.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)






DO i=0,400
DO ii=0,300
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((LOGR0_g(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/logR_vs_z_map_g.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/100.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)


DO i=0,400
DO ii=0,300
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((LOGR0_r(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/logR_vs_z_map_r.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/100.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)


DO i=0,400
DO ii=0,300
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((LOGR0_i(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/logR_vs_z_map_i.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/100.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)




DO i=0,400
DO ii=0,300
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((LOGR0_z(i)+0.5D0)*100.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/logR_vs_z_map_z.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/100.D0)-0.5D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)








DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_g(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_map_g.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)

DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_r(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_map_r.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)



DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_i(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_map_i.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_z(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_map_z.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)




DO i=0,500
DO ii=0,400
bias_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (partpresel(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_r(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
bias_map(help_x,help_y)=bias_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_map_r_full.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,bias_map(i,ii)
END DO
END DO
 CLOSE(61)





!output parameters vs redshift


OPEN(70,file='output/parameter_vs_z_in_g.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) z_cor(i),LOGI0_g(i),LOGR0_g(i),LOGsigma_g(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_z_in_r.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) z_cor(i),LOGI0_r(i),LOGR0_r(i),LOGsigma_r(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_z_in_i.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) z_cor(i),LOGI0_i(i),LOGR0_i(i),LOGsigma_i(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_z_in_z.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) z_cor(i),LOGI0_z(i),LOGR0_z(i),LOGsigma_z(i)
END IF
END DO
 CLOSE (70)




!output parameter vs redshift


OPEN(70,file='output/parameter_vs_magabs_in_g.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) magabs_g(i),LOGI0_g(i),LOGR0_g(i),LOGsigma_g(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_magabs_in_r.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) magabs_r(i),LOGI0_r(i),LOGR0_r(i),LOGsigma_r(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_magabs_in_i.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) magabs_i(i),LOGI0_i(i),LOGR0_i(i),LOGsigma_i(i)
END IF
END DO
 CLOSE (70)

OPEN(70,file='output/parameter_vs_magabs_in_z.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) magabs_z(i),LOGI0_z(i),LOGR0_z(i),LOGsigma_z(i)
END IF
END DO
 CLOSE (70)


WRITE(*,*) 'output correlation data'
WRITE(30,*) 'output correlation data'




dist_k_g=-0.2D0
dist_k_r=-0.2D0
dist_k_i=-0.2D0
dist_k_z=-0.2D0



 hcount=0
 DO i=1,n
 IF (active(i)) THEN
 hcount=hcount+1
 helplist_g(hcount)=-magabs_g(i)*dist_k_g+logdistlum(i)
 helplist_r(hcount)=-magabs_r(i)*dist_k_r+logdistlum(i)
 helplist_i(hcount)=-magabs_i(i)*dist_k_i+logdistlum(i)
 helplist_z(hcount)=-magabs_z(i)*dist_k_z+logdistlum(i)
 END IF
 END DO


 DO ii=1,hcount
 DO iii=ii,hcount

 IF (helplist_g(ii)<helplist_g(iii)) THEN
 helpflip=helplist_g(ii)
 helplist_g(ii)=helplist_g(iii)
 helplist_g(iii)=helpflip
 END IF
 IF (helplist_r(ii)<helplist_r(iii)) THEN
 helpflip=helplist_r(ii)
 helplist_r(ii)=helplist_r(iii)
 helplist_r(iii)=helpflip
 END IF
 IF (helplist_i(ii)<helplist_i(iii)) THEN
 helpflip=helplist_i(ii)
 helplist_i(ii)=helplist_i(iii)
 helplist_i(iii)=helpflip
 END IF
 IF (helplist_z(ii)<helplist_z(iii)) THEN
 helpflip=helplist_z(ii)
 helplist_z(ii)=helplist_z(iii)
 helplist_z(iii)=helpflip
 END IF

 END DO
 END DO

n1percent=CEILING(DBLE(hcount)/1000.D0*3D0) !99.7% limit =~3 sigma
n_threesigma=hcount-n1percent

dist_d_g=helplist_g(n1percent)

dist_d_r=helplist_r(n1percent)

dist_d_i=helplist_i(n1percent)

dist_d_z=helplist_z(n1percent)

dist_dsat_g=helplist_g(n_threesigma)

dist_dsat_r=helplist_r(n_threesigma)

dist_dsat_i=helplist_i(n_threesigma)

dist_dsat_z=helplist_z(n_threesigma)


OPEN(70,file='output/dist_limits_for_mag.txt')
WRITE(70,*) dist_k_g,dist_d_g,dist_dsat_g
WRITE(70,*) dist_k_r,dist_d_r,dist_dsat_r
WRITE(70,*) dist_k_i,dist_d_i,dist_dsat_i
WRITE(70,*) dist_k_z,dist_d_z,dist_dsat_z
 CLOSE (70)


OPEN(70,file='output/dist_limits_for_mag_plot.txt')

solve_t1=1.D0/dist_k_g
solve_t2=-dist_d_g/dist_k_g
solve_t3=-dist_dsat_g/dist_k_g
WRITE(70,*) 'distkg=',solve_t1
WRITE(70,*) 'distdg=',solve_t2
WRITE(70,*) 'distsatdg=',solve_t3
solve_t1=1.D0/dist_k_r
solve_t2=-dist_d_r/dist_k_r
solve_t3=-dist_dsat_r/dist_k_r
WRITE(70,*) 'distkr=',solve_t1
WRITE(70,*) 'distdr=',solve_t2
WRITE(70,*) 'distsatdr=',solve_t3
solve_t1=1.D0/dist_k_i
solve_t2=-dist_d_i/dist_k_i
solve_t3=-dist_dsat_i/dist_k_i
WRITE(70,*) 'distki=',solve_t1
WRITE(70,*) 'distdi=',solve_t2
WRITE(70,*) 'distsatdi=',solve_t3
solve_t1=1.D0/dist_k_z
solve_t2=-dist_d_z/dist_k_z
solve_t3=-dist_dsat_z/dist_k_z
WRITE(70,*) 'distkz=',solve_t1
WRITE(70,*) 'distdz=',solve_t2
WRITE(70,*) 'distsatdz=',solve_t3
 CLOSE (70)



! calculate volume weights 
allocate(volume_weight_g(1:n))
allocate(volume_weight_r(1:n))
allocate(volume_weight_i(1:n))
allocate(volume_weight_z(1:n))


V_sum_g=0.D0
V_sum_r=0.D0
V_sum_i=0.D0
V_sum_z=0.D0



DO i=1,n
IF (active(i)) THEN


D_limit=dist_k_g*magabs_g(i)+dist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_g*magabs_g(i)+dist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF

IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_g(i)/TAN(rang_min_g/180.D0*PI/3600.D0)


IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! g',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_g(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_r(i)/TAN(rang_min_r/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit


otherlimit=rang_dang/1.D3
!  WRITE(*,*) otherlimit,D_lower,D_middle,D_upper
 
 
IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! r',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF





V_limit=(D_limit**3)-Vminsat
volume_weight_r(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

D_limit=dist_k_i*magabs_i(i)+dist_d_i
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_i*magabs_i(i)+dist_dsat_i
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF













IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_i(i)/TAN(rang_min_i/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! i',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF


END IF



V_limit=(D_limit**3)-Vminsat
volume_weight_i(i)=1.D0/V_limit
V_sum_i=V_sum_i+1.D0/V_limit

D_limit=dist_k_z*magabs_z(i)+dist_d_z
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_z*magabs_z(i)+dist_dsat_z
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF








IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_z(i)/TAN(rang_min_z/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! z',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF





V_limit=(D_limit**3)-Vminsat
volume_weight_z(i)=1.D0/V_limit
V_sum_z=V_sum_z+1.D0/V_limit


END IF
END DO


DO i=1,n
IF (active(i)) THEN
volume_weight_g(i)=volume_weight_g(i)/V_sum_g
volume_weight_r(i)=volume_weight_r(i)/V_sum_r
volume_weight_i(i)=volume_weight_i(i)/V_sum_i
volume_weight_z(i)=volume_weight_z(i)/V_sum_z
END IF
END DO




WRITE(*,*) 'luminosity limit and volume weights calculated'
WRITE(30,*) 'luminosity limit and volume weights calculated'


galactive=0
DO i=1,n
IF (active(i)) THEN
galactive=galactive+1
END IF
END DO




DO i=0,500
DO ii=0,400
weight_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_g(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_g(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_weightmap_g.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)

DO i=0,500
DO ii=0,400
weight_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_r(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_r(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_weightmap_r.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)



DO i=0,500
DO ii=0,400
weight_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_i(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_i(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_weightmap_i.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,500
DO ii=0,400
weight_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((logdistlum(i)-7.D0)*200.D0)
help_y=NINT((-magabs_z(i)-15.D0)*40.D0)
IF ((help_x>0).AND.(help_x<500)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_z(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/m_vs_d_weightmap_z.txt')
DO i=0,500
DO ii=0,400
help_x2=((DBLE(i))/200.D0)+7.D0
help_y2=-((DBLE(ii))/40.D0)-15.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)




WRITE(*,*) 'preselction done, now working with ',galactive,' galaxies'
WRITE(30,*) 'preselction done, now working with ',galactive,' galaxies'






WRITE(*,*) 'start fitting using least squares'
WRITE(30,*) 'start fitting using least squares'
!fitting the fundamental plane --- here the real work starts!


 a_g=1.1D0
 b_g=-0.7D0
 c_g=-8.D0
 a_r=1.1D0
 b_r=-0.7D0
 c_r=-8.D0
 a_i=1.1D0
 b_i=-0.7D0
 c_i=-8.D0
 a_z=1.1D0
 b_z=-0.7D0
 c_z=-8.D0

 continueloop=.TRUE.
ee=0

delta_a_g=0.D0
delta_b_g=0.D0
delta_c_g=0.D0
delta_a_r=0.D0
delta_b_r=0.D0
delta_c_r=0.D0
delta_a_i=0.D0
delta_b_i=0.D0
delta_c_i=0.D0
delta_a_z=0.D0
delta_b_z=0.D0
delta_c_z=0.D0

! do loop for opitmization
DO WHILE (continueloop)
ee=ee+1

! calculating statistical weights for the measurments

IF (weight_switch==1) THEN


V_sum_g=0.D0
V_sum_r=0.D0
V_sum_i=0.D0
V_sum_z=0.D0

DO i=1,n
IF (active(i)) THEN


D_limit=dist_k_g*magabs_g(i)+dist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_g*magabs_g(i)+dist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_g(i)/TAN(rang_min_g/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! g',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF



V_limit=(D_limit**3)-Vminsat
volume_weight_g(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF









IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_r(i)/TAN(rang_min_r/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! r',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF


V_limit=(D_limit**3)-Vminsat
volume_weight_r(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

D_limit=dist_k_i*magabs_i(i)+dist_d_i
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_i*magabs_i(i)+dist_dsat_i
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF



IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_i(i)/TAN(rang_min_i/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! i',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_i(i)=1.D0/V_limit
V_sum_i=V_sum_i+1.D0/V_limit

D_limit=dist_k_z*magabs_z(i)+dist_d_z
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_z*magabs_z(i)+dist_dsat_z
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_z(i)/TAN(rang_min_z/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! z',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF


V_limit=(D_limit**3)-Vminsat
volume_weight_z(i)=1.D0/V_limit
V_sum_z=V_sum_z+1.D0/V_limit


END IF
END DO



DO i=1,n
IF (active(i)) THEN

volume_weight_g(i)=volume_weight_g(i)/V_sum_g
volume_weight_r(i)=volume_weight_r(i)/V_sum_r
volume_weight_i(i)=volume_weight_i(i)/V_sum_i
volume_weight_z(i)=volume_weight_z(i)/V_sum_z
END IF
END DO





WRITE(*,*) 'volume weights recalculated'
WRITE(30,*) 'volume weights recalculated'


END IF




DO i=1,n
IF (active(i)) THEN

err_g(i)=1.D0

err_r(i)=1.D0

err_i(i)=1.D0

err_z(i)=1.D0

END IF
END DO



IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN

err_g(i)=volume_weight_g(i)*DBLE(galactive)

err_r(i)=volume_weight_r(i)*DBLE(galactive)

err_i(i)=volume_weight_i(i)*DBLE(galactive)

err_z(i)=volume_weight_z(i)*DBLE(galactive)

END IF
END DO
END IF





!preparing matrizes
DO i=1,3 
Yvector_g(i)=0.D0
Yvector_r(i)=0.D0
Yvector_i(i)=0.D0
Yvector_z(i)=0.D0
DO ii=1,3
Amatrix_g(i,ii)=0.D0
Amatrix_r(i,ii)=0.D0
Amatrix_i(i,ii)=0.D0
Amatrix_z(i,ii)=0.D0
Bmatrix1_g(i,ii)=0.D0
Bmatrix2_g(i,ii)=0.D0
Bmatrix3_g(i,ii)=0.D0
Bmatrix1_r(i,ii)=0.D0
Bmatrix2_r(i,ii)=0.D0
Bmatrix3_r(i,ii)=0.D0
Bmatrix1_i(i,ii)=0.D0
Bmatrix2_i(i,ii)=0.D0
Bmatrix3_i(i,ii)=0.D0
Bmatrix2_z(i,ii)=0.D0
Bmatrix3_z(i,ii)=0.D0
Bmatrix1_z(i,ii)=0.D0
END DO
END DO

!calculating basic matrix und vector
DO i=1,n
IF (active(i)) THEN

Amatrix_g(1,1)=Amatrix_g(1,1)+logsigma_g(i)*logsigma_g(i)*err_g(i)
Amatrix_g(2,2)=Amatrix_g(2,2)+logI0_g(i)*logI0_g(i)*err_g(i)
Amatrix_g(3,3)=Amatrix_g(3,3)+1.D0*err_g(i)
Amatrix_g(1,2)=Amatrix_g(1,2)+logsigma_g(i)*logI0_g(i)*err_g(i)
Amatrix_g(2,1)=Amatrix_g(2,1)+logsigma_g(i)*logI0_g(i)*err_g(i)
Amatrix_g(1,3)=Amatrix_g(1,3)+logsigma_g(i)*err_g(i)
Amatrix_g(3,1)=Amatrix_g(3,1)+logsigma_g(i)*err_g(i)
Amatrix_g(2,3)=Amatrix_g(2,3)+logI0_g(i)*err_g(i)
Amatrix_g(3,2)=Amatrix_g(3,2)+logI0_g(i)*err_g(i)
Yvector_g(1)=Yvector_g(1)+logR0_g(i)*logsigma_g(i)*err_g(i)
Yvector_g(2)=Yvector_g(2)+logR0_g(i)*logI0_g(i)*err_g(i)
Yvector_g(3)=Yvector_g(3)+logR0_g(i)*err_g(i)

Amatrix_r(1,1)=Amatrix_r(1,1)+logsigma_r(i)*logsigma_r(i)*err_r(i)
Amatrix_r(2,2)=Amatrix_r(2,2)+logI0_r(i)*logI0_r(i)*err_r(i)
Amatrix_r(3,3)=Amatrix_r(3,3)+1.D0*err_r(i)
Amatrix_r(1,2)=Amatrix_r(1,2)+logsigma_r(i)*logI0_r(i)*err_r(i)
Amatrix_r(2,1)=Amatrix_r(2,1)+logsigma_r(i)*logI0_r(i)*err_r(i)
Amatrix_r(1,3)=Amatrix_r(1,3)+logsigma_r(i)*err_r(i)
Amatrix_r(3,1)=Amatrix_r(3,1)+logsigma_r(i)*err_r(i)
Amatrix_r(2,3)=Amatrix_r(2,3)+logI0_r(i)*err_r(i)
Amatrix_r(3,2)=Amatrix_r(3,2)+logI0_r(i)*err_r(i)
Yvector_r(1)=Yvector_r(1)+logR0_r(i)*logsigma_r(i)*err_r(i)
Yvector_r(2)=Yvector_r(2)+logR0_r(i)*logI0_r(i)*err_r(i)
Yvector_r(3)=Yvector_r(3)+logR0_r(i)*err_r(i)

Amatrix_i(1,1)=Amatrix_i(1,1)+logsigma_i(i)*logsigma_i(i)*err_i(i)
Amatrix_i(2,2)=Amatrix_i(2,2)+logI0_i(i)*logI0_i(i)*err_i(i)
Amatrix_i(3,3)=Amatrix_i(3,3)+1.D0*err_i(i)
Amatrix_i(1,2)=Amatrix_i(1,2)+logsigma_i(i)*logI0_i(i)*err_i(i)
Amatrix_i(2,1)=Amatrix_i(2,1)+logsigma_i(i)*logI0_i(i)*err_i(i)
Amatrix_i(1,3)=Amatrix_i(1,3)+logsigma_i(i)*err_i(i)
Amatrix_i(3,1)=Amatrix_i(3,1)+logsigma_i(i)*err_i(i)
Amatrix_i(2,3)=Amatrix_i(2,3)+logI0_i(i)*err_i(i)
Amatrix_i(3,2)=Amatrix_i(3,2)+logI0_i(i)*err_i(i)
Yvector_i(1)=Yvector_i(1)+logR0_i(i)*logsigma_i(i)*err_i(i)
Yvector_i(2)=Yvector_i(2)+logR0_i(i)*logI0_i(i)*err_i(i)
Yvector_i(3)=Yvector_i(3)+logR0_i(i)*err_i(i)

Amatrix_z(1,1)=Amatrix_z(1,1)+logsigma_z(i)*logsigma_z(i)*err_z(i)
Amatrix_z(2,2)=Amatrix_z(2,2)+logI0_z(i)*logI0_z(i)*err_z(i)
Amatrix_z(3,3)=Amatrix_z(3,3)+1.D0*err_z(i)
Amatrix_z(1,2)=Amatrix_z(1,2)+logsigma_z(i)*logI0_z(i)*err_z(i)
Amatrix_z(2,1)=Amatrix_z(2,1)+logsigma_z(i)*logI0_z(i)*err_z(i)
Amatrix_z(1,3)=Amatrix_z(1,3)+logsigma_z(i)*err_z(i)
Amatrix_z(3,1)=Amatrix_z(3,1)+logsigma_z(i)*err_z(i)
Amatrix_z(2,3)=Amatrix_z(2,3)+logI0_z(i)*err_z(i)
Amatrix_z(3,2)=Amatrix_z(3,2)+logI0_z(i)*err_z(i)
Yvector_z(1)=Yvector_z(1)+logR0_z(i)*logsigma_z(i)*err_z(i)
Yvector_z(2)=Yvector_z(2)+logR0_z(i)*logI0_z(i)*err_z(i)
Yvector_z(3)=Yvector_z(3)+logR0_z(i)*err_z(i)


END IF
END DO

OPEN(70,file='output/Amatrizes.txt')
DO i=1,3
WRITE(70,*) Amatrix_g(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Amatrix_r(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Amatrix_i(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Amatrix_z(i,1:3)
END DO
 CLOSE(70)

OPEN(70,file='output/Yvectors.txt')
WRITE(70,*) Yvector_g(1:3)
WRITE(70,*) '----------------------------------------------------------'
WRITE(70,*) Yvector_r(1:3)
WRITE(70,*) '----------------------------------------------------------'
WRITE(70,*) Yvector_i(1:3)
WRITE(70,*) '----------------------------------------------------------'
WRITE(70,*) Yvector_z(1:3)
 CLOSE(70)

!get determinat of Amatrix


detA_g=Amatrix_g(1,1)*Amatrix_g(2,2)*Amatrix_g(3,3)
detA_g=detA_g+Amatrix_g(2,1)*Amatrix_g(3,2)*Amatrix_g(1,3)
detA_g=detA_g+Amatrix_g(1,2)*Amatrix_g(2,3)*Amatrix_g(3,1)
detA_g=detA_g-Amatrix_g(1,3)*Amatrix_g(2,2)*Amatrix_g(3,1)
detA_g=detA_g-Amatrix_g(2,1)*Amatrix_g(1,2)*Amatrix_g(3,3)
detA_g=detA_g-Amatrix_g(2,3)*Amatrix_g(3,2)*Amatrix_g(1,1)

detA_r=Amatrix_r(1,1)*Amatrix_r(2,2)*Amatrix_r(3,3)
detA_r=detA_r+Amatrix_r(2,1)*Amatrix_r(3,2)*Amatrix_r(1,3)
detA_r=detA_r+Amatrix_r(1,2)*Amatrix_r(2,3)*Amatrix_r(3,1)
detA_r=detA_r-Amatrix_r(1,3)*Amatrix_r(2,2)*Amatrix_r(3,1)
detA_r=detA_r-Amatrix_r(2,1)*Amatrix_r(1,2)*Amatrix_r(3,3)
detA_r=detA_r-Amatrix_r(2,3)*Amatrix_r(3,2)*Amatrix_r(1,1)

detA_i=Amatrix_i(1,1)*Amatrix_i(2,2)*Amatrix_i(3,3)
detA_i=detA_i+Amatrix_i(2,1)*Amatrix_i(3,2)*Amatrix_i(1,3)
detA_i=detA_i+Amatrix_i(1,2)*Amatrix_i(2,3)*Amatrix_i(3,1)
detA_i=detA_i-Amatrix_i(1,3)*Amatrix_i(2,2)*Amatrix_i(3,1)
detA_i=detA_i-Amatrix_i(2,1)*Amatrix_i(1,2)*Amatrix_i(3,3)
detA_i=detA_i-Amatrix_i(2,3)*Amatrix_i(3,2)*Amatrix_i(1,1)

detA_z=Amatrix_z(1,1)*Amatrix_z(2,2)*Amatrix_z(3,3)
detA_z=detA_z+Amatrix_z(2,1)*Amatrix_z(3,2)*Amatrix_z(1,3)
detA_z=detA_z+Amatrix_z(1,2)*Amatrix_z(2,3)*Amatrix_z(3,1)
detA_z=detA_z-Amatrix_z(1,3)*Amatrix_z(2,2)*Amatrix_z(3,1)
detA_z=detA_z-Amatrix_z(2,1)*Amatrix_z(1,2)*Amatrix_z(3,3)
detA_z=detA_z-Amatrix_z(2,3)*Amatrix_z(3,2)*Amatrix_z(1,1)


OPEN(70,file='output/detA.txt')
WRITE(70,*) detA_g,detA_r,detA_i,detA_z
 CLOSE(70)


!calculate B matrizes
DO i=1,3
DO ii=1,3


Bmatrix1_g(i,ii)=Amatrix_g(i,ii)
Bmatrix2_g(i,ii)=Amatrix_g(i,ii)
Bmatrix3_g(i,ii)=Amatrix_g(i,ii)

Bmatrix1_r(i,ii)=Amatrix_r(i,ii)
Bmatrix2_r(i,ii)=Amatrix_r(i,ii)
Bmatrix3_r(i,ii)=Amatrix_r(i,ii)

Bmatrix1_i(i,ii)=Amatrix_i(i,ii)
Bmatrix2_i(i,ii)=Amatrix_i(i,ii)
Bmatrix3_i(i,ii)=Amatrix_i(i,ii)

Bmatrix1_z(i,ii)=Amatrix_z(i,ii)
Bmatrix2_z(i,ii)=Amatrix_z(i,ii)
Bmatrix3_z(i,ii)=Amatrix_z(i,ii)


END DO
END DO

DO i=1,3


Bmatrix1_g(1,i)=Yvector_g(i)
Bmatrix2_g(2,i)=Yvector_g(i)
Bmatrix3_g(3,i)=Yvector_g(i)

Bmatrix1_r(1,i)=Yvector_r(i)
Bmatrix2_r(2,i)=Yvector_r(i)
Bmatrix3_r(3,i)=Yvector_r(i)

Bmatrix1_i(1,i)=Yvector_i(i)
Bmatrix2_i(2,i)=Yvector_i(i)
Bmatrix3_i(3,i)=Yvector_i(i)

Bmatrix1_z(1,i)=Yvector_z(i)
Bmatrix2_z(2,i)=Yvector_z(i)
Bmatrix3_z(3,i)=Yvector_z(i)


END DO



OPEN(70,file='output/Bmatrizes.txt')

DO i=1,3
WRITE(70,*) Bmatrix1_g(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix1_r(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix1_i(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix1_z(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
WRITE(70,*) '----------------------------------------------------------'

DO i=1,3
WRITE(70,*) Bmatrix2_g(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix2_r(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix2_i(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix2_z(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
WRITE(70,*) '----------------------------------------------------------'

DO i=1,3
WRITE(70,*) Bmatrix3_g(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix3_r(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix3_i(i,1:3)
END DO
WRITE(70,*) '----------------------------------------------------------'
DO i=1,3
WRITE(70,*) Bmatrix3_z(i,1:3)
END DO
 CLOSE(70)





! get determinat of Bmatrizes



detB1_g=Bmatrix1_g(1,1)*Bmatrix1_g(2,2)*Bmatrix1_g(3,3)
detB1_g=detB1_g+Bmatrix1_g(2,1)*Bmatrix1_g(3,2)*Bmatrix1_g(1,3)
detB1_g=detB1_g+Bmatrix1_g(1,2)*Bmatrix1_g(2,3)*Bmatrix1_g(3,1)
detB1_g=detB1_g-Bmatrix1_g(1,3)*Bmatrix1_g(2,2)*Bmatrix1_g(3,1)
detB1_g=detB1_g-Bmatrix1_g(2,1)*Bmatrix1_g(1,2)*Bmatrix1_g(3,3)
detB1_g=detB1_g-Bmatrix1_g(2,3)*Bmatrix1_g(3,2)*Bmatrix1_g(1,1)
detB2_g=Bmatrix2_g(1,1)*Bmatrix2_g(2,2)*Bmatrix2_g(3,3)
detB2_g=detB2_g+Bmatrix2_g(2,1)*Bmatrix2_g(3,2)*Bmatrix2_g(1,3)
detB2_g=detB2_g+Bmatrix2_g(1,2)*Bmatrix2_g(2,3)*Bmatrix2_g(3,1)
detB2_g=detB2_g-Bmatrix2_g(1,3)*Bmatrix2_g(2,2)*Bmatrix2_g(3,1)
detB2_g=detB2_g-Bmatrix2_g(2,1)*Bmatrix2_g(1,2)*Bmatrix2_g(3,3)
detB2_g=detB2_g-Bmatrix2_g(2,3)*Bmatrix2_g(3,2)*Bmatrix2_g(1,1)
detB3_g=Bmatrix3_g(1,1)*Bmatrix3_g(2,2)*Bmatrix3_g(3,3)
detB3_g=detB3_g+Bmatrix3_g(2,1)*Bmatrix3_g(3,2)*Bmatrix3_g(1,3)
detB3_g=detB3_g+Bmatrix3_g(1,2)*Bmatrix3_g(2,3)*Bmatrix3_g(3,1)
detB3_g=detB3_g-Bmatrix3_g(1,3)*Bmatrix3_g(2,2)*Bmatrix3_g(3,1)
detB3_g=detB3_g-Bmatrix3_g(2,1)*Bmatrix3_g(1,2)*Bmatrix3_g(3,3)
detB3_g=detB3_g-Bmatrix3_g(2,3)*Bmatrix3_g(3,2)*Bmatrix3_g(1,1)

detB1_r=Bmatrix1_r(1,1)*Bmatrix1_r(2,2)*Bmatrix1_r(3,3)
detB1_r=detB1_r+Bmatrix1_r(2,1)*Bmatrix1_r(3,2)*Bmatrix1_r(1,3)
detB1_r=detB1_r+Bmatrix1_r(1,2)*Bmatrix1_r(2,3)*Bmatrix1_r(3,1)
detB1_r=detB1_r-Bmatrix1_r(1,3)*Bmatrix1_r(2,2)*Bmatrix1_r(3,1)
detB1_r=detB1_r-Bmatrix1_r(2,1)*Bmatrix1_r(1,2)*Bmatrix1_r(3,3)
detB1_r=detB1_r-Bmatrix1_r(2,3)*Bmatrix1_r(3,2)*Bmatrix1_r(1,1)
detB2_r=Bmatrix2_r(1,1)*Bmatrix2_r(2,2)*Bmatrix2_r(3,3)
detB2_r=detB2_r+Bmatrix2_r(2,1)*Bmatrix2_r(3,2)*Bmatrix2_r(1,3)
detB2_r=detB2_r+Bmatrix2_r(1,2)*Bmatrix2_r(2,3)*Bmatrix2_r(3,1)
detB2_r=detB2_r-Bmatrix2_r(1,3)*Bmatrix2_r(2,2)*Bmatrix2_r(3,1)
detB2_r=detB2_r-Bmatrix2_r(2,1)*Bmatrix2_r(1,2)*Bmatrix2_r(3,3)
detB2_r=detB2_r-Bmatrix2_r(2,3)*Bmatrix2_r(3,2)*Bmatrix2_r(1,1)
detB3_r=Bmatrix3_r(1,1)*Bmatrix3_r(2,2)*Bmatrix3_r(3,3)
detB3_r=detB3_r+Bmatrix3_r(2,1)*Bmatrix3_r(3,2)*Bmatrix3_r(1,3)
detB3_r=detB3_r+Bmatrix3_r(1,2)*Bmatrix3_r(2,3)*Bmatrix3_r(3,1)
detB3_r=detB3_r-Bmatrix3_r(1,3)*Bmatrix3_r(2,2)*Bmatrix3_r(3,1)
detB3_r=detB3_r-Bmatrix3_r(2,1)*Bmatrix3_r(1,2)*Bmatrix3_r(3,3)
detB3_r=detB3_r-Bmatrix3_r(2,3)*Bmatrix3_r(3,2)*Bmatrix3_r(1,1)

detB1_i=Bmatrix1_i(1,1)*Bmatrix1_i(2,2)*Bmatrix1_i(3,3)
detB1_i=detB1_i+Bmatrix1_i(2,1)*Bmatrix1_i(3,2)*Bmatrix1_i(1,3)
detB1_i=detB1_i+Bmatrix1_i(1,2)*Bmatrix1_i(2,3)*Bmatrix1_i(3,1)
detB1_i=detB1_i-Bmatrix1_i(1,3)*Bmatrix1_i(2,2)*Bmatrix1_i(3,1)
detB1_i=detB1_i-Bmatrix1_i(2,1)*Bmatrix1_i(1,2)*Bmatrix1_i(3,3)
detB1_i=detB1_i-Bmatrix1_i(2,3)*Bmatrix1_i(3,2)*Bmatrix1_i(1,1)
detB2_i=Bmatrix2_i(1,1)*Bmatrix2_i(2,2)*Bmatrix2_i(3,3)
detB2_i=detB2_i+Bmatrix2_i(2,1)*Bmatrix2_i(3,2)*Bmatrix2_i(1,3)
detB2_i=detB2_i+Bmatrix2_i(1,2)*Bmatrix2_i(2,3)*Bmatrix2_i(3,1)
detB2_i=detB2_i-Bmatrix2_i(1,3)*Bmatrix2_i(2,2)*Bmatrix2_i(3,1)
detB2_i=detB2_i-Bmatrix2_i(2,1)*Bmatrix2_i(1,2)*Bmatrix2_i(3,3)
detB2_i=detB2_i-Bmatrix2_i(2,3)*Bmatrix2_i(3,2)*Bmatrix2_i(1,1)
detB3_i=Bmatrix3_i(1,1)*Bmatrix3_i(2,2)*Bmatrix3_i(3,3)
detB3_i=detB3_i+Bmatrix3_i(2,1)*Bmatrix3_i(3,2)*Bmatrix3_i(1,3)
detB3_i=detB3_i+Bmatrix3_i(1,2)*Bmatrix3_i(2,3)*Bmatrix3_i(3,1)
detB3_i=detB3_i-Bmatrix3_i(1,3)*Bmatrix3_i(2,2)*Bmatrix3_i(3,1)
detB3_i=detB3_i-Bmatrix3_i(2,1)*Bmatrix3_i(1,2)*Bmatrix3_i(3,3)
detB3_i=detB3_i-Bmatrix3_i(2,3)*Bmatrix3_i(3,2)*Bmatrix3_i(1,1)

detB1_z=Bmatrix1_z(1,1)*Bmatrix1_z(2,2)*Bmatrix1_z(3,3)
detB1_z=detB1_z+Bmatrix1_z(2,1)*Bmatrix1_z(3,2)*Bmatrix1_z(1,3)
detB1_z=detB1_z+Bmatrix1_z(1,2)*Bmatrix1_z(2,3)*Bmatrix1_z(3,1)
detB1_z=detB1_z-Bmatrix1_z(1,3)*Bmatrix1_z(2,2)*Bmatrix1_z(3,1)
detB1_z=detB1_z-Bmatrix1_z(2,1)*Bmatrix1_z(1,2)*Bmatrix1_z(3,3)
detB1_z=detB1_z-Bmatrix1_z(2,3)*Bmatrix1_z(3,2)*Bmatrix1_z(1,1)
detB2_z=Bmatrix2_z(1,1)*Bmatrix2_z(2,2)*Bmatrix2_z(3,3)
detB2_z=detB2_z+Bmatrix2_z(2,1)*Bmatrix2_z(3,2)*Bmatrix2_z(1,3)
detB2_z=detB2_z+Bmatrix2_z(1,2)*Bmatrix2_z(2,3)*Bmatrix2_z(3,1)
detB2_z=detB2_z-Bmatrix2_z(1,3)*Bmatrix2_z(2,2)*Bmatrix2_z(3,1)
detB2_z=detB2_z-Bmatrix2_z(2,1)*Bmatrix2_z(1,2)*Bmatrix2_z(3,3)
detB2_z=detB2_z-Bmatrix2_z(2,3)*Bmatrix2_z(3,2)*Bmatrix2_z(1,1)
detB3_z=Bmatrix3_z(1,1)*Bmatrix3_z(2,2)*Bmatrix3_z(3,3)
detB3_z=detB3_z+Bmatrix3_z(2,1)*Bmatrix3_z(3,2)*Bmatrix3_z(1,3)
detB3_z=detB3_z+Bmatrix3_z(1,2)*Bmatrix3_z(2,3)*Bmatrix3_z(3,1)
detB3_z=detB3_z-Bmatrix3_z(1,3)*Bmatrix3_z(2,2)*Bmatrix3_z(3,1)
detB3_z=detB3_z-Bmatrix3_z(2,1)*Bmatrix3_z(1,2)*Bmatrix3_z(3,3)
detB3_z=detB3_z-Bmatrix3_z(2,3)*Bmatrix3_z(3,2)*Bmatrix3_z(1,1)


OPEN(70,file='output/detB.txt')
WRITE(70,*) detB1_g,detB1_r,detB1_i,detB1_z
WRITE(70,*) detB2_g,detB2_r,detB2_i,detB2_z
WRITE(70,*) detB3_g,detB3_r,detB3_i,detB3_z
 CLOSE(70)


! get solutions


 a_g=detB1_g/detA_g
 b_g=detB2_g/detA_g
 c_g=detB3_g/detA_g

 a_r=detB1_r/detA_r
 b_r=detB2_r/detA_r
 c_r=detB3_r/detA_r

 a_i=detB1_i/detA_i
 b_i=detB2_i/detA_i
 c_i=detB3_i/detA_i

 a_z=detB1_z/detA_z
 b_z=detB2_z/detA_z
 c_z=detB3_z/detA_z



WRITE(*,*) 'fundamental plane fitted'
WRITE(30,*) 'fundamental plane fitted'

!calculate right side of fundamental plane
DO i=1,n
IF (active(i)) THEN


otherside_g(i)=a_g*logsigma_g(i)+b_g*logI0_g(i)+c_g
otherside_r(i)=a_r*logsigma_r(i)+b_r*logI0_r(i)+c_r
otherside_i(i)=a_i*logsigma_i(i)+b_i*logI0_i(i)+c_i
otherside_z(i)=a_z*logsigma_z(i)+b_z*logI0_z(i)+c_z

END IF
END DO

! propagation of error
!root mean square
rms_g=0.D0
rms_r=0.D0
rms_i=0.D0
rms_z=0.D0
DO i=1,n
IF (active(i)) THEN



deviation_g(i)=otherside_g(i)-logR0_g(i)
deviation_r(i)=otherside_r(i)-logR0_r(i)
deviation_i(i)=otherside_i(i)-logR0_i(i)
deviation_z(i)=otherside_z(i)-logR0_z(i)


rms_g=rms_g+err_g(i)*((deviation_g(i))**2)
rms_r=rms_r+err_r(i)*((deviation_r(i))**2)
rms_i=rms_i+err_i(i)*((deviation_i(i))**2)
rms_z=rms_z+err_z(i)*((deviation_z(i))**2)

END IF
END DO



rms_g=SQRT(rms_g/DBLE(galactive))
rms_r=SQRT(rms_r/DBLE(galactive))
rms_i=SQRT(rms_i/DBLE(galactive))
rms_z=SQRT(rms_z/DBLE(galactive))



! error of fitting parameters


 a_err_g=(Amatrix_g(2,2)*Amatrix_g(3,3)-Amatrix_g(2,3)*Amatrix_g(3,2))/detA_g
 a_err_g=SQRT(a_err_g)
 b_err_g=(Amatrix_g(1,1)*Amatrix_g(3,3)-Amatrix_g(1,3)*Amatrix_g(3,1))/detA_g
 b_err_g=SQRT(b_err_g)
 c_err_g=(Amatrix_g(1,1)*Amatrix_g(2,2)-Amatrix_g(1,2)*Amatrix_g(2,1))/detA_g
 c_err_g=SQRT(c_err_g)

 a_err_r=(Amatrix_r(2,2)*Amatrix_r(3,3)-Amatrix_r(2,3)*Amatrix_r(3,2))/detA_r
 a_err_r=SQRT(a_err_r)
 b_err_r=(Amatrix_r(1,1)*Amatrix_r(3,3)-Amatrix_r(1,3)*Amatrix_r(3,1))/detA_r
 b_err_r=SQRT(b_err_r)
 c_err_r=(Amatrix_r(1,1)*Amatrix_r(2,2)-Amatrix_r(1,2)*Amatrix_r(2,1))/detA_r
 c_err_r=SQRT(c_err_r)

 a_err_i=(Amatrix_i(2,2)*Amatrix_i(3,3)-Amatrix_i(2,3)*Amatrix_i(3,2))/detA_i
 a_err_i=SQRT(a_err_i)
 b_err_i=(Amatrix_i(1,1)*Amatrix_i(3,3)-Amatrix_i(1,3)*Amatrix_i(3,1))/detA_i
 b_err_i=SQRT(b_err_i)
 c_err_i=(Amatrix_i(1,1)*Amatrix_i(2,2)-Amatrix_i(1,2)*Amatrix_i(2,1))/detA_i
 c_err_i=SQRT(c_err_i)

 a_err_z=(Amatrix_z(2,2)*Amatrix_z(3,3)-Amatrix_z(2,3)*Amatrix_z(3,2))/detA_z
 a_err_z=SQRT(a_err_z)
 b_err_z=(Amatrix_z(1,1)*Amatrix_z(3,3)-Amatrix_z(1,3)*Amatrix_z(3,1))/detA_z
 b_err_z=SQRT(b_err_z)
 c_err_z=(Amatrix_z(1,1)*Amatrix_z(2,2)-Amatrix_z(1,2)*Amatrix_z(2,1))/detA_z
 c_err_z=SQRT(c_err_z)



WRITE(*,*) 'propagation of error done'
WRITE(30,*) 'propagation of error done'



!see if another loop is still nessecary


delta_a_g=delta_a_g-a_g
delta_b_g=delta_b_g-b_g
delta_c_g=delta_c_g-c_g
delta_a_g=delta_a_g*3.D0
delta_b_g=delta_b_g*3.D0
delta_c_g=delta_c_g*3.D0
delta_a_g=delta_a_g**2
delta_b_g=delta_b_g**2
delta_c_g=delta_c_g**2

delta_a_r=delta_a_r-a_r
delta_b_r=delta_b_r-b_r
delta_c_r=delta_c_r-c_r
delta_a_r=delta_a_r*3.D0
delta_b_r=delta_b_r*3.D0
delta_c_r=delta_c_r*3.D0
delta_a_r=delta_a_r**2
delta_b_r=delta_b_r**2
delta_c_r=delta_c_r**2

delta_a_i=delta_a_i-a_i
delta_b_i=delta_b_i-b_i
delta_c_i=delta_c_i-c_i
delta_a_i=delta_a_i*3.D0
delta_b_i=delta_b_i*3.D0
delta_c_i=delta_c_i*3.D0
delta_a_i=delta_a_i**2
delta_b_i=delta_b_i**2
delta_c_i=delta_c_i**2

delta_a_z=delta_a_z-a_z
delta_b_z=delta_b_z-b_z
delta_c_z=delta_c_z-c_z
delta_a_z=delta_a_z*3.D0
delta_b_z=delta_b_z*3.D0
delta_c_z=delta_c_z*3.D0
delta_a_z=delta_a_z**2
delta_b_z=delta_b_z**2
delta_c_z=delta_c_z**2



 continueloop=.FALSE.



IF (delta_a_g>(a_err_g**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_b_g>(b_err_g**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_c_g>(c_err_g**2)) THEN
 continueloop=.TRUE.
END IF


IF (delta_a_r>(a_err_r**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_b_r>(b_err_r**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_c_r>(c_err_r**2)) THEN
 continueloop=.TRUE.
END IF


IF (delta_a_i>(a_err_i**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_b_i>(b_err_i**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_c_i>(c_err_i**2)) THEN
 continueloop=.TRUE.
END IF


IF (delta_a_z>(a_err_z**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_b_z>(b_err_z**2)) THEN
 continueloop=.TRUE.
END IF
IF (delta_c_z>(c_err_z**2)) THEN
 continueloop=.TRUE.
END IF






delta_a_g=a_g
delta_b_g=b_g
delta_c_g=c_g

delta_a_r=a_r
delta_b_r=b_r
delta_c_r=c_r

delta_a_i=a_i
delta_b_i=b_i
delta_c_i=c_i

delta_a_z=a_z
delta_b_z=b_z
delta_c_z=c_z


IF (ee>maxloop) THEN
 continueloop=.FALSE.
END IF




IF (continueloop) THEN

!3-sigma-clipping
DO i=1,n
IF (active(i)) THEN


IF ((deviation_g(i)**2.D0)>((3.D0*rms_g)**2.D0)) THEN
active(i)=.FALSE.
END IF

IF ((deviation_r(i)**2.D0)>((3.D0*rms_r)**2.D0)) THEN
active(i)=.FALSE.
END IF

IF ((deviation_i(i)**2.D0)>((3.D0*rms_i)**2.D0)) THEN
active(i)=.FALSE.
END IF

IF ((deviation_z(i)**2.D0)>((3.D0*rms_z)**2.D0)) THEN
active(i)=.FALSE.
END IF

END IF
END DO
WRITE(*,*) '3-sigma clipping done'
WRITE(30,*) '3-sigma clipping done'



! count galaxies still in use
galactive=0
DO i=1,n
IF (active(i)) THEN
galactive=galactive+1
END IF
END DO
WRITE(*,*) 'basis data selection improved for the ',ee,' time'
WRITE(*,*) 'redo fitting with ',galactive,' galaxies'
WRITE(30,*) 'basis data selection improved for the ',ee,' time'
WRITE(30,*) 'redo fitting with ',galactive,' galaxies'





END IF

! end long loop
END DO
WRITE(*,*) 'fitting the fundamental plane completed'
WRITE(30,*) 'fitting the fundamental plane completed'



! output fitparameter results
OPEN(60,file='output/fitparameters.txt')


WRITE(60,*) a_g,b_g,c_g
WRITE(60,*) a_err_g,b_err_g,c_err_g,rms_g
WRITE(60,*) a_r,b_r,c_r
WRITE(60,*) a_err_r,b_err_r,c_err_r,rms_r
WRITE(60,*) a_i,b_i,c_i
WRITE(60,*) a_err_i,b_err_i,c_err_i,rms_i
WRITE(60,*) a_z,b_z,c_z
WRITE(60,*) a_err_z,b_err_z,c_err_z,rms_z

 CLOSE(60)



! write output for galaxies




OPEN(70,file='output/fplane_g.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) logR0_g(i),logsigma_g(i),logI0_g(i)
END IF
END DO
 CLOSE(70)

OPEN(70,file='output/fplane_r.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) logR0_r(i),logsigma_r(i),logI0_r(i)
END IF
END DO
 CLOSE(70)

OPEN(70,file='output/fplane_i.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) logR0_i(i),logsigma_i(i),logI0_i(i)
END IF
END DO
 CLOSE(70)

OPEN(70,file='output/fplane_z.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(70,*) logR0_z(i),logsigma_z(i),logI0_z(i)
END IF
END DO
 CLOSE(70)



! output for diagrams


OPEN(61,file='output/fundamental_g.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/fundamental_r.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/fundamental_i.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/fundamental_z.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END DO
 CLOSE(61)






IF (autosplit==1) THEN

! output for diagrams redshift binned
iii=0


OPEN(61,file='output/f1_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>(zmin)).AND.(z_cor(i)<(zmin+(deltaz/3.D0)))) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>(zmin)).AND.(z_cor(i)<(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>(zmin)).AND.(z_cor(i)<(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>(zmin)).AND.(z_cor(i)<(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)

iii=0



OPEN(61,file='output/f2_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmin+(deltaz*2.D0/3.D0))).AND.(z_cor(i)>(zmin+(deltaz/3.D0)))) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmin+(deltaz*2.D0/3.D0))).AND.(z_cor(i)>(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmin+(deltaz*2.D0/3.D0))).AND.(z_cor(i)>(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmin+(deltaz*2.D0/3.D0))).AND.(z_cor(i)>(zmin+(deltaz/3.D0)))) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)

iii=0



OPEN(61,file='output/f3_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmax)).AND.(z_cor(i)>(zmin+(deltaz*2.D0/3.D0)))) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmax)).AND.(z_cor(i)>(zmin+(deltaz*2.D0/3.D0)))) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmax)).AND.(z_cor(i)>(zmin+(deltaz*2.D0/3.D0)))) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<(zmax)).AND.(z_cor(i)>(zmin+(deltaz*2.D0/3.D0)))) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)

ELSE


! output for diagrams redshift binned
iii=0


!WRITE(*,*) iii

OPEN(61,file='output/f1_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>zmin).AND.(z_cor(i)<split1)) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>zmin).AND.(z_cor(i)<split1)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>zmin).AND.(z_cor(i)<split1)) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f1_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)>zmin).AND.(z_cor(i)<split1)) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)

iii=0


OPEN(61,file='output/f2_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<split2).AND.(z_cor(i)>split1)) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<split2).AND.(z_cor(i)>split1)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<split2).AND.(z_cor(i)>split1)) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f2_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<split2).AND.(z_cor(i)>split1)) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)

iii=0



OPEN(61,file='output/f3_g.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<zmax).AND.(z_cor(i)>split2)) THEN
iii=iii+1
WRITE(61,*) logR0_g(i),otherside_g(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_r.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<zmax).AND.(z_cor(i)>split2)) THEN
WRITE(61,*) logR0_r(i),otherside_r(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_i.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<zmax).AND.(z_cor(i)>split2)) THEN
WRITE(61,*) logR0_i(i),otherside_i(i)
END IF
END IF
END DO
 CLOSE(61)

OPEN(61,file='output/f3_z.txt')
DO i=1,n
IF (active(i)) THEN
IF ((z_cor(i)<zmax).AND.(z_cor(i)>split2)) THEN
WRITE(61,*) logR0_z(i),otherside_z(i)
END IF
END IF
END DO
 CLOSE(61)




END IF











DO i=0,350
DO ii=0,350
weight_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_g(i)*100.D0+100.D0)
help_y=NINT(otherside_g(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_g(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_weightmap_g.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,350
DO ii=0,350
weight_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_r(i)*100.D0+100.D0)
help_y=NINT(otherside_r(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_r(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_weightmap_r.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)




DO i=0,350
DO ii=0,350
weight_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_i(i)*100.D0+100.D0)
help_y=NINT(otherside_i(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_i(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_weightmap_i.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,350
DO ii=0,350
weight_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_z(i)*100.D0+100.D0)
help_y=NINT(otherside_z(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
weight_map(help_x,help_y)=weight_map(help_x,help_y)+volume_weight_z(i)
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_weightmap_z.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,weight_map(i,ii)
END DO
END DO
 CLOSE(61)



































DO i=0,350
DO ii=0,350
fp_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_g(i)*100.D0+100.D0)
help_y=NINT(otherside_g(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_map_g.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)




DO i=0,350
DO ii=0,350
fp_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_r(i)*100.D0+100.D0)
help_y=NINT(otherside_r(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_map_r.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)






DO i=0,350
DO ii=0,350
fp_map(i,ii)=0
END DO
END DO

DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_i(i)*100.D0+100.D0)
help_y=NINT(otherside_i(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_map_i.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)



DO i=0,350
DO ii=0,350
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(logR0_z(i)*100.D0+100.D0)
help_y=NINT(otherside_z(i)*100.D0+100.D0)
IF ((help_x>0).AND.(help_x<350)) THEN
IF ((help_y>0).AND.(help_y<350)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/fp_map_z.txt')
DO i=0,350
DO ii=0,350
help_x2=DBLE(i-100)/100.D0
help_y2=DBLE(ii-100)/100.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)




OPEN(61,file='output/residuals_dist.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) distance(i),deviation_z(i)
END IF
END DO

 CLOSE(61)
 
OPEN(61,file='output/residuals_magabs.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) magabs_z(i),deviation_z(i)
END IF
END DO

 CLOSE(61)


OPEN(61,file='output/residuals_colour.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) Mag_app_g(i)-Mag_app_r(i),deviation_z(i)
END IF
END DO

 CLOSE(61)



! residuals 

DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_i(i)+0.4D0)*500.D0)
help_y=NINT((deviation_z(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_iz.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_r(i)+0.4D0)*500.D0)
help_y=NINT((deviation_z(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_rz.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)


DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_g(i)+0.4D0)*500.D0)
help_y=NINT((deviation_z(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_gz.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)










DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_r(i)+0.4D0)*500.D0)
help_y=NINT((deviation_i(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_ri.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_g(i)+0.4D0)*500.D0)
help_y=NINT((deviation_i(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_gi.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)










DO i=0,400
DO ii=0,400
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT((deviation_g(i)+0.4D0)*500.D0)
help_y=NINT((deviation_r(i)+0.4D0)*500.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<400)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/residuals_map_gr.txt')
DO i=0,400
DO ii=0,400
help_x2=(DBLE(i)/500.D0)-0.4D0
help_y2=(DBLE(ii)/500.D0)-0.4D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)












av_dev_g=0.D0
av_dev_r=0.D0
av_dev_i=0.D0
av_dev_z=0.D0

DO i=1,n
IF (active(i)) THEN

av_dev_g=av_dev_g+deviation_r(i)
av_dev_r=av_dev_r+deviation_r(i)
av_dev_i=av_dev_i+deviation_i(i)
av_dev_z=av_dev_z+deviation_z(i)
END IF
END DO


av_dev_g=av_dev_g/DBLE(galactive)
av_dev_r=av_dev_r/DBLE(galactive)
av_dev_i=av_dev_i/DBLE(galactive)
av_dev_z=av_dev_z/DBLE(galactive)



sxx=0.D0
DO i=1,n
IF (active(i)) THEN
sxx=sxx+((deviation_z(i)-av_dev_z)**2)
END IF
END DO



syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_i(i)-av_dev_i)**2)
sxy=sxy+(deviation_z(i)-av_dev_z)*(deviation_i(i)-av_dev_i)
END IF
END DO

r_iz=(sxy**2)/(sxx*syy)
r_iz=SQRT(r_iz)


syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_r(i)-av_dev_r)**2)
sxy=sxy+(deviation_z(i)-av_dev_z)*(deviation_r(i)-av_dev_r)
END IF
END DO

r_rz=(sxy**2)/(sxx*syy)
r_rz=SQRT(r_rz)


syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_g(i)-av_dev_g)**2)
sxy=sxy+(deviation_z(i)-av_dev_z)*(deviation_g(i)-av_dev_g)
END IF
END DO

r_gz=(sxy**2)/(sxx*syy)
r_gz=SQRT(r_gz)







sxx=0.D0
DO i=1,n
IF (active(i)) THEN
sxx=sxx+((deviation_i(i)-av_dev_i)**2)
END IF
END DO



syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_r(i)-av_dev_r)**2)
sxy=sxy+(deviation_i(i)-av_dev_i)*(deviation_r(i)-av_dev_r)
END IF
END DO

r_ri=(sxy**2)/(sxx*syy)
r_ri=SQRT(r_ri)


syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_g(i)-av_dev_g)**2)
sxy=sxy+(deviation_i(i)-av_dev_i)*(deviation_g(i)-av_dev_g)
END IF
END DO

r_gi=(sxy**2)/(sxx*syy)
r_gi=SQRT(r_gi)







sxx=0.D0
DO i=1,n
IF (active(i)) THEN
sxx=sxx+((deviation_r(i)-av_dev_r)**2)
END IF
END DO



syy=0.D0
sxy=0.D0
DO i=1,n
IF (active(i)) THEN
syy=syy+((deviation_g(i)-av_dev_g)**2)
sxy=sxy+(deviation_r(i)-av_dev_r)*(deviation_g(i)-av_dev_g)
END IF
END DO

r_gr=(sxy**2)/(sxx*syy)
r_gr=SQRT(r_gr)







OPEN(61,file='output/correlation_residuals.txt')
WRITE(61,*) r_iz,r_rz,r_gz,r_ri,r_gi,r_gr
 CLOSE(61)














OPEN(61,file='output/corrected_data.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),magabs_g(i),magabs_r(i),magabs_i(i),magabs_z(i),Mag_app_g(i),Mag_app_r(i),Mag_app_i(i),Mag_app_z(i)
END IF
END DO
 CLOSE(61)




OPEN(61,file='output/zdependence_dev.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),deviation_g(i),deviation_r(i),deviation_i(i),deviation_z(i)
END IF
END DO
 CLOSE(61)



OPEN(61,file='output/zdependence_logR0.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),logR0_g(i),logR0_r(i),logR0_i(i),logR0_z(i)
END IF
END DO
 CLOSE(61)




OPEN(61,file='output/zdependence_sb.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),(-2.5D0*logI0_g(i)),(-2.5D0*logI0_r(i)),(-2.5D0*logI0_i(i)),(-2.5D0*logI0_z(i))
END IF
END DO
 CLOSE(61)






DO i=0,400
DO ii=0,300
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((-2.5D0*logI0_g(i)-16.D0)*20.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/zdependence_sb_map_g.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/20.D0)+16.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)





DO i=0,400
DO ii=0,300
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((-2.5D0*logI0_r(i)-16.D0)*20.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/zdependence_sb_map_r.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/20.D0)+16.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)




DO i=0,400
DO ii=0,300
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((-2.5D0*logI0_i(i)-16.D0)*20.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/zdependence_sb_map_i.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/20.D0)+16.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)







DO i=0,400
DO ii=0,300
fp_map(i,ii)=0
END DO
END DO



DO i=1,n
IF (active(i)) THEN

help_x=NINT(z_cor(i)*2000.D0)
help_y=NINT((-2.5D0*logI0_z(i)-16.D0)*20.D0)
IF ((help_x>0).AND.(help_x<400)) THEN
IF ((help_y>0).AND.(help_y<300)) THEN
fp_map(help_x,help_y)=fp_map(help_x,help_y)+1
END IF
END IF

END IF
END DO

OPEN(61,file='output/zdependence_sb_map_z.txt')
DO i=0,400
DO ii=0,300
help_x2=DBLE(i)/2000.D0
help_y2=(DBLE(ii)/20.D0)+16.D0
WRITE(61,*) help_x2,help_y2,fp_map(i,ii)
END DO
END DO
 CLOSE(61)















OPEN(61,file='output/zdependence_logsigma.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),logsigma_g(i),logsigma_r(i),logsigma_i(i),logsigma_z(i)
END IF
END DO
 CLOSE(61)



OPEN(61,file='output/zdependence_magabs.txt')
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) z_cor(i),magabs_g(i),magabs_r(i),magabs_i(i),magabs_z(i)
END IF
END DO
 CLOSE(61)





WRITE(*,*) 'output written to files for ',galactive,' galaxies'
WRITE(30,*) 'output written to files for ',galactive,' galaxies'







DO i=1,n
IF (partpresel(i)) THEN

fp_dist_g(i)=a_g*logsigma_g(i)+b_g*logI0_g(i)+c_g
fp_dist_r(i)=a_r*logsigma_r(i)+b_r*logI0_r(i)+c_r
fp_dist_i(i)=a_i*logsigma_i(i)+b_i*logI0_i(i)+c_i
fp_dist_z(i)=a_z*logsigma_z(i)+b_z*logI0_z(i)+c_z
END IF
END DO

DO i=1,n
IF (partpresel(i)) THEN

fp_dist_g(i)=(10.D0**fp_dist_g(i))/TAN(alpha_g(i))
fp_dist_r(i)=(10.D0**fp_dist_r(i))/TAN(alpha_r(i))
fp_dist_i(i)=(10.D0**fp_dist_i(i))/TAN(alpha_i(i))
fp_dist_z(i)=(10.D0**fp_dist_z(i))/TAN(alpha_z(i))

END IF
END DO

! 
! 
! 
! 
DO i=1,n
IF (partpresel(i)) THEN

! 
! D_limit=fp_dist_g(i)/1.D3
! t1=(light**2)*q0-(light**2)
! t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
! t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
! t2=SQRT(t2)
! t3=light*D_limit*H0*q0
! z_limit=1/(light**2)*(t1+t2+t3)

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 D_limit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_lower)**(-2.D0))
 D_lower=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 D_limit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_middle)**(-2.D0))
 D_middle=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 D_limit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_upper)**(-2.D0))
 D_upper=D_limit

D_limit=fp_dist_g(i)/1.D3

IF ((D_limit>D_lower).AND.(D_limit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((D_limit>D_middle).AND.(D_limit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! g',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

z_fp_g(i)=z_limit
fp_cdist_g(i)=fp_dist_g(i)*(1+z_limit)
fp_ldist_g(i)=fp_dist_g(i)*(1+z_limit)*(1+z_limit)

! D_limit=fp_dist_r(i)/1.D3
! t1=(light**2)*q0-(light**2)
! t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
! t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
! t2=SQRT(t2)
! t3=light*D_limit*H0*q0
! z_limit=1/(light**2)*(t1+t2+t3)



 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 D_limit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_lower)**(-2.D0))
 D_lower=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 D_limit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_middle)**(-2.D0))
 D_middle=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 D_limit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_upper)**(-2.D0))
 D_upper=D_limit

D_limit=fp_dist_r(i)/1.D3

IF ((D_limit>D_lower).AND.(D_limit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((D_limit>D_middle).AND.(D_limit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! r',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

z_fp_r(i)=z_limit
fp_cdist_r(i)=fp_dist_r(i)*(1+z_limit)
fp_ldist_r(i)=fp_dist_r(i)*(1+z_limit)*(1+z_limit)

! D_limit=fp_dist_i(i)/1.D3
! t1=(light**2)*q0-(light**2)
! t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
! t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
! t2=SQRT(t2)
! t3=light*D_limit*H0*q0
! z_limit=1/(light**2)*(t1+t2+t3)




 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 D_limit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_lower)**(-2.D0))
 D_lower=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 D_limit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_middle)**(-2.D0))
 D_middle=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 D_limit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_upper)**(-2.D0))
 D_upper=D_limit

D_limit=fp_dist_i(i)/1.D3

IF ((D_limit>D_lower).AND.(D_limit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((D_limit>D_middle).AND.(D_limit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! i',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do



z_fp_i(i)=z_limit
fp_cdist_i(i)=fp_dist_i(i)*(1+z_limit)
fp_ldist_i(i)=fp_dist_i(i)*(1+z_limit)*(1+z_limit)

! D_limit=fp_dist_z(i)/1.D3
! t1=(light**2)*q0-(light**2)
! t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
! t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
! t2=SQRT(t2)
! t3=light*D_limit*H0*q0
! z_limit=1/(light**2)*(t1+t2+t3)







 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 D_limit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_lower)**(-2.D0))
 D_lower=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 D_limit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_middle)**(-2.D0))
 D_middle=D_limit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 D_limit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 D_limit=D_limit*((1.D0+z_upper)**(-2.D0))
 D_upper=D_limit

D_limit=fp_dist_z(i)/1.D3

IF ((D_limit>D_lower).AND.(D_limit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((D_limit>D_middle).AND.(D_limit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! z',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do



z_fp_z(i)=z_limit
fp_cdist_z(i)=fp_dist_z(i)*(1+z_limit)
fp_ldist_z(i)=fp_dist_z(i)*(1+z_limit)*(1+z_limit)

END IF
END DO


DO i=1,n
IF (partpresel(i)) THEN

vpec_g(i)=(fp_cdist_g(i)-distance(i)*(1+z_cor(i)))*H0/1000.D0 !Mpc
vpec_r(i)=(fp_cdist_r(i)-distance(i)*(1+z_cor(i)))*H0/1000.D0 !Mpc
vpec_i(i)=(fp_cdist_i(i)-distance(i)*(1+z_cor(i)))*H0/1000.D0 !Mpc
vpec_z(i)=(fp_cdist_z(i)-distance(i)*(1+z_cor(i)))*H0/1000.D0 !Mpc
END IF
END DO


!total

fp_dist_err_g=0.D0
fp_dist_err_r=0.D0
fp_dist_err_i=0.D0
fp_dist_err_z=0.D0

DO i=1,n
IF (active(i)) THEN
! fp_dist_err_u=fp_dist_err_u+((distance(i)*(1+z_cor(i))-fp_dist_u(i))/(distance(i)*(1+z_cor(i))))**2
! fp_dist_err_g=fp_dist_err_g+((distance(i)*(1+z_cor(i))-fp_dist_g(i))/(distance(i)*(1+z_cor(i))))**2
! fp_dist_err_r=fp_dist_err_r+((distance(i)*(1+z_cor(i))-fp_dist_r(i))/(distance(i)*(1+z_cor(i))))**2
! fp_dist_err_i=fp_dist_err_i+((distance(i)*(1+z_cor(i))-fp_dist_i(i))/(distance(i)*(1+z_cor(i))))**2
! fp_dist_err_z=fp_dist_err_z+((distance(i)*(1+z_cor(i))-fp_dist_z(i))/(distance(i)*(1+z_cor(i))))**2

fp_dist_err_g=fp_dist_err_g+((distance(i)-fp_dist_g(i))/(distance(i)))**2
fp_dist_err_r=fp_dist_err_r+((distance(i)-fp_dist_r(i))/(distance(i)))**2
fp_dist_err_i=fp_dist_err_i+((distance(i)-fp_dist_i(i))/(distance(i)))**2
fp_dist_err_z=fp_dist_err_z+((distance(i)-fp_dist_z(i))/(distance(i)))**2
END IF
END DO


fp_dist_err_g=SQRT(fp_dist_err_g/DBLE(galactive))
fp_dist_err_r=SQRT(fp_dist_err_r/DBLE(galactive))
fp_dist_err_i=SQRT(fp_dist_err_i/DBLE(galactive))
fp_dist_err_z=SQRT(fp_dist_err_z/DBLE(galactive))





OPEN(61,file='fp_distances/fp_z.txt')
WRITE(61,*) 'N  |','ID  |','d_fp_a [Mpc]  |','d_fp_c [Mpc]  |','d_fp_l [Mpc]  |'
DO i=1,n
IF (active(i)) THEN
WRITE(61,*) i,objid(i),(fp_dist_z(i)/1000.D0),(fp_cdist_z(i)/1000.D0),(fp_ldist_z(i)/1000.D0)
END IF
END DO
 CLOSE(61)

OPEN(61,file='fp_distances/n_max.txt')
WRITE(61,*) n
 CLOSE(61)

OPEN(61,file='output/fp_rel_dist_err.txt')
WRITE(61,*) fp_dist_err_g,fp_dist_err_r,fp_dist_err_i,fp_dist_err_z
 CLOSE(61)






! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0


DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


! IF (weight_switch==1) THEN
! DO i=1,n
! IF (active(i)) THEN
! weightzcor(i)=1.D0/DBLE(galactive)
! 
! weight_g(i)=volume_weight_g(i)
! weight_r(i)=volume_weight_r(i)
! weight_i(i)=volume_weight_i(i)
! weight_z(i)=volume_weight_z(i)
! END IF
! END DO
! 
! 
! END IF
! 
! 








weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN

weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO




DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)

dbar_g=dbar_g+LOG10(fp_dist_g(i)/(distance(i)))*weight_g(i)
dbar_r=dbar_r+LOG10(fp_dist_r(i)/(distance(i)))*weight_r(i)
dbar_i=dbar_i+LOG10(fp_dist_i(i)/(distance(i)))*weight_i(i)
dbar_z=dbar_z+LOG10(fp_dist_z(i)/(distance(i)))*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0


help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0


DO i=1,n
IF (active(i)) THEN

help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO


DO i=1,n
IF (active(i)) THEN

devfitk_g=devfitk_g+((z_cor(i)-zbar)*(LOG10(fp_dist_g(i)/(distance(i)))-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(LOG10(fp_dist_r(i)/(distance(i)))-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(LOG10(fp_dist_i(i)/(distance(i)))-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(LOG10(fp_dist_z(i)/(distance(i)))-dbar_z))*weight_z(i)
END IF
END DO



devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z


devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar


devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0





DO i=1,n
IF (active(i)) THEN

wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN

devRMS_g=devRMS_g+((LOG10(fp_dist_g(i)/(distance(i)))-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((LOG10(fp_dist_r(i)/(distance(i)))-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((LOG10(fp_dist_i(i)/(distance(i)))-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((LOG10(fp_dist_z(i)/(distance(i)))-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO


devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)



devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z


OPEN(61,file='output/zdep_fit_relangulardist.txt')


WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)




OPEN(61,file='output/latex_fp_parameters.txt')

WRITE(61,*) ' \begin{table*}[ht]'
WRITE(61,*) '\begin{center}'
WRITE(61,*) '\begin{tabular}{c|ccccc}'
WRITE(61,*) 'bands & $a$ & $b$ & $c$ & $s_{\varepsilon}$ & $\bar{\sigma}_{\textrm{dist}}$ [\%] \\ \hline \hline'

WRITE(61,*)  "g & $",a_g," \pm ",a_err_g,"$  & $",b_g," \pm ",b_err_g,"$  & $",c_g," \pm ",&
 c_err_g,"$ & $",rms_g,"$ & $",fp_dist_err_g*100.D0,"$\\"

WRITE(61,*)  "r & $",a_r," \pm ",a_err_r,"$  & $",b_r," \pm ",b_err_r,"$  & $",c_r," \pm ",&
 c_err_r,"$ & $",rms_r,"$ & $",fp_dist_err_r*100.D0,"$\\"

WRITE(61,*)  "i & $",a_i," \pm ",a_err_i,"$  & $",b_i," \pm ",b_err_i,"$  & $",c_i," \pm ",&
 c_err_i,"$ & $",rms_i,"$ & $",fp_dist_err_i*100.D0,"$\\"

WRITE(61,*)  "z & $",a_z," \pm ",a_err_z,"$  & $",b_z," \pm ",b_err_z,"$  & $",c_z," \pm ",&
 c_err_z,"$ & $",rms_z,"$ & $",fp_dist_err_z*100.D0,"$\\"

WRITE(61,*) '\end{tabular}'
WRITE(61,*) '\end{center}'
WRITE(61,*) '\caption{text text text}'
WRITE(61,*) '\label{fitparameters}'
WRITE(61,*) '\end{table*}'


 
 CLOSE(61)

 


WRITE(*,*) 'fundamental plane distances and error calculated'
WRITE(30,*) 'fundamental plane distances and error calculated'
!look for any redshift dependence


















V_sum_g=0.D0
V_sum_r=0.D0
V_sum_i=0.D0
V_sum_z=0.D0

DO i=1,n
IF (active(i)) THEN


D_limit=dist_k_g*magabs_g(i)+dist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_g*magabs_g(i)+dist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF



IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! g',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF
END IF



V_limit=(D_limit**3)-Vminsat
volume_weight_g(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF



IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_r(i)/TAN(rang_min_r/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! r',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_r(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

D_limit=dist_k_i*magabs_i(i)+dist_d_i
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_i*magabs_i(i)+dist_dsat_i
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_i(i)/TAN(rang_min_i/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! i',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF
END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_i(i)=1.D0/V_limit
V_sum_i=V_sum_i+1.D0/V_limit

D_limit=dist_k_z*magabs_z(i)+dist_d_z
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_z*magabs_z(i)+dist_dsat_z
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_z(i)/TAN(rang_min_z/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! z',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_z(i)=1.D0/V_limit
V_sum_z=V_sum_z+1.D0/V_limit


END IF
END DO



DO i=1,n
IF (active(i)) THEN
volume_weight_g(i)=volume_weight_g(i)/V_sum_g
volume_weight_r(i)=volume_weight_r(i)/V_sum_r
volume_weight_i(i)=volume_weight_i(i)/V_sum_i
volume_weight_z(i)=volume_weight_z(i)/V_sum_z
END IF
END DO

! WRITE(*,*) V_sum_u,V_sum_g,V_sum_r,V_sum_i,V_sum_z



!bias corrected averages 
DO i=2,5
av_r_cor(i)=0.D0
sigma_r_cor(i)=0.D0
av_sigma_cor(i)=0.D0
sigma_sigma_cor(i)=0.D0
av_mag_app(i)=0.D0
sigma_mag_app(i)=0.D0

av_logR0(i)=0.D0
sigma_logR0(i)=0.D0
av_logsigma(i)=0.D0
sigma_logsigma(i)=0.D0
av_sb(i)=0.D0
sigma_sb(i)=0.D0
END DO



DO i=1,n 
IF (active(i)) THEN
av_r_cor(2)=av_r_cor(2)+r_cor_g(i)*volume_weight_g(i)
av_r_cor(3)=av_r_cor(3)+r_cor_r(i)*volume_weight_r(i)
av_r_cor(4)=av_r_cor(4)+r_cor_i(i)*volume_weight_i(i)
av_r_cor(5)=av_r_cor(5)+r_cor_z(i)*volume_weight_z(i)

av_sigma_cor(2)=av_sigma_cor(2)+sigma_cor_g(i)*volume_weight_g(i)
av_sigma_cor(3)=av_sigma_cor(3)+sigma_cor_r(i)*volume_weight_r(i)
av_sigma_cor(4)=av_sigma_cor(4)+sigma_cor_i(i)*volume_weight_i(i)
av_sigma_cor(5)=av_sigma_cor(5)+sigma_cor_z(i)*volume_weight_z(i)

av_mag_app(2)=av_mag_app(2)+Mag_app_g(i)*volume_weight_g(i)
av_mag_app(3)=av_mag_app(3)+Mag_app_r(i)*volume_weight_r(i)
av_mag_app(4)=av_mag_app(4)+Mag_app_i(i)*volume_weight_i(i)
av_mag_app(5)=av_mag_app(5)+Mag_app_z(i)*volume_weight_z(i)

av_logR0(2)=av_logR0(2)+logR0_g(i)*volume_weight_g(i)
av_logR0(3)=av_logR0(3)+logR0_r(i)*volume_weight_r(i)
av_logR0(4)=av_logR0(4)+logR0_i(i)*volume_weight_i(i)
av_logR0(5)=av_logR0(5)+logR0_z(i)*volume_weight_z(i)

av_sb(2)=av_sb(2)-2.5D0*logI0_g(i)*volume_weight_g(i)
av_sb(3)=av_sb(3)-2.5D0*logI0_r(i)*volume_weight_r(i)
av_sb(4)=av_sb(4)-2.5D0*logI0_i(i)*volume_weight_i(i)
av_sb(5)=av_sb(5)-2.5D0*logI0_z(i)*volume_weight_z(i)


av_logsigma(2)=av_logsigma(2)+logsigma_g(i)*volume_weight_g(i)
av_logsigma(3)=av_logsigma(3)+logsigma_r(i)*volume_weight_r(i)
av_logsigma(4)=av_logsigma(4)+logsigma_i(i)*volume_weight_i(i)
av_logsigma(5)=av_logsigma(5)+logsigma_z(i)*volume_weight_z(i)


END IF
END DO





DO i=1,n 
IF (active(i)) THEN
sigma_r_cor(2)=sigma_r_cor(2)+((r_cor_g(i)-av_r_cor(2))**2)*volume_weight_g(i)
sigma_r_cor(3)=sigma_r_cor(3)+((r_cor_r(i)-av_r_cor(3))**2)*volume_weight_r(i)
sigma_r_cor(4)=sigma_r_cor(4)+((r_cor_i(i)-av_r_cor(4))**2)*volume_weight_i(i)
sigma_r_cor(5)=sigma_r_cor(5)+((r_cor_z(i)-av_r_cor(5))**2)*volume_weight_z(i)

sigma_sigma_cor(2)=sigma_sigma_cor(2)+((sigma_cor_g(i)-av_sigma_cor(2))**2)*volume_weight_g(i)
sigma_sigma_cor(3)=sigma_sigma_cor(3)+((sigma_cor_r(i)-av_sigma_cor(3))**2)*volume_weight_r(i)
sigma_sigma_cor(4)=sigma_sigma_cor(4)+((sigma_cor_i(i)-av_sigma_cor(4))**2)*volume_weight_i(i)
sigma_sigma_cor(5)=sigma_sigma_cor(5)+((sigma_cor_z(i)-av_sigma_cor(5))**2)*volume_weight_z(i)

sigma_mag_app(2)=sigma_mag_app(2)+((Mag_app_g(i)-av_mag_app(2))**2)*volume_weight_g(i)
sigma_mag_app(3)=sigma_mag_app(3)+((Mag_app_r(i)-av_mag_app(3))**2)*volume_weight_r(i)
sigma_mag_app(4)=sigma_mag_app(4)+((Mag_app_i(i)-av_mag_app(4))**2)*volume_weight_i(i)
sigma_mag_app(5)=sigma_mag_app(5)+((Mag_app_z(i)-av_mag_app(5))**2)*volume_weight_z(i)

sigma_logR0(2)=sigma_logR0(2)+((logR0_g(i)-av_logR0(2))**2)*volume_weight_g(i)
sigma_logR0(3)=sigma_logR0(3)+((logR0_r(i)-av_logR0(3))**2)*volume_weight_r(i)
sigma_logR0(4)=sigma_logR0(4)+((logR0_i(i)-av_logR0(4))**2)*volume_weight_i(i)
sigma_logR0(5)=sigma_logR0(5)+((logR0_z(i)-av_logR0(5))**2)*volume_weight_z(i)

sigma_sb(2)=sigma_sb(2)+((-2.5D0*logI0_g(i)-av_sb(2))**2)*volume_weight_g(i)
sigma_sb(3)=sigma_sb(3)+((-2.5D0*logI0_r(i)-av_sb(3))**2)*volume_weight_r(i)
sigma_sb(4)=sigma_sb(4)+((-2.5D0*logI0_i(i)-av_sb(4))**2)*volume_weight_i(i)
sigma_sb(5)=sigma_sb(5)+((-2.5D0*logI0_z(i)-av_sb(5))**2)*volume_weight_z(i)

sigma_logsigma(2)=sigma_logsigma(2)+((logsigma_g(i)-av_logsigma(2))**2)*volume_weight_g(i)
sigma_logsigma(3)=sigma_logsigma(3)+((logsigma_r(i)-av_logsigma(3))**2)*volume_weight_r(i)
sigma_logsigma(4)=sigma_logsigma(4)+((logsigma_i(i)-av_logsigma(4))**2)*volume_weight_i(i)
sigma_logsigma(5)=sigma_logsigma(5)+((logsigma_z(i)-av_logsigma(5))**2)*volume_weight_z(i)


END IF
END DO




DO i=2,5
sigma_r_cor(i)=SQRT(sigma_r_cor(i))
sigma_sigma_cor(i)=SQRT(sigma_sigma_cor(i))
sigma_mag_app(i)=SQRT(sigma_mag_app(i))
sigma_logR0(i)=SQRT(sigma_logR0(i))
sigma_logsigma(i)=SQRT(sigma_logsigma(i))
sigma_sb(i)=SQRT(sigma_sb(i))
END DO




OPEN(61,file='output/biascor_averages.txt')

WRITE(61,*) av_r_cor(2:5)
WRITE(61,*) sigma_r_cor(2:5)

WRITE(61,*) av_sigma_cor(2:5)
WRITE(61,*) sigma_sigma_cor(2:5)

WRITE(61,*) av_mag_app(2:5)
WRITE(61,*) sigma_mag_app(2:5)

WRITE(61,*) av_logR0(2:5)
WRITE(61,*) sigma_logR0(2:5)

WRITE(61,*) av_sb(2:5)
WRITE(61,*) sigma_sb(2:5)

WRITE(61,*) av_logsigma(2:5)
WRITE(61,*) sigma_logsigma(2:5)

 CLOSE(61)

OPEN(61,file='output/latex_biascor_averages.txt')

WRITE(61,*) "$\bar{r}_{\textrm{cor}}$ [arcsec] & ",&
av_r_cor(2)," & ",av_r_cor(3)," & ",av_r_cor(4)," & ",av_r_cor(5)," \\"
WRITE(61,*) "$\sigma_{r_{\textrm{cor}}}$ [arcsec] & ",&
sigma_r_cor(2)," & ",sigma_r_cor(3)," & ",sigma_r_cor(4)," & ",sigma_r_cor(5),"\\"
WRITE(61,*) "$\bar{m}_{\textrm{app}}$ [mag] & ",&
av_mag_app(2)," & ",av_mag_app(3)," & ",av_mag_app(4)," & ",av_mag_app(5),"\\"
WRITE(61,*) "$\sigma_{m_{\textrm{app}}}$ [mag] & ",&
sigma_mag_app(2)," & ",sigma_mag_app(3)," & ",sigma_mag_app(4)," & ",sigma_mag_app(5),"\\"
WRITE(61,*) "$\bar{\sigma}_{0}$ [km/s] & ",&
av_sigma_cor(2)," & ",av_sigma_cor(3)," & ",av_sigma_cor(4)," & ",av_sigma_cor(5),"\\"
WRITE(61,*) "$\sigma_{\sigma_{0}}$ [km/s] & ",&
sigma_sigma_cor(2)," & ",sigma_sigma_cor(3)," & ",sigma_sigma_cor(4)," & ",sigma_sigma_cor(5),"\\"
WRITE(61,*) "$\overline{\textrm{log}_{10}(R_{0})}$ [$\textrm{log}_{10}(\textrm{kpc})$] & ",&
av_logR0(2)," & ",av_logR0(3)," & ",av_logR0(4)," & ",av_logR0(5)," \\"
WRITE(61,*) "$\sigma_{\textrm{log}_{10}(R_{0})}$ [$\textrm{log}_{10}(\textrm{kpc})$] & ",&
sigma_logR0(2)," & ",sigma_logR0(3)," & ",sigma_logR0(4)," & ",sigma_logR0(5),"\\"
WRITE(61,*) "$\bar{\mu}_{0}$ [mag/arcsec$^2$] & ",&
av_sb(2)," & ",av_sb(3)," & ",av_sb(4)," & ",av_sb(5)," \\"
WRITE(61,*) "$\sigma_{\mu_{0}}$ [mag/arcsec$^2$] & ",&
sigma_sb(2)," & ",sigma_sb(3)," & ",sigma_sb(4)," & ",sigma_sb(5),"\\"
WRITE(61,*) "$\overline{\textrm{log}_{10}(\sigma_{0})}$ [$\textrm{log}_{10}(\textrm{km/s})$] & ",&
av_logsigma(2)," & ",av_logsigma(3)," & ",av_logsigma(4)," & ",av_logsigma(5)," \\"
WRITE(61,*) "$\sigma_{\textrm{log}_{10}(\sigma_{0})}$ [$\textrm{log}_{10}(\textrm{km/s})$] & ",&
sigma_logsigma(2)," & ",sigma_logsigma(3)," & ",sigma_logsigma(4)," & ",sigma_logsigma(5),"\\"



 CLOSE(61)




WRITE(*,*) 'bias corrected averages and standard deviations calculated'
WRITE(30,*) 'bias corrected averages and standard deviations calculated'



! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0




DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)
weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)
weight_g(i)=volume_weight_g(i)
weight_r(i)=volume_weight_r(i)
weight_i(i)=volume_weight_i(i)
weight_z(i)=volume_weight_z(i)
END IF
END DO


END IF



weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN
weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO



DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)
dbar_g=dbar_g+logR0_g(i)*weight_g(i)
dbar_r=dbar_r+logR0_r(i)*weight_r(i)
dbar_i=dbar_i+logR0_i(i)*weight_i(i)
dbar_z=dbar_z+logR0_z(i)*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values_logR0.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0


help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN
help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO


DO i=1,n
IF (active(i)) THEN
devfitk_g=devfitk_g+((z_cor(i)-zbar)*(logR0_g(i)-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(logR0_r(i)-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(logR0_i(i)-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(logR0_z(i)-dbar_z))*weight_z(i)
END IF
END DO

! devfitk_u=devfitk_u*(1.D0/(1.D0-weight_sum2_u))
! devfitk_g=devfitk_g*(1.D0/(1.D0-weight_sum2_g))
! devfitk_r=devfitk_r*(1.D0/(1.D0-weight_sum2_r))
! devfitk_i=devfitk_i*(1.D0/(1.D0-weight_sum2_i))
! devfitk_z=devfitk_z*(1.D0/(1.D0-weight_sum2_z))




devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z


devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar


devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0




DO i=1,n
IF (active(i)) THEN

wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN
devRMS_g=devRMS_g+((logR0_g(i)-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((logR0_r(i)-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((logR0_i(i)-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((logR0_z(i)-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO

devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)


devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z


OPEN(61,file='output/zdep_fit_logR0.txt')

WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)


OPEN(61,file='output/zdep_fit_logR0_shell.txt')


WRITE(61,*) 'kg=',devfitk_g
WRITE(61,*) 'dg=',devfitd_g
WRITE(61,*) 'kr=',devfitk_r
WRITE(61,*) 'dr=',devfitd_r
WRITE(61,*) 'ki=',devfitk_i
WRITE(61,*) 'di=',devfitd_i
WRITE(61,*) 'kz=',devfitk_z
WRITE(61,*) 'dz=',devfitd_z

WRITE(61,*) 'av_g=',dbar_g
WRITE(61,*) 'av_r=',dbar_r
WRITE(61,*) 'av_i=',dbar_i
WRITE(61,*) 'av_z=',dbar_z

 CLOSE(61)









! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0




DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=volume_weight_g(i)
weight_r(i)=volume_weight_r(i)
weight_i(i)=volume_weight_i(i)
weight_z(i)=volume_weight_z(i)
END IF
END DO


END IF






weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN

weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO



DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)

dbar_g=dbar_g-2.5D0*logI0_g(i)*weight_g(i)
dbar_r=dbar_r-2.5D0*logI0_r(i)*weight_r(i)
dbar_i=dbar_i-2.5D0*logI0_i(i)*weight_i(i)
dbar_z=dbar_z-2.5D0*logI0_z(i)*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values_sb.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0



help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0


DO i=1,n
IF (active(i)) THEN
help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO


DO i=1,n
IF (active(i)) THEN
devfitk_g=devfitk_g+((z_cor(i)-zbar)*(-2.5D0*logI0_g(i)-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(-2.5D0*logI0_r(i)-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(-2.5D0*logI0_i(i)-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(-2.5D0*logI0_z(i)-dbar_z))*weight_z(i)
END IF
END DO


! devfitk_u=devfitk_u*(1.D0/(1.D0-weight_sum2_u))
! devfitk_g=devfitk_g*(1.D0/(1.D0-weight_sum2_g))
! devfitk_r=devfitk_r*(1.D0/(1.D0-weight_sum2_r))
! devfitk_i=devfitk_i*(1.D0/(1.D0-weight_sum2_i))
! devfitk_z=devfitk_z*(1.D0/(1.D0-weight_sum2_z))




devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z



devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar


devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0






DO i=1,n
IF (active(i)) THEN
wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN

devRMS_g=devRMS_g+((-2.5D0*logI0_g(i)-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((-2.5D0*logI0_r(i)-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((-2.5D0*logI0_i(i)-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((-2.5D0*logI0_z(i)-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO


devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)







devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z


OPEN(61,file='output/zdep_fit_sb.txt')


WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)


OPEN(61,file='output/zdep_fit_sb_shell.txt')


WRITE(61,*) 'kg=',devfitk_g
WRITE(61,*) 'dg=',devfitd_g
WRITE(61,*) 'kr=',devfitk_r
WRITE(61,*) 'dr=',devfitd_r
WRITE(61,*) 'ki=',devfitk_i
WRITE(61,*) 'di=',devfitd_i
WRITE(61,*) 'kz=',devfitk_z
WRITE(61,*) 'dz=',devfitd_z

WRITE(61,*) 'av_g=',dbar_g
WRITE(61,*) 'av_r=',dbar_r
WRITE(61,*) 'av_i=',dbar_i
WRITE(61,*) 'av_z=',dbar_z

 CLOSE(61)









! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0



DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=volume_weight_g(i)
weight_r(i)=volume_weight_r(i)
weight_i(i)=volume_weight_i(i)
weight_z(i)=volume_weight_z(i)
END IF
END DO


END IF



weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN

weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO





DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)

dbar_g=dbar_g+logsigma_g(i)*weight_g(i)
dbar_r=dbar_r+logsigma_r(i)*weight_r(i)
dbar_i=dbar_i+logsigma_i(i)*weight_i(i)
dbar_z=dbar_z+logsigma_z(i)*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values_logsigma.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0

help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0


DO i=1,n
IF (active(i)) THEN

help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO




DO i=1,n
IF (active(i)) THEN

devfitk_g=devfitk_g+((z_cor(i)-zbar)*(logsigma_g(i)-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(logsigma_r(i)-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(logsigma_i(i)-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(logsigma_z(i)-dbar_z))*weight_z(i)
END IF
END DO


! devfitk_u=devfitk_u*(1.D0/(1.D0-weight_sum2_u))
! devfitk_g=devfitk_g*(1.D0/(1.D0-weight_sum2_g))
! devfitk_r=devfitk_r*(1.D0/(1.D0-weight_sum2_r))
! devfitk_i=devfitk_i*(1.D0/(1.D0-weight_sum2_i))
! devfitk_z=devfitk_z*(1.D0/(1.D0-weight_sum2_z))


devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z


devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar


devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0




DO i=1,n
IF (active(i)) THEN

wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN

devRMS_g=devRMS_g+((logsigma_g(i)-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((logsigma_r(i)-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((logsigma_i(i)-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((logsigma_z(i)-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO


devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)






devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z



OPEN(61,file='output/zdep_fit_logsigma.txt')


WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)


OPEN(61,file='output/zdep_fit_logsigma_shell.txt')


WRITE(61,*) 'kg=',devfitk_g
WRITE(61,*) 'dg=',devfitd_g
WRITE(61,*) 'kr=',devfitk_r
WRITE(61,*) 'dr=',devfitd_r
WRITE(61,*) 'ki=',devfitk_i
WRITE(61,*) 'di=',devfitd_i
WRITE(61,*) 'kz=',devfitk_z
WRITE(61,*) 'dz=',devfitd_z
WRITE(61,*) 'av_g=',dbar_g
WRITE(61,*) 'av_r=',dbar_r
WRITE(61,*) 'av_i=',dbar_i
WRITE(61,*) 'av_z=',dbar_z

 CLOSE(61)







! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0


DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)
weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)
weight_g(i)=volume_weight_g(i)
weight_r(i)=volume_weight_r(i)
weight_i(i)=volume_weight_i(i)
weight_z(i)=volume_weight_z(i)
END IF
END DO


END IF




weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN
weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO




DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)
dbar_g=dbar_g+magabs_g(i)*weight_g(i)
dbar_r=dbar_r+magabs_r(i)*weight_r(i)
dbar_i=dbar_i+magabs_i(i)*weight_i(i)
dbar_z=dbar_z+magabs_z(i)*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values_magabs.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0


help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0


DO i=1,n
IF (active(i)) THEN

help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO



DO i=1,n
IF (active(i)) THEN

devfitk_g=devfitk_g+((z_cor(i)-zbar)*(magabs_g(i)-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(magabs_r(i)-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(magabs_i(i)-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(magabs_z(i)-dbar_z))*weight_z(i)
END IF
END DO


! devfitk_u=devfitk_u*(1.D0/(1.D0-weight_sum2_u))
! devfitk_g=devfitk_g*(1.D0/(1.D0-weight_sum2_g))
! devfitk_r=devfitk_r*(1.D0/(1.D0-weight_sum2_r))
! devfitk_i=devfitk_i*(1.D0/(1.D0-weight_sum2_i))
! devfitk_z=devfitk_z*(1.D0/(1.D0-weight_sum2_z))



devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z



devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar

devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0


DO i=1,n
IF (active(i)) THEN
wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN
devRMS_g=devRMS_g+((magabs_g(i)-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((magabs_r(i)-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((magabs_i(i)-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((magabs_z(i)-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO

devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)







devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z



OPEN(61,file='output/zdep_fit_magabs.txt')

WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)


OPEN(61,file='output/zdep_fit_magabs_shell.txt')

WRITE(61,*) 'kg=',devfitk_g
WRITE(61,*) 'dg=',devfitd_g
WRITE(61,*) 'kr=',devfitk_r
WRITE(61,*) 'dr=',devfitd_r
WRITE(61,*) 'ki=',devfitk_i
WRITE(61,*) 'di=',devfitd_i
WRITE(61,*) 'kz=',devfitk_z
WRITE(61,*) 'dz=',devfitd_z
WRITE(61,*) 'av_g=',dbar_g
WRITE(61,*) 'av_r=',dbar_r
WRITE(61,*) 'av_i=',dbar_i
WRITE(61,*) 'av_z=',dbar_z

 CLOSE(61)





!limiting magnitudes 


helpflip=dist_d_g+dist_k_g*dbar_g
mlimit_g=dbar_g+5.D0*helpflip-5.D0

helpflip=dist_d_r+dist_k_r*dbar_r
mlimit_r=dbar_r+5.D0*helpflip-5.D0

helpflip=dist_d_i+dist_k_i*dbar_i
mlimit_i=dbar_i+5.D0*helpflip-5.D0

helpflip=dist_d_z+dist_k_z*dbar_z
mlimit_z=dbar_z+5.D0*helpflip-5.D0


OPEN(61,file='output/limit_magnitudes.txt')

WRITE(61,*) mlimit_g,mlimit_r,mlimit_i,mlimit_z


 CLOSE(61)








! do linear fit for dependence
zbar=0.D0

dbar_g=0.D0
dbar_r=0.D0
dbar_i=0.D0
dbar_z=0.D0


DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=1.D0/DBLE(galactive)
weight_r(i)=1.D0/DBLE(galactive)
weight_i(i)=1.D0/DBLE(galactive)
weight_z(i)=1.D0/DBLE(galactive)
END IF
END DO


IF (weight_switch==1) THEN
DO i=1,n
IF (active(i)) THEN
weightzcor(i)=1.D0/DBLE(galactive)

weight_g(i)=volume_weight_g(i)
weight_r(i)=volume_weight_r(i)
weight_i(i)=volume_weight_i(i)
weight_z(i)=volume_weight_z(i)
END IF
END DO


END IF










weight_sum2_g=0.D0
weight_sum2_r=0.D0
weight_sum2_i=0.D0
weight_sum2_z=0.D0

DO i=1,n
IF (active(i)) THEN

weight_sum2_g=weight_sum2_g+(weight_g(i)**2)
weight_sum2_r=weight_sum2_r+(weight_r(i)**2)
weight_sum2_i=weight_sum2_i+(weight_i(i)**2)
weight_sum2_z=weight_sum2_z+(weight_z(i)**2)
END IF
END DO




DO i=1,n
IF (active(i)) THEN
zbar=zbar+z_cor(i)*weightzcor(i)

dbar_g=dbar_g+deviation_g(i)*weight_g(i)
dbar_r=dbar_r+deviation_r(i)*weight_r(i)
dbar_i=dbar_i+deviation_i(i)*weight_i(i)
dbar_z=dbar_z+deviation_z(i)*weight_z(i)
END IF
END DO



OPEN(61,file='output/zdep_average_values.txt')
WRITE(61,*) zbar,dbar_g,dbar_r,dbar_i,dbar_z
 CLOSE(61)


devfitk_g=0.D0
devfitk_r=0.D0
devfitk_i=0.D0
devfitk_z=0.D0


help_sum2_g=0.D0
help_sum2_r=0.D0
help_sum2_i=0.D0
help_sum2_z=0.D0


DO i=1,n
IF (active(i)) THEN

help_sum2_g=help_sum2_g+((z_cor(i)-zbar)**2.D0)*weight_g(i)
help_sum2_r=help_sum2_r+((z_cor(i)-zbar)**2.D0)*weight_r(i)
help_sum2_i=help_sum2_i+((z_cor(i)-zbar)**2.D0)*weight_i(i)
help_sum2_z=help_sum2_z+((z_cor(i)-zbar)**2.D0)*weight_z(i)
END IF
END DO


DO i=1,n
IF (active(i)) THEN

devfitk_g=devfitk_g+((z_cor(i)-zbar)*(deviation_g(i)-dbar_g))*weight_g(i)
devfitk_r=devfitk_r+((z_cor(i)-zbar)*(deviation_r(i)-dbar_r))*weight_r(i)
devfitk_i=devfitk_i+((z_cor(i)-zbar)*(deviation_i(i)-dbar_i))*weight_i(i)
devfitk_z=devfitk_z+((z_cor(i)-zbar)*(deviation_z(i)-dbar_z))*weight_z(i)
END IF
END DO



devfitk_g=devfitk_g/help_sum2_g
devfitk_r=devfitk_r/help_sum2_r
devfitk_i=devfitk_i/help_sum2_i
devfitk_z=devfitk_z/help_sum2_z


devfitd_g=dbar_g-devfitk_g*zbar
devfitd_r=dbar_r-devfitk_r*zbar
devfitd_i=dbar_i-devfitk_i*zbar
devfitd_z=dbar_z-devfitk_z*zbar


devRMS_g=0.D0
devRMS_r=0.D0
devRMS_i=0.D0
devRMS_z=0.D0





DO i=1,n
IF (active(i)) THEN

wrms_g(i)=1.D0/DBLE(galactive)
wrms_r(i)=1.D0/DBLE(galactive)
wrms_i(i)=1.D0/DBLE(galactive)
wrms_z(i)=1.D0/DBLE(galactive)
END IF
END DO





DO i=1,n
IF (active(i)) THEN

devRMS_g=devRMS_g+((deviation_g(i)-devfitk_g*z_cor(i)-devfitd_g)**2.D0)*wrms_g(i)
devRMS_r=devRMS_r+((deviation_r(i)-devfitk_r*z_cor(i)-devfitd_r)**2.D0)*wrms_r(i)
devRMS_i=devRMS_i+((deviation_i(i)-devfitk_i*z_cor(i)-devfitd_i)**2.D0)*wrms_i(i)
devRMS_z=devRMS_z+((deviation_z(i)-devfitk_z*z_cor(i)-devfitd_z)**2.D0)*wrms_z(i)
END IF
END DO


devRMS_g=SQRT(devRMS_g)
devRMS_r=SQRT(devRMS_r)
devRMS_i=SQRT(devRMS_i)
devRMS_z=SQRT(devRMS_z)



devfitk_g=devfitk_g
devfitk_r=devfitk_r
devfitk_i=devfitk_i
devfitk_z=devfitk_z


OPEN(61,file='output/zdep_fit.txt')


WRITE(61,*) devfitk_g,devfitd_g,devRMS_g
WRITE(61,*) devfitk_r,devfitd_r,devRMS_r
WRITE(61,*) devfitk_i,devfitd_i,devRMS_i
WRITE(61,*) devfitk_z,devfitd_z,devRMS_z

 CLOSE(61)


OPEN(61,file='output/zdep_fit_shell.txt')


WRITE(61,*) 'kg=',devfitk_g
WRITE(61,*) 'dg=',devfitd_g
WRITE(61,*) 'kr=',devfitk_r
WRITE(61,*) 'dr=',devfitd_r
WRITE(61,*) 'ki=',devfitk_i
WRITE(61,*) 'di=',devfitd_i
WRITE(61,*) 'kz=',devfitk_z
WRITE(61,*) 'dz=',devfitd_z
WRITE(61,*) 'av_g=',dbar_g
WRITE(61,*) 'av_r=',dbar_r
WRITE(61,*) 'av_i=',dbar_i
WRITE(61,*) 'av_z=',dbar_z


 CLOSE(61)











WRITE(*,*) 'output for potential z-dependences written'
WRITE(30,*) 'output for potential z-dependences written'


!logsigma-binned numbers

DO i=0,60

logsigma0_bin_g(i)=0
logsigma0_bin_r(i)=0
logsigma0_bin_i(i)=0
logsigma0_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,60
binhelp=DBLE(ii)/100.D0+2.D0

IF ((logsigma_g(i)>(binhelp-0.005)).AND.(logsigma_g(i)<(binhelp+0.005))) THEN
logsigma0_bin_g(ii)=logsigma0_bin_g(ii)+1
END IF
IF ((logsigma_r(i)>(binhelp-0.005)).AND.(logsigma_r(i)<(binhelp+0.005))) THEN
logsigma0_bin_r(ii)=logsigma0_bin_r(ii)+1
END IF
IF ((logsigma_i(i)>(binhelp-0.005)).AND.(logsigma_i(i)<(binhelp+0.005))) THEN
logsigma0_bin_i(ii)=logsigma0_bin_i(ii)+1
END IF
IF ((logsigma_z(i)>(binhelp-0.005)).AND.(logsigma_z(i)<(binhelp+0.005))) THEN
logsigma0_bin_z(ii)=logsigma0_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/logsigma_binned.txt')
DO i=0,60
binhelp=DBLE(i)/100.D0+2.D0
WRITE(70,*) binhelp,logsigma0_bin_g(i),logsigma0_bin_r(i),logsigma0_bin_i(i),logsigma0_bin_z(i)
END DO
 CLOSE (70)



!logI0-binned numbers

DO i=0,60

logI0_bin_g(i)=0
logI0_bin_r(i)=0
logI0_bin_i(i)=0
logI0_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,60
binhelp=DBLE(ii)/10.D0-12.5D0

IF ((logI0_g(i)>(binhelp-0.05)).AND.(logI0_g(i)<(binhelp+0.05))) THEN
logI0_bin_g(ii)=logI0_bin_g(ii)+1
END IF
IF ((logI0_r(i)>(binhelp-0.05)).AND.(logI0_r(i)<(binhelp+0.05))) THEN
logI0_bin_r(ii)=logI0_bin_r(ii)+1
END IF
IF ((logI0_i(i)>(binhelp-0.05)).AND.(logI0_i(i)<(binhelp+0.05))) THEN
logI0_bin_i(ii)=logI0_bin_i(ii)+1
END IF
IF ((logI0_z(i)>(binhelp-0.05)).AND.(logI0_z(i)<(binhelp+0.05))) THEN
logI0_bin_z(ii)=logI0_bin_z(ii)+1
END IF
END DO
END IF

END DO




OPEN(70,file='output/logI0_binned.txt')
DO i=0,60
binhelp=DBLE(i)/10.D0-12.5D0
WRITE(70,*) binhelp,logI0_bin_g(i),logI0_bin_r(i),logI0_bin_i(i),logI0_bin_z(i)
END DO
 CLOSE (70)





!logI0-binned numbers

DO i=0,60

mag_app_bin_g(i)=0
mag_app_bin_r(i)=0
mag_app_bin_i(i)=0
mag_app_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,60
binhelp=DBLE(ii)/5.D0+10.5D0

IF ((Mag_app_g(i)>(binhelp-0.1)).AND.(Mag_app_g(i)<(binhelp+0.1))) THEN
mag_app_bin_g(ii)=mag_app_bin_g(ii)+1
END IF
IF ((Mag_app_r(i)>(binhelp-0.1)).AND.(Mag_app_r(i)<(binhelp+0.1))) THEN
mag_app_bin_r(ii)=mag_app_bin_r(ii)+1
END IF
IF ((Mag_app_i(i)>(binhelp-0.1)).AND.(Mag_app_i(i)<(binhelp+0.1))) THEN
mag_app_bin_i(ii)=mag_app_bin_i(ii)+1
END IF
IF ((Mag_app_z(i)>(binhelp-0.1)).AND.(Mag_app_z(i)<(binhelp+0.1))) THEN
mag_app_bin_z(ii)=mag_app_bin_z(ii)+1
END IF
END DO
END IF

END DO




OPEN(70,file='output/mag_app_binned.txt')
DO i=0,60
binhelp=DBLE(i)/5.D0+10.5D0
WRITE(70,*) binhelp,mag_app_bin_g(i),mag_app_bin_r(i),mag_app_bin_i(i),mag_app_bin_z(i)
END DO
 CLOSE (70)





!logR0-binned numbers

DO i=0,70

logR0_bin_g(i)=0
logR0_bin_r(i)=0
logR0_bin_i(i)=0
logR0_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,70
binhelp=DBLE(ii)/20.D0-1.D0

IF ((logR0_g(i)>(binhelp-0.025)).AND.(logR0_g(i)<(binhelp+0.025))) THEN
logR0_bin_g(ii)=logR0_bin_g(ii)+1
END IF
IF ((logR0_r(i)>(binhelp-0.025)).AND.(logR0_r(i)<(binhelp+0.025))) THEN
logR0_bin_r(ii)=logR0_bin_r(ii)+1
END IF
IF ((logR0_i(i)>(binhelp-0.025)).AND.(logR0_i(i)<(binhelp+0.025))) THEN
logR0_bin_i(ii)=logR0_bin_i(ii)+1
END IF
IF ((logR0_z(i)>(binhelp-0.025)).AND.(logR0_z(i)<(binhelp+0.025))) THEN
logR0_bin_z(ii)=logR0_bin_z(ii)+1
END IF
END DO
END IF

END DO




OPEN(70,file='output/logR0_binned.txt')
DO i=0,70
binhelp=DBLE(i)/20.D0-1.D0
WRITE(70,*) binhelp,logR0_bin_g(i),logR0_bin_r(i),logR0_bin_i(i),logR0_bin_z(i)
END DO
 CLOSE (70)







!rcor-binned numbers

DO i=0,60

r_cor_bin_g(i)=0
r_cor_bin_r(i)=0
r_cor_bin_i(i)=0
r_cor_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,60
binhelp=DBLE(ii)/2.D0

IF ((r_cor_g(i)>(binhelp-0.25)).AND.(r_cor_g(i)<(binhelp+0.25))) THEN
r_cor_bin_g(ii)=r_cor_bin_g(ii)+1
END IF
IF ((r_cor_r(i)>(binhelp-0.25)).AND.(r_cor_r(i)<(binhelp+0.25))) THEN
r_cor_bin_r(ii)=r_cor_bin_r(ii)+1
END IF
IF ((r_cor_i(i)>(binhelp-0.25)).AND.(r_cor_i(i)<(binhelp+0.25))) THEN
r_cor_bin_i(ii)=r_cor_bin_i(ii)+1
END IF
IF ((r_cor_z(i)>(binhelp-0.25)).AND.(r_cor_z(i)<(binhelp+0.25))) THEN
r_cor_bin_z(ii)=r_cor_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/r_cor_binned.txt')
DO i=0,60
binhelp=DBLE(i)/2.D0
WRITE(70,*) binhelp,r_cor_bin_g(i),r_cor_bin_r(i),r_cor_bin_i(i),r_cor_bin_z(i)
END DO
 CLOSE (70)




!sigma_cor-binned numbers

DO i=0,50

sigma_cor_bin_g(i)=0
sigma_cor_bin_r(i)=0
sigma_cor_bin_i(i)=0
sigma_cor_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,50
binhelp=DBLE(ii)*10.D0

IF ((sigma_cor_g(i)>(binhelp-5.D0)).AND.(sigma_cor_g(i)<(binhelp+5.D0))) THEN
sigma_cor_bin_g(ii)=sigma_cor_bin_g(ii)+1
END IF
IF ((sigma_cor_r(i)>(binhelp-5.D0)).AND.(sigma_cor_r(i)<(binhelp+5.D0))) THEN
sigma_cor_bin_r(ii)=sigma_cor_bin_r(ii)+1
END IF
IF ((sigma_cor_i(i)>(binhelp-5.D0)).AND.(sigma_cor_i(i)<(binhelp+5.D0))) THEN
sigma_cor_bin_i(ii)=sigma_cor_bin_i(ii)+1
END IF
IF ((sigma_cor_z(i)>(binhelp-5.D0)).AND.(sigma_cor_z(i)<(binhelp+5.D0))) THEN
sigma_cor_bin_z(ii)=sigma_cor_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/sigma_cor_binned.txt')
DO i=0,50
binhelp=DBLE(i)*10.D0
WRITE(70,*) binhelp,sigma_cor_bin_g(i),sigma_cor_bin_r(i),sigma_cor_bin_i(i),sigma_cor_bin_z(i)
END DO
 CLOSE (70)



!I0-binned numbers

DO i=0,100

I0_bin_g(i)=0
I0_bin_r(i)=0
I0_bin_i(i)=0
I0_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,100
binhelp=DBLE(ii)*3D-9

IF ((I0_g(i)>(binhelp-1.5D-9)).AND.(I0_g(i)<(binhelp+1.5D-9))) THEN
I0_bin_g(ii)=I0_bin_g(ii)+1
END IF
IF ((I0_r(i)>(binhelp-1.5D-9)).AND.(I0_r(i)<(binhelp+1.5D-9))) THEN
I0_bin_r(ii)=I0_bin_r(ii)+1
END IF
IF ((I0_i(i)>(binhelp-1.5D-9)).AND.(I0_i(i)<(binhelp+1.5D-9))) THEN
I0_bin_i(ii)=I0_bin_i(ii)+1
END IF
IF ((I0_z(i)>(binhelp-1.5D-9)).AND.(I0_z(i)<(binhelp+1.5D-9))) THEN
I0_bin_z(ii)=I0_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/I0_binned.txt')
DO i=0,100
binhelp=DBLE(i)*3D-9
WRITE(70,*) binhelp,I0_bin_g(i),I0_bin_r(i),I0_bin_i(i),I0_bin_z(i)
END DO
 CLOSE (70)





!R0-binned numbers

DO i=0,75

R0_bin_g(i)=0
R0_bin_r(i)=0
R0_bin_i(i)=0
R0_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,75
binhelp=DBLE(ii)/5.D0

IF ((R0_g(i)>(binhelp-0.1D0)).AND.(R0_g(i)<(binhelp+0.1D0))) THEN
R0_bin_g(ii)=R0_bin_g(ii)+1
END IF
IF ((R0_r(i)>(binhelp-0.1D0)).AND.(R0_r(i)<(binhelp+0.1D0))) THEN
R0_bin_r(ii)=R0_bin_r(ii)+1
END IF
IF ((R0_i(i)>(binhelp-0.1D0)).AND.(R0_i(i)<(binhelp+0.1D0))) THEN
R0_bin_i(ii)=R0_bin_i(ii)+1
END IF
IF ((R0_z(i)>(binhelp-0.1D0)).AND.(R0_z(i)<(binhelp+0.1D0))) THEN
R0_bin_z(ii)=R0_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/R0_binned.txt')
DO i=0,75
binhelp=DBLE(i)/5.D0
WRITE(70,*) binhelp,R0_bin_g(i),R0_bin_r(i),R0_bin_i(i),R0_bin_z(i)
END DO
 CLOSE (70)




!surface brightness-binned numbers

DO i=0,80

mag_bin_g(i)=0
mag_bin_r(i)=0
mag_bin_i(i)=0
mag_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,80
binhelp=15.5D0+DBLE(ii)/5.D0

IF (((-2.5D0*logI0_g(i))>(binhelp-0.1D0)).AND.((-2.5D0*logI0_g(i))<(binhelp+0.1D0))) THEN
mag_bin_g(ii)=mag_bin_g(ii)+1
END IF
IF (((-2.5D0*logI0_r(i))>(binhelp-0.1D0)).AND.((-2.5D0*logI0_r(i))<(binhelp+0.1D0))) THEN
mag_bin_r(ii)=mag_bin_r(ii)+1
END IF
IF (((-2.5D0*logI0_i(i))>(binhelp-0.1D0)).AND.((-2.5D0*logI0_i(i))<(binhelp+0.1D0))) THEN
mag_bin_i(ii)=mag_bin_i(ii)+1
END IF
IF (((-2.5D0*logI0_z(i))>(binhelp-0.1D0)).AND.((-2.5D0*logI0_z(i))<(binhelp+0.1D0))) THEN
mag_bin_z(ii)=mag_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/sb_binned.txt')
DO i=0,80
binhelp=15.5D0+DBLE(i)/5.D0
WRITE(70,*) binhelp,mag_bin_g(i),mag_bin_r(i),mag_bin_i(i),mag_bin_z(i)
END DO
 CLOSE (70)





!absmag-binned numbers

DO i=0,50

magabs_bin_g(i)=0
magabs_bin_r(i)=0
magabs_bin_i(i)=0
magabs_bin_z(i)=0
END DO

DO i=1,n

IF (active(i)) THEN
DO ii=0,50
binhelp=-15.D0-DBLE(ii)/5.D0

IF ((magabs_g(i)>(binhelp-0.1D0)).AND.(magabs_g(i)<(binhelp+0.1D0))) THEN
magabs_bin_g(ii)=magabs_bin_g(ii)+1
END IF
IF ((magabs_r(i)>(binhelp-0.1D0)).AND.(magabs_r(i)<(binhelp+0.1D0))) THEN
magabs_bin_r(ii)=magabs_bin_r(ii)+1
END IF
IF ((magabs_i(i)>(binhelp-0.1D0)).AND.(magabs_i(i)<(binhelp+0.1D0))) THEN
magabs_bin_i(ii)=magabs_bin_i(ii)+1
END IF
IF ((magabs_z(i)>(binhelp-0.1D0)).AND.(magabs_z(i)<(binhelp+0.1D0))) THEN
magabs_bin_z(ii)=magabs_bin_z(ii)+1
END IF
END DO
END IF

END DO


OPEN(70,file='output/magabs_binned.txt')
DO i=0,50
binhelp=-15.D0-DBLE(i)/5.D0
WRITE(70,*) binhelp,magabs_bin_g(i),magabs_bin_r(i),magabs_bin_i(i),magabs_bin_z(i)
END DO
 CLOSE (70)






!absmag-binned numbers2

DO i=0,50
DO ii=1,3

magabsz_largebin_g(i,ii)=0
magabsz_largebin_r(i,ii)=0
magabsz_largebin_i(i,ii)=0
magabsz_largebin_z(i,ii)=0
END DO
END DO

DO i=1,3
intz(i)=0
END DO

IF (autosplit==0) THEN

DO i=1,n

IF (active(i)) THEN
DO ii=0,50
binhelp=-15.D0-DBLE(ii)/5.D0

IF (z_cor(i)<split1) THEN
intz(1)=intz(1)+1

IF ((magabs_g(i)>(binhelp-0.1D0)).AND.(magabs_g(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_g(ii,1)=magabsz_largebin_g(ii,1)+1
END IF
IF ((magabs_r(i)>(binhelp-0.1D0)).AND.(magabs_r(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_r(ii,1)=magabsz_largebin_r(ii,1)+1
END IF
IF ((magabs_i(i)>(binhelp-0.1D0)).AND.(magabs_i(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_i(ii,1)=magabsz_largebin_i(ii,1)+1
END IF
IF ((magabs_z(i)>(binhelp-0.1D0)).AND.(magabs_z(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_z(ii,1)=magabsz_largebin_z(ii,1)+1
END IF
END IF

IF ((z_cor(i)>split1).AND.(z_cor(i)<split2)) THEN
intz(2)=intz(2)+1

IF ((magabs_g(i)>(binhelp-0.1D0)).AND.(magabs_g(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_g(ii,2)=magabsz_largebin_g(ii,2)+1
END IF
IF ((magabs_r(i)>(binhelp-0.1D0)).AND.(magabs_r(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_r(ii,2)=magabsz_largebin_r(ii,2)+1
END IF
IF ((magabs_i(i)>(binhelp-0.1D0)).AND.(magabs_i(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_i(ii,2)=magabsz_largebin_i(ii,2)+1
END IF
IF ((magabs_z(i)>(binhelp-0.1D0)).AND.(magabs_z(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_z(ii,2)=magabsz_largebin_z(ii,2)+1
END IF
END IF

IF (z_cor(i)>split2) THEN
intz(3)=intz(3)+1

IF ((magabs_g(i)>(binhelp-0.1D0)).AND.(magabs_g(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_g(ii,3)=magabsz_largebin_g(ii,3)+1
END IF
IF ((magabs_r(i)>(binhelp-0.1D0)).AND.(magabs_r(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_r(ii,3)=magabsz_largebin_r(ii,3)+1
END IF
IF ((magabs_i(i)>(binhelp-0.1D0)).AND.(magabs_i(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_i(ii,3)=magabsz_largebin_i(ii,3)+1
END IF
IF ((magabs_z(i)>(binhelp-0.1D0)).AND.(magabs_z(i)<(binhelp+0.1D0))) THEN
magabsz_largebin_z(ii,3)=magabsz_largebin_z(ii,3)+1
END IF
END IF



END DO
END IF

END DO



END IF


DO i=1,3
intz(i)=intz(i)/51
END DO



OPEN(70,file='output/magabsz_largebinned_g.txt')
DO i=0,50
binhelp=-15.D0-DBLE(i)/5.D0
WRITE(70,*) binhelp,magabsz_largebin_g(i,1),magabsz_largebin_g(i,2),magabsz_largebin_g(i,3)
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_largebinned_r.txt')
DO i=0,50
binhelp=-15.D0-DBLE(i)/5.D0
WRITE(70,*) binhelp,magabsz_largebin_r(i,1),magabsz_largebin_r(i,2),magabsz_largebin_r(i,3)
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_largebinned_i.txt')
DO i=0,50
binhelp=-15.D0-DBLE(i)/5.D0
WRITE(70,*) binhelp,magabsz_largebin_i(i,1),magabsz_largebin_i(i,2),magabsz_largebin_i(i,3)
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_largebinned_z.txt')
DO i=0,50
binhelp=-15.D0-DBLE(i)/5.D0
WRITE(70,*) binhelp,magabsz_largebin_z(i,1),magabsz_largebin_z(i,2),magabsz_largebin_z(i,3)
END DO
 CLOSE (70)





!absmag and z binned numbers

DO i=0,50
DO ii=0,15
magabsz_bin_g(i,ii)=0
magabsz_bin_r(i,ii)=0
magabsz_bin_i(i,ii)=0
magabsz_bin_z(i,ii)=0
END DO
END DO


DO i=1,n

IF (active(i)) THEN
DO ii=0,50
DO iii=0,15
binhelp=-15.D0-DBLE(ii)/5.D0
binhelp2=DBLE(iii)/100.D0

IF ((z_cor(i)>(binhelp2-0.005)).AND.(z_cor(i)<(binhelp2+0.005))) THEN

IF ((magabs_g(i)>(binhelp-0.1D0)).AND.(magabs_g(i)<(binhelp+0.1D0))) THEN
magabsz_bin_g(ii,iii)=magabsz_bin_g(ii,iii)+1
END IF
IF ((magabs_r(i)>(binhelp-0.1D0)).AND.(magabs_r(i)<(binhelp+0.1D0))) THEN
magabsz_bin_r(ii,iii)=magabsz_bin_r(ii,iii)+1
END IF
IF ((magabs_i(i)>(binhelp-0.1D0)).AND.(magabs_i(i)<(binhelp+0.1D0))) THEN
magabsz_bin_i(ii,iii)=magabsz_bin_i(ii,iii)+1
END IF
IF ((magabs_z(i)>(binhelp-0.1D0)).AND.(magabs_z(i)<(binhelp+0.1D0))) THEN
magabsz_bin_z(ii,iii)=magabsz_bin_z(ii,iii)+1
END IF
END IF

END DO
END DO
END IF

END DO






OPEN(70,file='output/magabsz_g_binned.txt')
DO i=0,50
DO ii=0,15
binhelp=-15.D0-DBLE(i)/4.D0
binhelp2=DBLE(ii)/100.D0
WRITE(70,*) binhelp,binhelp2,magabsz_bin_g(i,ii)
END DO
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_r_binned.txt')
DO i=0,50
DO ii=0,15
binhelp=-15.D0-DBLE(i)/4.D0
binhelp2=DBLE(ii)/100.D0
WRITE(70,*) binhelp,binhelp2,magabsz_bin_r(i,ii)
END DO
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_i_binned.txt')
DO i=0,50
DO ii=0,15
binhelp=-15.D0-DBLE(i)/4.D0
binhelp2=DBLE(ii)/100.D0
WRITE(70,*) binhelp,binhelp2,magabsz_bin_i(i,ii)
END DO
END DO
 CLOSE (70)

OPEN(70,file='output/magabsz_z_binned.txt')
DO i=0,50
DO ii=0,15
binhelp=-15.D0-DBLE(i)/4.D0
binhelp2=DBLE(ii)/100.D0
WRITE(70,*) binhelp,binhelp2,magabsz_bin_z(i,ii)
END DO
END DO
 CLOSE (70)


WRITE(*,*) 'output for binned data written'
WRITE(30,*) 'output for binned data written'








V_sum_g=0.D0
V_sum_r=0.D0
V_sum_i=0.D0
V_sum_z=0.D0


DO i=1,n
IF (partpresel(i)) THEN



D_limit=dist_k_g*magabs_g(i)+dist_d_g
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_g*magabs_g(i)+dist_dsat_g
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF


IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_g(i)/TAN(rang_min_g/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! g',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_g(i)=1.D0/V_limit
V_sum_g=V_sum_g+1.D0/V_limit

D_limit=dist_k_r*magabs_r(i)+dist_d_r
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Dmin=dist_k_r*magabs_r(i)+dist_dsat_r
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF






IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_r(i)/TAN(rang_min_r/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! r',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF


V_limit=(D_limit**3)-Vminsat
volume_weight_r(i)=1.D0/V_limit
V_sum_r=V_sum_r+1.D0/V_limit

D_limit=dist_k_i*magabs_i(i)+dist_d_i
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6


t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_i*magabs_i(i)+dist_dsat_i
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_i(i)/TAN(rang_min_i/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! i',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_i(i)=1.D0/V_limit
V_sum_i=V_sum_i+1.D0/V_limit

D_limit=dist_k_z*magabs_z(i)+dist_d_z
D_limit=10.D0**D_limit
D_limit=D_limit/1.D6



t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*D_limit*H0*(q0**2)
t2=t2-4.D0*(light**3)*D_limit*H0*q0+2.D0*(light**3)*D_limit*H0
t2=SQRT(t2)
t3=light*D_limit*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)

IF (z_limit>zmax) THEN
z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
END IF

D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance



Dmin=dist_k_z*magabs_z(i)+dist_dsat_z
Dmin=10.D0**Dmin
Dmin=Dmin/1.D6

t1=(light**2)*q0-(light**2)
t2=(light**4)*(q0**2)-2.D0*(light**4)*q0+(light**4)+2.D0*(light**3)*Dmin*H0*(q0**2)
t2=t2-4.D0*(light**3)*Dmin*H0*q0+2.D0*(light**3)*Dmin*H0
t2=SQRT(t2)
t3=light*Dmin*H0*q0

z_limit=1/(light**2)*(t1+t2+t3)
Dmin=Dmin*((1.D0+z_limit)**(-1.D0))!comoving diameter distance

Vminsat=(Dmin**3)

IF (Vminsat<Vmin) THEN
Vminsat=Vmin
END IF




IF (act_radii_weights.NE.0) THEN

! ,rang_min_r,rang_min_i,rang_min_z,rang_vis_V,rang_dang,

rang_dang=R0_z(i)/TAN(rang_min_z/180.D0*PI/3600.D0)

IF ((2.D0*rang_dang/1.D3)<D_limit) THEN

 z_lower=0.D0
 z_middle=0.4D0
 z_upper=0.8D0
 z_limit=1000.D0
 t1=1.D0

otherlimit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
otherlimit=otherlimit*((1.D0+z_limit)**(-2.D0))
 
do while (t1>1.D-10)
 
 divisor=(SQRT(1.D0+2.D0*q0*z_lower)+1.D0+q0*z_lower)
 otherlimit=light/H0*z_lower*(1.D0+((z_lower*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_lower)**(-2.D0))
 D_lower=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_middle)+1.D0+q0*z_middle)
 otherlimit=light/H0*z_middle*(1.D0+((z_middle*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_middle)**(-2.D0))
 D_middle=otherlimit
 
  divisor=(SQRT(1.D0+2.D0*q0*z_upper)+1.D0+q0*z_upper)
 otherlimit=light/H0*z_upper*(1.D0+((z_upper*(1.D0-q0))/divisor))
 otherlimit=otherlimit*((1.D0+z_upper)**(-2.D0))
 D_upper=otherlimit

otherlimit=rang_dang/1.D3

IF ((otherlimit>D_lower).AND.(otherlimit<D_middle)) THEN
 z_upper=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
IF ((otherlimit>D_middle).AND.(otherlimit<D_upper)) THEN
 z_lower=z_middle
 z_middle=(z_upper+z_lower)/2.D0
ELSE
WRITE(*,*) 'We have got a problem! z',i
END IF
END IF

t1=(z_limit-z_middle)**2.D0

z_limit=z_middle

end do

rang_dco=rang_dang*(1+z_limit)


! 
IF (rang_dco<D_limit) THEN
D_limit=rang_dco
END IF

END IF

END IF

V_limit=(D_limit**3)-Vminsat
volume_weight_z(i)=1.D0/V_limit
V_sum_z=V_sum_z+1.D0/V_limit


END IF
END DO


DO i=1,n
IF (partpresel(i)) THEN
volume_weight_g(i)=volume_weight_g(i)/V_sum_g
volume_weight_r(i)=volume_weight_r(i)/V_sum_r
volume_weight_i(i)=volume_weight_i(i)/V_sum_i
volume_weight_z(i)=volume_weight_z(i)/V_sum_z
END IF
END DO



galactive=0
DO i=1,n
IF (partpresel(i)) THEN
galactive=galactive+1
END IF
END DO



WRITE(*,*) 'analysing the luminosity function for ',galactive,' galaxies'
WRITE(30,*) 'analysing the luminosity function for ',galactive,' galaxies'


!z-binned numbers

DO i=0,50
zbin_numbers(i)=0
END DO

DO i=1,n

DO ii=0,50
binhelp=DBLE(ii)/100.D0
IF ((z_cor(i)>(binhelp-0.005)).AND.(z_cor(i)<(binhelp+0.005))) THEN
IF (partpresel(i)) THEN
zbin_numbers(ii)=zbin_numbers(ii)+1
END IF
END IF
END DO

END DO

OPEN(70,file='output/zbin_numbers.txt')
DO i=0,50
binhelp=DBLE(i)/100.D0
WRITE(70,*) binhelp,zbin_numbers(i)
END DO
 CLOSE (70)





DO i=0,50

binhelp=(DBLE(i)+0.5)/100.D0
divisor=(SQRT(1.D0+2.D0*q0*binhelp)+1.D0+q0*binhelp) !luminosity distance_err
D_limit=light/H0*binhelp*(1.D0+((binhelp*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+binhelp)**(-1.D0))!comoving diameter distance
Vol1=D_limit**3

binhelp=(DBLE(i)-0.5)/100.D0
divisor=(SQRT(1.D0+2.D0*q0*binhelp)+1.D0+q0*binhelp) !luminosity distance_err
D_limit=light/H0*binhelp*(1.D0+((binhelp*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+binhelp)**(-1.D0))!comoving diameter distance
Vol2=D_limit**3

IF (Vol2<0) THEN
Vol2=0.D0
END IF

V_limit=Vol1-Vol2
V_limit=V_limit*(4.D0*PI/3.D0)*(9274.D0/41253.D0) !renormalize to sloan DR8 spectroscopic skycoverage
volbin_numbers(i)=DBLE(zbin_numbers(i))/V_limit

END DO


OPEN(70,file='output/volbin_numbers.txt')
DO i=0,50
binhelp=DBLE(i)/100.D0
WRITE(70,*) binhelp,volbin_numbers(i)
END DO
 CLOSE (70)




DO ii=2,5


mMag(ii)=0.D0
msigma(ii)=0.D0

DO i=1,n
IF (partpresel(i)) THEN


IF (ii==2) THEN
mMag(ii)=mMag(ii)+(magabs_g(i))*volume_weight_g(i)
END IF

IF (ii==3) THEN
mMag(ii)=mMag(ii)+(magabs_r(i))*volume_weight_r(i)
END IF

IF (ii==4) THEN
mMag(ii)=mMag(ii)+(magabs_i(i))*volume_weight_i(i)
END IF

IF (ii==5) THEN
mMag(ii)=mMag(ii)+(magabs_z(i))*volume_weight_z(i)
END IF



END IF
END DO


DO i=1,n
IF (partpresel(i)) THEN


IF (ii==2) THEN
msigma(ii)=msigma(ii)+((magabs_g(i)-(mMag(ii)))**2)*volume_weight_g(i)
END IF

IF (ii==3) THEN
msigma(ii)=msigma(ii)+((magabs_r(i)-(mMag(ii)))**2)*volume_weight_r(i)
END IF

IF (ii==4) THEN
msigma(ii)=msigma(ii)+((magabs_i(i)-(mMag(ii)))**2)*volume_weight_i(i)
END IF

IF (ii==5) THEN
msigma(ii)=msigma(ii)+((magabs_z(i)-(mMag(ii)))**2)*volume_weight_z(i)
END IF



END IF
END DO

msigma(ii)=SQRT(msigma(ii))


END DO


OPEN(70,file='output/absmag_lumfunct.txt')
DO i=2,5
WRITE(70,*) mMag(i),msigma(i)
END DO
 CLOSE (70)


! use simplex algorithm to find minimum


allocate(galdense_run(1:n_simplexstart))
allocate(gsigma_run(1:n_simplexstart))
allocate(gQ_run(1:n_simplexstart))
allocate(delta_m_run(1:n_simplexstart))
allocate(lowfunc(1:n_simplexstart))

n_simplex_dim=4
nsd1=n_simplex_dim+1

allocate(x_simplex(1:n_simplex_dim,1:nsd1))
allocate(paralist(1:50,1:3))
allocate(x_c(1:n_simplex_dim))
allocate(ax_c(1:n_simplex_dim))
allocate(x_h(1:n_simplex_dim))
allocate(x_l(1:n_simplex_dim))
allocate(x_alpha(1:n_simplex_dim))
allocate(x_beta(1:n_simplex_dim))
allocate(x_gamma(1:n_simplex_dim))
allocate(f_sum(1:nsd1))
allocate(x_oldlow(1:n_simplex_dim))




simplex_alpha=1.D0
simplex_beta=0.35D0
simplex_gamma=2.D0
simplex_delta=0.5D0

OPEN(70,file='output/numberdensity_localminima.txt')


DO i=1,50
paralist(i,1)=volbin_numbers(i) !numberdensities
paralist(i,2)=DBLE(i)/100.D0 !redshift 
paralist(i,3)=DBLE(zbin_numbers(i))!number per bin for wights
END DO


DO ee=1,n_simplexstart


!some more or less random values
x_simplex(1,1)=0.001+0.005*RAND()
x_simplex(2,1)=35.D0+10.D0*RAND()
x_simplex(3,1)=0.5D0+RAND()
x_simplex(4,1)=0.5D0+RAND()

x_simplex(1,2)=0.001+0.005*RAND()
x_simplex(2,2)=35.D0+10.D0*RAND()
x_simplex(3,2)=0.5D0+RAND()
x_simplex(4,2)=0.5D0+RAND()

x_simplex(1,3)=0.001+0.005*RAND()
x_simplex(2,3)=35.D0+10.D0*RAND()
x_simplex(3,3)=0.5D0+RAND()
x_simplex(4,3)=0.5D0+RAND()

x_simplex(1,4)=0.001+0.005*RAND()
x_simplex(2,4)=35.D0+10.D0*RAND()
x_simplex(3,4)=0.5D0+RAND()
x_simplex(4,4)=0.5D0+RAND()

x_simplex(1,5)=0.001+0.005*RAND()
x_simplex(2,5)=35.D0+10.D0*RAND()
x_simplex(3,5)=0.5D0+RAND()
x_simplex(4,5)=0.5D0+RAND()

ax_c(1)=1000
ax_c(2)=1000
ax_c(3)=1000
ax_c(4)=1000




DO ii=1,nsd1
! safety condition ==> density cannot be negative
IF (x_simplex(1,ii)<0.D0) THEN
x_simplex(1,ii)=-x_simplex(1,ii)
END IF
! safety condition ==> standard deviasion cannot be negative
 IF (x_simplex(3,ii)<0.D0) THEN
 x_simplex(3,ii)=-x_simplex(3,ii)
 END IF

!  IF (x_simplex(4,ii)<0.D0) THEN
!  x_simplex(4,ii)=-x_simplex(4,ii)
!  END IF




f_sum(ii)=0.D0
DO i=1,50

divisor=(SQRT(1.D0+2.D0*q0*paralist(i,2))+1.D0+q0*paralist(i,2))
!luminosity distance
D_help=light/H0*paralist(i,2)*(1.D0+((paralist(i,2)*(1.D0-q0))/divisor))
D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
upterm=ERF((x_simplex(2,ii)+paralist(i,2)*x_simplex(4,ii)+D_help)/(x_simplex(3,ii)*SQRT(2.D0)))
!upterm=ERF((x_simplex(2,ii)+D_help)/(av_sigma4*SQRT(2.D0)))
f_simplex_help=(x_simplex(1,ii)/2.D0*(1.D0+upterm))-paralist(i,1)
!-av_Q4*paralist(i,2)
f_sum(ii)=f_sum(ii)+((f_simplex_help)**2)!*SQRT(paralist(i,3))

END DO


IF (f_sum(ii)>=veryhugenumber) THEN
f_sum(ii)=veryhugenumber
END IF
IF (f_sum(ii)<=-veryhugenumber) THEN
f_sum(ii)=veryhugenumber
END IF


END DO


DO i=1,n_simplex_dim
x_oldlow(i)=0.D0
END DO


itercount=0
 continueloop=.TRUE.
DO WHILE (continueloop)


highest=1
second=1
lowest=1

DO ii=2,nsd1
IF ((f_sum(highest))<(f_sum(ii))) THEN
highest=ii
END IF
END DO

DO ii=2,nsd1
IF ((f_sum(second))<(f_sum(ii))) THEN
IF (ii.NE.highest) THEN
second=ii
END IF
END IF
END DO

DO ii=2,nsd1
IF ((f_sum(lowest))>(f_sum(ii))) THEN
lowest=ii
END IF
END DO

f_h=f_sum(highest)
f_s=f_sum(second)
f_l=f_sum(lowest)



DO i=1,n_simplex_dim
x_h(i)=x_simplex(i,highest)
END DO

DO i=1,n_simplex_dim
x_l(i)=x_simplex(i,lowest)
END DO

DO i=1,n_simplex_dim
 x_c(i)=0.D0
END DO

! real center of mass
DO i=1,n_simplex_dim
DO ii=1,nsd1
  x_c(i)=x_c(i)+x_simplex(i,ii)
END DO
  x_c(i)=x_c(i)/DBLE(nsd1)
END DO


itercount=itercount+1
!WRITE(*,*) itercount
 com_change=0.D0
 DO i=1,n_simplex_dim
 com_change=(x_c(i)-ax_c(i))**2
 END DO

 continueloop=.FALSE.

IF (com_change>0.01) THEN
 continueloop=.TRUE.
END IF


 com_change=0.D0
 DO ii=1,nsd1
 DO i=1,n_simplex_dim
 com_change=(x_simplex(i,ii)-x_c(i))**2
 END DO
 END DO

IF (com_change>0.01) THEN
 continueloop=.TRUE.
END IF

 DO i=1,n_simplex_dim
 IF (((x_c(i)-ax_c(i))**2)>1.D-2) THEN
 continueloop=.TRUE.
END IF
 END DO

DO i=1,n_simplex_dim
IF (((x_oldlow(i)-x_l(i))**2)>1.D-6) THEN
 continueloop=.TRUE.
END IF
END DO


DO i=1,n_simplex_dim
IF (((x_h(i)-x_l(i))**2)>1.D-2) THEN
 continueloop=.TRUE.
END IF
END DO



IF (itercount>100) THEN
 continueloop=.FALSE.
END IF

! output variables


galdense_run(ee)=x_l(1)
delta_m_run(ee)=x_l(2)
gsigma_run(ee)=x_l(3)
gQ_run(ee)=x_l(4)


lowfunc(ee)=f_l

DO i=1,n_simplex_dim
 ax_c(i)=x_c(i)
END DO

DO i=1,n_simplex_dim
x_oldlow(i)=x_l(i)
END DO

! center of mass for simplex
DO i=1,n_simplex_dim
 x_c(i)=0.D0
DO ii=1,nsd1
IF (ii.NE.highest) THEN
  x_c(i)=x_c(i)+x_simplex(i,ii)
END IF
END DO
  x_c(i)=x_c(i)/DBLE(n_simplex_dim)
END DO


IF (continueloop) THEN




DO i=1,n_simplex_dim
x_alpha(i)=(1.D0+simplex_alpha)*x_c(i)-simplex_alpha*x_h(i)
END DO



! safety condition ==> density cannot be negative
IF (x_alpha(1)<0.D0) THEN
x_alpha(1)=-x_alpha(1)
END IF


 IF (x_alpha(3)<0.D0) THEN
 x_alpha(3)=-x_alpha(3)
 END IF

 IF (x_alpha(4)<0.D0) THEN
 x_alpha(4)=-x_alpha(4)
 END IF


f_alpha=0.D0
DO i=1,50

divisor=(SQRT(1.D0+2.D0*q0*paralist(i,2))+1.D0+q0*paralist(i,2))
!luminosity distance
D_help=light/H0*paralist(i,2)*(1.D0+((paralist(i,2)*(1.D0-q0))/divisor))
D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
! upterm=ERF((x_alpha(2)+D_help)/(av_sigma4*SQRT(2.D0)))
upterm=ERF((x_alpha(2)+paralist(i,2)*x_alpha(4)+D_help)/(x_alpha(3)*SQRT(2.D0)))
f_simplex_help=(x_alpha(1)/2.D0*(1.D0+upterm))-paralist(i,1)

f_alpha=f_alpha+((f_simplex_help)**2)!*SQRT(paralist(i,3))

END DO


IF (f_alpha>=veryhugenumber) THEN
f_alpha=veryhugenumber
END IF
IF (f_alpha<=-veryhugenumber) THEN
f_alpha=veryhugenumber
END IF


IF (f_alpha<f_l) THEN

DO i=1,n_simplex_dim
x_gamma(i)=(1.D0-simplex_gamma)*x_c(i)+simplex_gamma*x_alpha(i)
END DO

! safety condition ==> density cannot be negative
IF (x_gamma(1)<0.D0) THEN
x_gamma(1)=-x_gamma(1)
END IF


 IF (x_gamma(3)<0.D0) THEN
 x_gamma(3)=-x_gamma(3)
 END IF

 IF (x_gamma(4)<0.D0) THEN
 x_gamma(4)=-x_gamma(4)
 END IF



f_gamma=0.D0
DO i=1,50

divisor=(SQRT(1.D0+2.D0*q0*paralist(i,2))+1.D0+q0*paralist(i,2))
!luminosity distance
D_help=light/H0*paralist(i,2)*(1.D0+((paralist(i,2)*(1.D0-q0))/divisor))
D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
! upterm=ERF((x_gamma(2)+D_help)/(av_sigma4*SQRT(2.D0)))
upterm=ERF((x_gamma(2)+paralist(i,2)*x_gamma(4)+D_help)/(x_gamma(3)*SQRT(2.D0)))
f_simplex_help=(x_gamma(1)/2.D0*(1.D0+upterm))-paralist(i,1)


f_gamma=f_gamma+((f_simplex_help)**2)!*SQRT(paralist(i,3))

END DO


IF (f_gamma>=veryhugenumber) THEN
f_gamma=veryhugenumber
END IF
IF (f_gamma<=-veryhugenumber) THEN
f_gamma=veryhugenumber
END IF


IF (f_gamma<f_alpha) THEN

! S^k+1=gamma(alpha(S^k))
!WRITE(*,*) 'gamma'
DO i=1,n_simplex_dim
x_simplex(i,highest)=x_gamma(i)
END DO
f_sum(highest)=f_gamma


ELSE

!WRITE(*,*) 'alpha1'
! S^k+1=alpha(S^k)
DO i=1,n_simplex_dim
x_simplex(i,highest)=x_alpha(i)
END DO
f_sum(highest)=f_alpha

END IF


ELSE

IF (f_alpha<f_s) THEN

! S^k+1=alpha(S^k)
!WRITE(*,*) 'alpha2'
DO i=1,n_simplex_dim
x_simplex(i,highest)=x_alpha(i)
END DO
f_sum(highest)=f_alpha


ELSE


IF (f_alpha>f_h) THEN
DO i=1,n_simplex_dim
x_beta(i)=(1.D0-simplex_beta)*x_c(i)+simplex_beta*x_h(i)
END DO
ELSE
DO i=1,n_simplex_dim
x_beta(i)=(1.D0-simplex_beta)*x_c(i)+simplex_beta*x_alpha(i)
END DO
END IF

! safety condition ==> density cannot be negative
IF (x_beta(1)<0.D0) THEN
x_beta(1)=-x_beta(1)
END IF

 IF (x_beta(3)<0.D0) THEN
 x_beta(3)=-x_beta(3)
 END IF

 IF (x_beta(4)<0.D0) THEN
 x_beta(4)=-x_beta(4)
 END IF

f_beta=0.D0
DO i=1,50

divisor=(SQRT(1.D0+2.D0*q0*paralist(i,2))+1.D0+q0*paralist(i,2))
!luminosity distance
D_help=light/H0*paralist(i,2)*(1.D0+((paralist(i,2)*(1.D0-q0))/divisor))
D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
! upterm=ERF((x_beta(2)+D_help)/(av_sigma4*SQRT(2.D0)))
upterm=ERF((x_beta(2)+paralist(i,2)*x_beta(4)+D_help)/(x_beta(3)*SQRT(2.D0)))
f_simplex_help=(x_beta(1)/2.D0*(1.D0+upterm))-paralist(i,1)


f_beta=f_beta+((f_simplex_help)**2)!*SQRT(paralist(i,3))

END DO


IF (f_beta>=veryhugenumber) THEN
f_beta=veryhugenumber
END IF
IF (f_beta<=-veryhugenumber) THEN
f_beta=veryhugenumber
END IF



IF (f_beta>f_h) THEN

!WRITE(*,*) 'delta'
! S^k+1=delta(S^k)

DO ii=1,nsd1
IF (ii.NE.lowest) THEN
DO i=1,n_simplex_dim
x_simplex(i,ii)=x_l(i)+simplex_delta*(x_simplex(i,ii)-x_l(i))
END DO

END IF
END DO

DO ii=1,nsd1
! safety condition ==> density cannot be negative
IF (x_simplex(1,ii)<0.D0) THEN
x_simplex(1,ii)=-x_simplex(1,ii)
END IF

 IF (x_simplex(3,ii)<0.D0) THEN
 x_simplex(3,ii)=-x_simplex(3,ii)
 END IF

 IF (x_simplex(4,ii)<0.D0) THEN
 x_simplex(4,ii)=-x_simplex(4,ii)
 END IF



END DO



DO ii=1,nsd1

IF (ii.NE.lowest) THEN
f_sum(ii)=0.D0
DO i=1,50

divisor=(SQRT(1.D0+2.D0*q0*paralist(i,2))+1.D0+q0*paralist(i,2))
!luminosity distance
D_help=light/H0*paralist(i,2)*(1.D0+((paralist(i,2)*(1.D0-q0))/divisor))
D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
! upterm=ERF((x_simplex(2,ii)+D_help)/(av_sigma4*SQRT(2.D0)))
upterm=ERF((x_simplex(2,ii)+paralist(i,2)*x_simplex(4,ii)+D_help)/(x_simplex(3,ii)*SQRT(2.D0)))
f_simplex_help=(x_simplex(1,ii)/2.D0*(1.D0+upterm))-paralist(i,1)

f_sum(ii)=f_sum(ii)+((f_simplex_help)**2)!*SQRT(paralist(i,3))

END DO


IF (f_sum(ii)>=veryhugenumber) THEN
f_sum(ii)=veryhugenumber
END IF
IF (f_sum(ii)<=-veryhugenumber) THEN
f_sum(ii)=veryhugenumber
END IF


END IF
END DO






ELSE


! S^k+1=beta(S^k)
!WRITE(*,*) 'beta'
DO i=1,n_simplex_dim
x_simplex(i,highest)=x_beta(i)
END DO
f_sum(highest)=f_beta



END IF


END IF
END IF



END IF
END DO


END DO


DO ee=1,n_simplexstart
WRITE(70,*) lowfunc(ee)
WRITE(70,*) galdense_run(ee),delta_m_run(ee),gsigma_run(ee),gQ_run(ee)
END DO

hcount=1
DO ee=2,n_simplexstart
IF (lowfunc(ee)<lowfunc(hcount)) THEN
hcount=ee
END IF
END DO

WRITE(70,*) hcount
WRITE(70,*) '----------------------------------------------'
galdense=galdense_run(hcount)
delta_m=delta_m_run(hcount)
gsigma=gsigma_run(hcount)
gQ=gQ_run(hcount)
bestmin=lowfunc(hcount)

 CLOSE(70)

deallocate(x_simplex)
deallocate(paralist)
deallocate(x_c)
deallocate(ax_c)
deallocate(x_h)
deallocate(x_l)
deallocate(x_alpha)
deallocate(x_beta)
deallocate(x_gamma)
deallocate(f_sum)
deallocate(x_oldlow)

deallocate(galdense_run)
deallocate(delta_m_run)
deallocate(gsigma_run)


! 
! 
!  ck_inverf(0)=1.D0
!  ck_inverf(1)=1.D0
! DO i=2,20
!  ck_inverf(i)=0.D0
! DO ii=0,(i-1)
!   ck_inverf(i)=ck_inverf(i)+(ck_inverf(ii)*ck_inverf(i-1-ii)/((DBLE(ii)+1.D0)*(2.D0*DBLE(ii)+1.D0)))
! END DO
! END DO
! 
! 
! 
! DO i=1,50
! yh(i)=2.D0*volbin_numbers(i)/galdense-1.D0
! END DO
! 
! 
! DO i=6,30
! erf1y(i)=0.D0
! DO ii=0,20
! erf1y(i)=erf1y(i)+ck_inverf(ii)/(2.D0*DBLE(ii)+1.D0)*((yh(i)*SQRT(PI)/2.D0)**(2*ii+1))
! END DO
! 
! ev_z(i)=DBLE(i)/100.D0
! divisor=(SQRT(1.D0+2.D0*q0*ev_z(i))+1.D0+q0*ev_z(i))
! D_help=light/H0*ev_z(i)*(1.D0+((ev_z(i)*(1.D0-q0))/divisor))
! logDL(i)=-5.D0*LOG10(D_help*1.D6)+5.D0
! 
! END DO
! 
! 
! 
! 
! 
! DO i=1,3
! DO ii=1,3
!  colour_matrix(i,ii)=0.D0
! END DO
!  colour_vector(i)=0.D0
! END DO
! 
! DO i=6,30
! 
! 
! 
!  colour_matrix(1,1)=colour_matrix(1,1)+ev_z(i)*ev_z(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(1,2)=colour_matrix(1,2)+ev_z(i)*logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(2,1)=colour_matrix(2,1)+ev_z(i)*logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(2,2)=colour_matrix(2,2)+logDL(i)*logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(3,1)=colour_matrix(3,1)+ev_z(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(1,3)=colour_matrix(1,3)+ev_z(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(3,2)=colour_matrix(3,2)+logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(2,3)=colour_matrix(2,3)+logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_matrix(3,3)=colour_matrix(3,3)+1.D0!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
! 
!  colour_vector(1)=colour_vector(1)+erf1y(i)*ev_z(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_vector(2)=colour_vector(2)+erf1y(i)*logDL(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
!  colour_vector(3)=colour_vector(3)+erf1y(i)!*DBLE(zbin_numbers(i))/DBLE(galactive)*50.D0
! 
! END DO
! 
! det_cMatrix=colour_matrix(1,1)*colour_matrix(2,2)*colour_matrix(3,3)
! det_cMatrix=det_cMatrix+colour_matrix(2,1)*colour_matrix(3,2)*colour_matrix(1,3)
! det_cMatrix=det_cMatrix+colour_matrix(1,2)*colour_matrix(2,3)*colour_matrix(3,1)
! det_cMatrix=det_cMatrix-colour_matrix(1,3)*colour_matrix(2,2)*colour_matrix(3,1)
! det_cMatrix=det_cMatrix-colour_matrix(2,1)*colour_matrix(1,2)*colour_matrix(3,3)
! det_cMatrix=det_cMatrix-colour_matrix(2,3)*colour_matrix(3,2)*colour_matrix(1,1)
! 
! 
! DO i=1,3
! DO ii=1,3
!  help_matrix_1(i,ii)=colour_matrix(i,ii)
!  help_matrix_2(i,ii)=colour_matrix(i,ii)
!  help_matrix_3(i,ii)=colour_matrix(i,ii)
! END DO
! END DO
! 
! DO i=1,3
!  help_matrix_1(1,i)=colour_vector(i)
!  help_matrix_2(2,i)=colour_vector(i)
!  help_matrix_3(3,i)=colour_vector(i)
! END DO
! 
! det_helpMatrix1=help_matrix_1(1,1)*help_matrix_1(2,2)*help_matrix_1(3,3)
! det_helpMatrix1=det_helpMatrix1+help_matrix_1(2,1)*help_matrix_1(3,2)*help_matrix_1(1,3)
! det_helpMatrix1=det_helpMatrix1+help_matrix_1(1,2)*help_matrix_1(2,3)*help_matrix_1(3,1)
! det_helpMatrix1=det_helpMatrix1-help_matrix_1(1,3)*help_matrix_1(2,2)*help_matrix_1(3,1)
! det_helpMatrix1=det_helpMatrix1-help_matrix_1(2,1)*help_matrix_1(1,2)*help_matrix_1(3,3)
! det_helpMatrix1=det_helpMatrix1-help_matrix_1(2,3)*help_matrix_1(3,2)*help_matrix_1(1,1)
! 
! det_helpMatrix2=help_matrix_2(1,1)*help_matrix_2(2,2)*help_matrix_2(3,3)
! det_helpMatrix2=det_helpMatrix2+help_matrix_2(2,1)*help_matrix_2(3,2)*help_matrix_2(1,3)
! det_helpMatrix2=det_helpMatrix2+help_matrix_2(1,2)*help_matrix_2(2,3)*help_matrix_2(3,1)
! det_helpMatrix2=det_helpMatrix2-help_matrix_2(1,3)*help_matrix_2(2,2)*help_matrix_2(3,1)
! det_helpMatrix2=det_helpMatrix2-help_matrix_2(2,1)*help_matrix_2(1,2)*help_matrix_2(3,3)
! det_helpMatrix2=det_helpMatrix2-help_matrix_2(2,3)*help_matrix_2(3,2)*help_matrix_2(1,1)
! 
! det_helpMatrix3=help_matrix_3(1,1)*help_matrix_3(2,2)*help_matrix_3(3,3)
! det_helpMatrix3=det_helpMatrix3+help_matrix_3(2,1)*help_matrix_3(3,2)*help_matrix_3(1,3)
! det_helpMatrix3=det_helpMatrix3+help_matrix_3(1,2)*help_matrix_3(2,3)*help_matrix_3(3,1)
! det_helpMatrix3=det_helpMatrix3-help_matrix_3(1,3)*help_matrix_3(2,2)*help_matrix_3(3,1)
! det_helpMatrix3=det_helpMatrix3-help_matrix_3(2,1)*help_matrix_3(1,2)*help_matrix_3(3,3)
! det_helpMatrix3=det_helpMatrix3-help_matrix_3(2,3)*help_matrix_3(3,2)*help_matrix_3(1,1)
! 
! 
! 
!  colour_coeff1=det_helpMatrix1/det_cMatrix
!  colour_coeff2=det_helpMatrix2/det_cMatrix
!  colour_coeff3=det_helpMatrix3/det_cMatrix
! 
! gsigma=1.D0/(SQRT(2.D0)*colour_coeff2)
! delta_m=colour_coeff3/colour_coeff2
! gQ=colour_coeff1/colour_coeff2
! 


OPEN(70,file='output/numdense_fit.txt')
WRITE(70,*) galdense,delta_m,gsigma,gQ
 CLOSE(70)

OPEN(70,file='output/numdense_fit_data.txt')
WRITE(70,*) "dense=",galdense
WRITE(70,*) "deltam=",delta_m
! WRITE(70,*) "gsigma=",av_sigma4
WRITE(70,*) "gsigma=",gsigma
WRITE(70,*) "Qterm=",gQ
upterm=SQRT(PI/2.D0)
WRITE(70,*) "sp2=",upterm
upterm=SQRT(2.D0)
WRITE(70,*) "sq2=",upterm
WRITE(70,*) "light=",light
WRITE(70,*) "H0=",H0
WRITE(70,*) "q0=",q0
 CLOSE(70)





WRITE(*,*) 'output for z-binned numberdensities written'
WRITE(30,*) 'output for z-binned numberdensities written'





overdense(0)=volbin_numbers(0)-galdense
overdense(0)=overdense(0)/galdense*100.D0
DO i=1,50
binhelp=DBLE(i)/100.D0
divisor=(SQRT(1.D0+2.D0*q0*binhelp)+1.D0+q0*binhelp)
!luminosity distance
D_help=light/H0*binhelp*(1.D0+((binhelp*(1.D0-q0))/divisor))
! WRITE(*,*) binhelp
! WRITE(*,*) D_help

D_help=-5.D0*LOG10(D_help*1.D6)+5.D0
! WRITE(*,*) D_help
! WRITE(*,*) 
! upterm=ERF((delta_m+D_help)/(av_sigma4*SQRT(2.D0)))
upterm=ERF((delta_m+binhelp*gQ+D_help)/(gsigma*SQRT(2.D0)))
f_simplex_help=(galdense/2.D0*(1.D0+upterm))

overdense(i)=volbin_numbers(i)-f_simplex_help
overdense(i)=overdense(i)/f_simplex_help*100.D0

END DO




OPEN(70,file='output/overdense.txt')
DO i=0,50
binhelp=DBLE(i)/100.D0
WRITE(70,*) binhelp,overdense(i)
END DO
 CLOSE(70)











z_limit=zmax
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
!luminosity distance
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance
V_limit=D_limit**3
helpflip=V_limit
!
z_limit=zmin
divisor=(SQRT(1.D0+2.D0*q0*z_limit)+1.D0+q0*z_limit)
!luminosity distance
D_limit=light/H0*z_limit*(1.D0+((z_limit*(1.D0-q0))/divisor))
D_limit=D_limit*((1.D0+z_limit)**(-1.D0))!comoving diameter distance
V_limit=D_limit**3

helpflip=helpflip-V_limit
helpflip=galdense*helpflip

OPEN(70,file='output/absmag_lumfunct_plot.txt')
WRITE(70,*) 'ncount=',helpflip
WRITE(70,*) 'magg=',mMag(2)
WRITE(70,*) 'magr=',mMag(3)
WRITE(70,*) 'magi=',mMag(4)
WRITE(70,*) 'magz=',mMag(5)
WRITE(70,*) 'smagg=',msigma(2)
WRITE(70,*) 'smagr=',msigma(3)
WRITE(70,*) 'smagi=',msigma(4)
WRITE(70,*) 'smagz=',msigma(5)
 CLOSE (70)





WRITE(*,*) '-----program finished-----'
WRITE(30,*) '-----program finished-----'
CLOSE(30)

END PROGRAM 
